// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.15 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # BRAllg.js	- allg. wiederverwendbarer Funktionalitt
// # ============================================================================

function	InitFocus(strFocusVarId)
{
	if (strFocusVarId != "")	{
		strFocus = document.getElementById(strFocusVarId).value;
		if (strFocus != "")	{
			var objFocus = document.getElementById(strFocus);
			if (objFocus != null)
				objFocus.focus();
		}
	}
}

function	SaveFocus(objCtrl, strFocusVarId)
{
	if (objCtrl != null && strFocusVarId != "")
		document.getElementById(strFocusVarId).value = objCtrl.id;
}

function	ShowTable(strTabID, bShow)
{
	var objTab	= document.getElementById(strTabID);
	var strShow = (bShow == true) ? "visible" : "hidden";
	if (objTab != null)		{
		objTab.style.visibility = strShow;
		var objFixedLine = document.getElementById(strTabID + "_FL");
		if (objFixedLine != null)
			objFixedLine.style.visibility = strShow;
		var objFixedCol = document.getElementById(strTabID + "_FC");
		if (objFixedCol != null)
			objFixedCol.style.visibility = strShow;
		var objFixedTab = document.getElementById(strTabID + "_AF");
		if (objFixedTab != null)
			objFixedTab.style.visibility = strShow;
	}
}

function	ShowTableFixedElements(strTabID)
{
	var objTab	= document.getElementById(strTabID);
	if (objTab != null)		{
		var strShow = objTab.style.visibility;
		var objFixedLine = document.getElementById(strTabID + "_FL");
		if (objFixedLine != null)
			objFixedLine.style.visibility = strShow;
		var objFixedCol = document.getElementById(strTabID + "_FC");
		if (objFixedCol != null)
			objFixedCol.style.visibility = strShow;
		var objFixedTab = document.getElementById(strTabID + "_AF");
		if (objFixedTab != null)
			objFixedTab.style.visibility = strShow;
	}
}

function    hiliteNavigation()
{
    var objPfeilTD;
    var objTextTD;
    switch (dialog.id)  {
    case "IDD_AUSWAHL":
    case "IDD_LFAUSWAHL":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_01");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_02");
        break;
    case "IDD_KOORDINATENSYS":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_03");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_04");
        break;
    case "IDD_AUSMASSE":
    case "IDD_KGTAUSMASSE":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_05");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_08");
        break;
    case "IDD_KGTWINKEL":
    case "IDD_WINKEL":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_09");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_06");
        break;
    case "IDD_DYNAUSWAHL":        
    case "IDD_DYNZYKLUS":
    case "IDD_DYNZEITANTEILE":
    case "IDD_DYNSTRECKEN":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_07");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_10");
        break;
    case "IDD_MASSENDYNZYKLUS":        
    case "IDD_MASSENDYNZEITANTEILE":
    case "IDD_MASSENDYNSTRECKEN":
    case "IDD_KGTMASSENDYNZYKLUS":
    case "IDD_KGTMASSENDYNZEITANTEILE":
    case "IDD_KGTMASSENDYNSTRECKEN":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL2_09");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_12");
        break;
    case "IDD_KRAEFTEDYNZYKLUS":
    case "IDD_KRAEFTEDYNZEITANTEILE":
    case "IDD_KRAEFTEDYNSTRECKEN":
    case "IDD_KGTKRAEFTEDYNZYKLUS":
    case "IDD_KGTKRAEFTEDYNZEITANTEILE":
    case "IDD_KGTKRAEFTEDYNSTRECKEN":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_13");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_14");
        break;
    case "IDD_HINWEISE":
    case "IDD_KGTHINWEISE":
    case "IDD_LFHINWEISE":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_15");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_16");
        break;
    case "IDD_DATEN":
    case "IDD_KGTDATEN":
    case "IDD_LFDATEN":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_17");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_18");
        break;
    case "IDD_VERLAGERUNGEN":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_19");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_20");
        break;
    case "IDD_PROJECTLIST":
        objPfeilTD  = document.getElementById("IDC_TABLE02_BUT_COL1_21");
        objTextTD   = document.getElementById("IDC_TABLE02_BUT_COL1_22");
        break;
    }
    
    objPfeilTD.className = "TABLE_BACKGROUND_RIGHT_HL";
    objTextTD.className = "BUTTON_TEXT_HL";
}