
// -pf- XMLHTTP Request Funktionen

// Return a XMLHTTPRequest in a browser independent fashion.
if(typeof GetXMLHttp == 'undefined') {
	GetXMLHttp = function ()
	{
	    var xmlhttp=false;
	    
	    try 
	    {
	        xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	    } 
	    catch (e) 
	    {
	        try 
	        {
	            xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	        }
	        catch (E)
	        {
	            xmlhttp = false;
	        }
	    }
	
	    // Mozilla then?
	    if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	       xmlhttp = new XMLHttpRequest();
	    }
	    
	    return xmlhttp;
	}
}


if(typeof getHost == 'undefined') {
	getHost = function()
	{
		if(self.location.host)
		{
			if(self.location.host.indexOf(":")<0 && isycat.port.value!="")
				return "http://"+self.location.host+":"+isycat.port.value;
			else
				return "http://"+self.location.host;
		}
		else
		{
			/*
			if (isycat.port.value == "")	{
				isycat.port.value =$(PORT).value;
				alert(isycat.port.value);
			}
			*/
			// return "http://localhost:8089";//+isycat.port.value;
			return "http://localhost:" + isycat.port.value;
		}
	}
}


if(typeof docEl == 'undefined') {
	docEl = function(id)
	{
		return id ? document.getElementById(id) : false;
	}
}




function hexnib(d) {
   if(d<10) return d; else return String.fromCharCode(65+d-10);
}

function hexbyte(d) {
        // return "%"+hexnib((d&240)>>4)+""+hexnib(d&15);
	return hexnib((d&240)>>4)+""+hexnib(d&15);
}

function ekEncode(inStr)
{
    var result="";
    var hex="";
     for(var i=0;i<inStr.length; i++) {
             var cc=inStr.charCodeAt(i);
             if (cc<128) {
                 result+=hexbyte(cc);
             } else if((cc>127) && (cc<2048)) {
                result+=  hexbyte((cc>>6)|192)
                        + hexbyte((cc&63)|128);
             } else {
                result+=  hexbyte((cc>>12)|224)
                        + hexbyte(((cc>>6)&63)|128)
                        + hexbyte((cc&63)|128);
             }
     }
    return result;
}


function getEKSubmitValuesUtf8()
{
	var nElements=document.isycat.length;
	var obj,id;
	
	var specialSubmitValues="";
	
	for(var i=0;i<nElements;i++)
	{
		obj=document.isycat[i];
		
		if(!obj.type)
		{
			continue;
		}
		
		if(!obj.id)
		{
			if(!obj.name)
			{
				continue;
			}
			else
			{
				id=obj.name;
			}
		}
		else
		{
			id=obj.id
		}
		
		id = id.trimright("_EK_WIDGET_VALUE");

		if(obj.type=="text" || obj.type=="hidden" || obj.type=="textarea" || obj.type=="password")
		{
			specialSubmitValues+=ekEncode(id)+"="+ekEncode(obj.value)+"&";
		    // alert(id + " type = "  +obj.type );
		}
		else if(obj.type=="checkbox")
		{
			if (obj.checked)
			{
				specialSubmitValues+=ekEncode(id)+"="+ekEncode("true")+"&";
			}
			else
			{
				specialSubmitValues+=ekEncode(id)+"="+ekEncode("false")+"&";
			}
		    // alert(id + " type = "  +obj.type );
		}
		else if(obj.type == "radio")
		{
			if (obj.checked)
			{
				specialSubmitValues+=ekEncode(obj.name)+"="+ekEncode(obj.value)+"&";
		        // alert(id + " type = "  +obj.type );
			}
		}
		else if(obj.type=="select-one")
		{
			if(obj.selectedIndex>=0)
				specialSubmitValues+=ekEncode(id)+"="+ekEncode(obj[obj.selectedIndex].value)+"&";
			else
				specialSubmitValues+=ekEncode(id)+"=&";
		    // alert(id + " type = "  +obj.type );
		}
		else if (obj.type=="select-multiple")
		{
			var selectedItems="";
			for (var j=0; j < obj.length;j++)
			{
				if(obj.options[j].selected)
				{
					selectedItems+=obj.options[j].value+"|";
				}
			}
			
			if(selectedItems!="")
				selectedItems=selectedItems.substring(0,selectedItems.length-1);
				
			specialSubmitValues+=ekEncode(id)+"="+ekEncode(selectedItems)+"&";
		    // alert(id + " type = "  +obj.type );
		}
		else if(obj.type=="button")
		{
			; // nix
		}
		else
		{
			// alert(obj.type);
		}
		
	}
	return specialSubmitValues;
}

function getEKSubmitValueUtf8(element)
{
	var specialSubmitValues = "";
	if (element == null)
		return specialSubmitValues;

	var obj,id;
	if (typeof(element) == "string") {
    	id = element;
		obj = document.isycat[id];
    } else {
    	obj = element;
		id	= obj.id ? obj.id : obj.name;
    }
    

	if (obj == null || !obj.type || !id)
		return specialSubmitValues;
		
	switch (obj.type)	{
	case "text":
	case "hidden":
	case "textarea":
	case "password":
		specialSubmitValues+=ekEncode(id)+"="+ekEncode(obj.value)+"&";
		break;
	case "checkbox":
		specialSubmitValues += obj.checked ? ekEncode(id)+"="+ekEncode("true")+"&" : ekEncode(id)+"="+ekEncode("false")+"&";
		break;
	case "radio":
		if (obj.checked)
			specialSubmitValues+=ekEncode(obj.name)+"="+ekEncode(obj.value)+"&";
		break;
	case "select-one":
		if(obj.selectedIndex>=0)
			specialSubmitValues+=ekEncode(id)+"="+ekEncode(obj[obj.selectedIndex].value)+"&";
		else
			specialSubmitValues+=ekEncode(id)+"=&";
		break;
	case "select-multiple":
		var selectedItems="";
		for (var j=0; j < obj.length;j++)	{
			if(obj.options[j].selected)	{
				selectedItems+=obj.options[j].value+"|";
			}
		}
		if(selectedItems!="")
			selectedItems=selectedItems.substring(0,selectedItems.length-1);
			
		specialSubmitValues+=ekEncode(id)+"="+ekEncode(selectedItems)+"&";
		break;
	case "button":
		break;
	}

	return specialSubmitValues;
}

function hexSubmit(element)
{
	if (typeof(element) == "string")
		document.isycat.EKSUBMITEVENT.value = element;
	else
		document.isycat.EKSUBMITEVENT.value = element.getAttribute('id');

	var oFragment = document.createDocumentFragment();
	var oSubForm = document.createElement('form');
	var oPort = document.createElement('input');
	var oData = document.createElement('input');

	oFragment.appendChild(oSubForm);
	oSubForm.appendChild(oPort);
	oSubForm.appendChild(oData);
	oSubForm.name 	= 'isycat_submit';
	oSubForm.method = 'post';
	oSubForm.action = document.isycat.action;
	oSubForm.target	= document.isycat.target;
	
	oPort.id='port';
	oPort.style.visibility='hidden';
	oPort.nodeValue=isycat.port.value;
	oData.id='__eksubmit_values_utf8__';
	oData.style.visibility='hidden';
	oData.nodeValue=getEKSubmitValuesUtf8();

	document.body.appendChild(oSubForm);
	oSubForm.submit();
	document.body.removeChild(oSubForm);
	document.isycat.target = '_self';
	return false;
}


function addPostParam(sParams, sParamName, sParamValue)
{
	if (sParams.length > 0) {
		sParams += "&";
	}
	return sParams + encodeURIComponent(sParamName) + "=" + encodeURIComponent(sParamValue);
}



function updateDialogElement(sDlgId, eventId, asyncRequest, elementIds)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
    var sURL=getHost() + "/ajax/update_dialog_elements?sessionid="+sessionid+"&stateid="+stateid+
    					 "&dialogid="+sDlgId+"&eventid="+eventId+"&elementids="+elementIds;

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	
	
	if( asyncRequest )
	{	// async. request
		oRequest.open("post", sTarget, true);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.onreadystatechange = function ()
		{
		    if ( oRequest.readyState==4 && oRequest.status==200 )
		    {
				//alert(oRequest.responseText); return;
				docEl("stateid").value=stateid;
				updateDialogElementExec( oRequest.responseText );
		    }
		}
		oRequest.send(sParams);
	}
	else
	{
		// synchroner post request
		// alert(sParams);
		oRequest.open("post", sTarget, false);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.send(sParams);
		if( oRequest.status==200 )
		{
			// alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
	}
}

function	addSubmitPar(strSubmitValues, id, value, bAddAmp)
{
	strSubmitValues += ekEncode(id)+"="+ekEncode(value);
	if (bAddAmp)
		strSubmitValues += "&";
	return strSubmitValues;
}
// Event Notification an Server schicken (zB: fuer Shellexecute, keinerlei Antwort interpretieren
function sendToServer(eventId, strSubmitPar)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
	var strDlgId	= dialog.id;
	var strEvent = window.event.type;
	// alert("dlgId = " + strDlgId);
	// alert("Evt = " + strEvent);
    var sURL=getHost() + "/ajax/sendToServer?sessionid=" + sessionid + "&stateid=" + stateid +
    					 "&dialogid=" + strDlgId + "&eventid=" + eventId;
	// alert("sURL = " + sURL);
	// alert("strSubmitPar = " + strSubmitPar);

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	sParams=addPostParam(sParams, "__eksubmit_values_utf8__", strSubmitPar+"&"+ekEncode("sessionid")+"="+ekEncode(sessionid)+"&"
						+ekEncode("stateid") + "="+ekEncode(stateid) +"&"
    					 +ekEncode("dialogid") + "="+ekEncode(strDlgId ) +"&"
						 +ekEncode("eksubmitevent")+"=" + ekEncode(eventId)+ "&"
						 +ekEncode("EKSUBMITEVENT")+"=" + ekEncode(eventId)+ "&"
						 +ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	
	// synchroner post request
	oRequest.open("post", sTarget, false);
	oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	oRequest.send(sParams);
}

function notifyServer(eventId, asyncRequest, strSubmitPar)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
	var strDlgId	= dialog.id;
	var strEvent = window.event.type;
	// alert("dlgId = " + strDlgId);
	// alert("Evt = " + strEvent);
    var sURL=getHost() + "/ajax/" + strEvent + "?sessionid=" + sessionid + "&stateid=" + stateid +
    					 "&dialogid=" + strDlgId + "&eventid=" + eventId;
	// alert("strSubmitPar = " + strSubmitPar);

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	sParams=addPostParam(sParams, "__eksubmit_values_utf8__", strSubmitPar+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	
	if( asyncRequest )
	{	// async. request
		oRequest.open("post", sTarget, true);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.onreadystatechange = function ()
		{
		    if ( oRequest.readyState==4 && oRequest.status==200 )
		    {
				//alert(oRequest.responseText); return;
				docEl("stateid").value=stateid;
				updateDialogElementExec( oRequest.responseText );
		    }
		}
		oRequest.send(sParams);
	}
	else
	{
		// synchroner post request
		oRequest.open("post", sTarget, false);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.send(sParams);
		if( oRequest.status==200 )
		{
			// alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
	}
}

function notifyServerClick(eventId, strSubmitPar)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
	var strDlgId	= dialog.id;
	var strEvent = "click";
	// alert("dlgId = " + strDlgId);
	// alert("Evt = " + strEvent);
    var sURL=getHost() + "/ajax/" + strEvent + "?sessionid=" + sessionid + "&stateid=" + stateid +
    					 "&dialogid=" + strDlgId + "&eventid=" + eventId;
	
	// alert("strSubmitPar = " + strSubmitPar);

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		// sParams=addPostParam(sParams, "__eksubmit_values_utf8__", getEKSubmitValuesUtf8()+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	sParams=addPostParam(sParams, "__eksubmit_values_utf8__", strSubmitPar+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	
	// synchroner post request
	oRequest.open("post", sTarget, false);
	oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	oRequest.send(sParams);
	if( oRequest.status==200 )
		{
			// alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
}


function submitDialogElement(sDlgId, eventId, asyncRequest, element)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
    var sURL=getHost() + "/ajax/submit_dialog_elements?sessionid="+sessionid+"&stateid="+stateid+
    					 "&dialogid="+sDlgId+"&eventid="+eventId; //+"&elementids="+elementIds;

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValueUtf8(element)+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValueUtf8(element)+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	
	if( asyncRequest )
	{	// async. request
		oRequest.open("post", sTarget, true);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.onreadystatechange = function ()
		{
		    if ( oRequest.readyState==4 && oRequest.status==200 )
		    {
				//alert(oRequest.responseText); return;
				docEl("stateid").value=stateid;
				updateDialogElementExec( oRequest.responseText );
		    }
		}
		oRequest.send(sParams);
	}
	else
	{
		// synchroner post request
		oRequest.open("post", sTarget, false);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.send(sParams);
		if( oRequest.status==200 )
		{
			// alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
	}
}

function updateSingleDialogElement(sDlgId, eventId, asyncRequest, element)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
    var sURL=getHost() + "/ajax/update_dialog_elements?sessionid="+sessionid+"&stateid="+stateid+
    					 "&dialogid="+sDlgId+"&eventid="+eventId; //+"&elementids="+elementIds;

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValueUtf8(element)+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					getEKSubmitValueUtf8(element)+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	
	if( asyncRequest )
	{	// async. request
		oRequest.open("post", sTarget, true);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.onreadystatechange = function ()
		{
		    if ( oRequest.readyState==4 && oRequest.status==200 )
		    {
				//alert(oRequest.responseText); return;
				docEl("stateid").value=stateid;
				updateDialogElementExec( oRequest.responseText );
		    }
		}
		oRequest.send(sParams);
	}
	else
	{
		// synchroner post request
		oRequest.open("post", sTarget, false);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.send(sParams);
		if( oRequest.status==200 )
		{
			//alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
	}
}

function updateDefiniteDialogElement(sDlgId, eventId, asyncRequest, element)
{
    var sTarget,sParams="";
    var oRequest = GetXMLHttp();
    var sessionid = docEl("sessionid").value;
    var stateid = docEl("stateid").value;
    var sURL=getHost() + "/ajax/update_dialog_elements?sessionid="+sessionid+"&stateid="+stateid+
    					 "&dialogid="+sDlgId+"&eventid="+eventId; //+"&elementids="+elementIds;

	// ekSubmit simulieren...
	document.isycat.EKSUBMITEVENT.value=eventId;
	var astrElements = element.split("|");
	var strSubmitvalue = "";
	for (var i = 0; i < astrElements.length; ++i)   {
	    // alert(astrElements[i]);
	    strSubmitvalue += getEKSubmitValueUtf8(astrElements[i]);
	}
    if(self.location.host)	// Server-Mode (indirekter Request via index.php usw.)
    {
    	sTarget=self.location.href;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					strSubmitvalue+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	else					// CD-Mode (direkter Request)
	{
		sTarget=sURL;
		sParams=addPostParam(sParams, "__eksubmit_values_utf8__",
					strSubmitvalue+ekEncode("ek_ajax_url")+"="+ekEncode(sURL));
	}
	
	if( asyncRequest )
	{	// async. request
		oRequest.open("post", sTarget, true);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.onreadystatechange = function ()
		{
		    if ( oRequest.readyState==4 && oRequest.status==200 )
		    {
				//alert(oRequest.responseText); return;
				docEl("stateid").value=stateid;
				updateDialogElementExec( oRequest.responseText );
		    }
		}
		oRequest.send(sParams);
	}
	else
	{
		// synchroner post request
		oRequest.open("post", sTarget, false);
		oRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		oRequest.send(sParams);
		if( oRequest.status==200 )
		{
			// alert(oRequest.responseText); //return;
			docEl("stateid").value=stateid;
			updateDialogElementExec( oRequest.responseText );
		}
	}
}

function updateDialogElementExec(sHTML)
{
	var widgets=Array(); 
	var aWidgets=Array(); 
	var widgetConstr="",widgetInit="";
	var oFragment = document.createDocumentFragment();
	var oDIV = document.createElement("DIV");
	oFragment.appendChild(oDIV);
	// alert("sHTML = " + sHTML);
	oDIV.innerHTML= sHTML;
	// alert("oDIV = " + oDIV.innerHTML);
		
	if(oDIV.childNodes.length==0)	{
		return false;
	}

	var aJS=oDIV.getElementsByTagName("SCRIPT");
	for(var i=0 ; i<aJS.length ; i++)	{
		// alert("SCRIPT " + aJS[i].innerHTML);
		eval(aJS[i].innerHTML);
	}
	
	var n=0;
	while( n<oDIV.childNodes.length )
	{
		var sId, oCurr=oDIV.childNodes[n];
		if( !oCurr || !oCurr.id || (sId=oCurr.id)=="")
		{
			n++;
			continue;
		}
		
		var oPCE = docEl( sId );	// current element in parent document
		if(!oPCE)
		{
			n++;
			continue;
		}
		
		// Comboboxen ohne nderung berspringen
		if (oPCE.nodeName == "SELECT" && oPCE.getAttribute("items") == oCurr.getAttribute("items")
			&& oPCE.getAttribute("selected") == oCurr.getAttribute("selected"))	{
			oPCE.setAttribute("norender", true);
			n++;
			continue;
		}

		if (oPCE.nodeName == "INPUT" && oPCE.type == "text" ) {
			oPCE.setAttribute("norender", true);
			dialog[sId].setValue(oCurr.value);
			n++;
			continue;
		}
				
		var oParent=oPCE.parentNode;
		//alert("alt:\n"+oPCE.innerHTML);
		//alert("neu:\n"+oCurr.innerHTML);
		oParent.replaceChild(oCurr, oPCE );
	}
	
	
	for(var i=0;i<widgets.length;i++)
	{
		var aWidgetConstr = widgets[i].split(':');
		var strWidgetId = aWidgetConstr[1];
		eval('widget=new '+ aWidgetConstr[0] + '(\'' + aWidgetConstr[1] + '\');');
		if (widget.element.getAttribute("norender"))	{
			widget.element.removeAttribute("norender");
			continue;
		}
		widget.render();
		widget.finalize();
		if (dialog[strWidgetId] == 'undefined')
			dialog.registerWidget(widget);
	}
}


/*
function updateDialogElementExec(sHTML)
{
	var widgets=Array(); 
	var aWidgets=Array(); 
	var widgetConstr="",widgetInit="";
	var oFragment = document.createDocumentFragment();
	var oDIV = document.createElement("DIV");
	oFragment.appendChild(oDIV);
	oDIV.innerHTML= sHTML;
	
	if(oDIV.childNodes.length==0)
		return false;

	var aJS=oDIV.getElementsByTagName("SCRIPT");
	for(var i=0 ; i<aJS.length ; i++)
		eval(aJS[i].innerHTML);

	for(n=0; n<oDIV.childNodes.length ; n++ )
	{
		var sId, oCurr=oDIV.childNodes[n];
		if( !oCurr || !oCurr.id || (sId=oCurr.id)=="" )
			continue;
	
		// var ektype= oCurr.getAttribute("ektype") ? oCurr.getAttribute("ektype") : oCurr.nodeName;
		// alert(oCurr.getAttribute('ektype'));
		
		var oPCE = docEl( sId );	// current element in parent document
		if (oPCE.nodeName == "SELECT" && oPCE.getAttribute("items") == oCurr.getAttribute("items")
			&& oPCE.getAttribute("selected") == oCurr.getAttribute("selected"))	{
			oPCE.setAttribute("norender", true);
			continue;
		}

		var oParent=oPCE.parentNode;
		oParent.replaceChild(oCurr, oPCE );
	}
	
	for(var i=0;i<widgets.length;i++)
	{
		var aWidgetConstr = widgets[i].split(':');
		var strWidgetId = aWidgetConstr[1];
//		widgetConstr += 'aWidgets['+i+']=new '+aWidgetConstr[0] + '(\'' + aWidgetConstr[1] + '\');';
		eval('widget=new '+ aWidgetConstr[0] + '(\'' + aWidgetConstr[1] + '\');');
		if (widget.element.getAttribute("norender"))	{
			widget.element.removeAttribute("norender");
			continue;
		}
		widget.render();
		widget.finalize();
		if (dialog[strWidgetId] == 'undefined')
			dialog.registerWidget(widget);
	}

	//for(var i=0;i<widgets.length;i++)
	//	widgetInit += 'aWidgets['+i+'].finalize();';
	
//	eval(widgetConstr);
//	eval(widgetInit);
}
*/





// Simulating inserAdjacentHTML on NS6
// Code by thor@jscript.dk
// ******************************************

if(typeof HTMLElement!="undefined" && !HTMLElement.prototype.insertAdjacentElement){
	HTMLElement.prototype.insertAdjacentElement = function (where,parsedNode)
	{
		switch (where){
		case 'beforeBegin':
			this.parentNode.insertBefore(parsedNode,this)
			break;
		case 'afterBegin':
			this.insertBefore(parsedNode,this.firstChild);
			break;
		case 'beforeEnd':
			this.appendChild(parsedNode);
			break;
		case 'afterEnd':
			if (this.nextSibling) 
				this.parentNode.insertBefore(parsedNode,this.nextSibling);
			else this.parentNode.appendChild(parsedNode);
			break;
		}
	}

	HTMLElement.prototype.insertAdjacentHTML = function(where,htmlStr)
	{
		var r = this.ownerDocument.createRange();
		r.setStartBefore(this);
		var parsedHTML = r.createContextualFragment(htmlStr);
		this.insertAdjacentElement(where,parsedHTML)
	}
}
