
class MotionProfiler
{

var m_anzPhasen=18;
var m_AlphaRadian=0;
var m_BetaRadian=0;
var m_GammaRadian=0;
var m_FX_MAX;
var m_FY_MAX;
var m_FZ_MAX;
var m_FX=new Array();
var m_FY=new Array();
var m_FZ=new Array();
var m_S_MAX,m_S_MIN;
var m_M_MAX;
var m_massen= new Array();
 
var m_dx;
var m_L1;
var m_LS1;
var m_LS2;

var m_selectedMasse;
var m_selectedKraft;
var m_TempDir; // Direktory, in dem temporaere Grafiken und Files abgelegt werden
var m_FileSeqNr; // Zusaetzliche Nummerierung der Grafik Files um die Filenamen eindeutig zu machen und
                 // unerwuenschtes Caching zu verhindern

// Konfigurationsparameter fuer die Darstellung
var m_selectedOnly= true; // Nur die momentan ausgewaehlten Massen und Kraefte bei der Darstellung beruecksichtigen
var m_ShowKraft=true;	// Kraefte Darstellen
var m_ShowMasse=true;   // Massen Darstellen
var m_ShowKoordSys=true; // Koordinatensystem darstellen (momentan realisiert durch Darstellung aller Kraefte)
var m_ShowTitle=true;  // Phase als Text in Bild mit ausgeben
var m_UseActiveFlag=true; // Active Flag auswerten. Falls Wert auf False steht werden ggfs. auch Massen und Kaefte angezeigt, die
                          // in der entsprechenden Phase deaktiviert sind
var m_XLabel="X";         // Beschriftung der X Achse (Wird in Kraefte Maske mit F beschriftet..)

enableKraft() {
	m_ShowKraft=true;
}
enableMasse() {
	m_ShowMasse=true;
}
enableKoordSys() {
	m_ShowKoordSys=true;
}
enableTitle() {
	m_ShowTitle=true;
}
disableKraft() {
	m_ShowKraft=false;
}
disableMasse() {
	m_ShowMasse=false;
}
disableKoordSys() {
	m_ShowKoordSys=false;
}
disableTitle() {
	m_ShowTitle=false;
}
disableActiveFlag() {
	m_UseActiveFlag=false;
}
setXLabel (label) {
	m_XLabel=label;
};

incSeqNr() {
	m_FileSeqNr=getdouble("DLGDATA.4DMOTION","SEQNR");	
	m_FileSeqNr+=1;
	setdouble ("DLGDATA.4DMOTION","SEQNR",m_FileSeqNr);
};
// Fuer 4D Profile relevante Werte aus Store auslesen un in Member Variablen uebetragen
initData () {

m_TempDir=trimright(getstring("CATALOG.HTMLTEMP","ROOT"),dirsep())+dirsep();
m_TempDir=m_TempDir.replace ("\\","/");
// Zahl der Phasen im Bewegungsablauf bestimmen
// TODO: anzahl Phasen bestimmen fur DynStreckenanteile und Dynzeitanteile
  for (var i=0;i<m_anzPhasen;i++) {
    
	s=getstring("DELTAS.RAW","DLGDATA.DYNZYKLUS.PROFIL."+i);
	if (s=="") {
	    q=getstring("QS.RAW","DLGDATA.DYNZYKLUS.PROFIL."+i);
		if (q=="" || q==0) {
			m_anzPhasen=i;
		}
	};
  }
// Winkel ermitteln und im Store hinterlegen
var Alpha=getdouble ("10003.VALUE","DLGDATA.SYSTEM");
var Beta=getdouble("10004.VALUE","DLGDATA.SYSTEM");
var Gamma=getdouble("GAMMA","DLGDATA.WINKEL");
var m_AlphaRadian=Alpha/180.0*Math.PI
if (m_AlphaRadian<0) {
	m_AlphaRadian=2*Math.PI+m_AlphaRadian;
};
var m_BetaRadian=Beta/180.0*Math.PI
if (m_BetaRadian<0) {
	m_BetaRadian=2*Math.PI+m_BetaRadian;
};
var m_GammaRadian=Gamma/180.0*Math.PI
if (m_GammaRadian<0) {
	m_GammaRadian=2*Math.PI+m_GammaRadian;
};


setstring ("ALPHA","DLGDATA.4DMOTION",formatstring(m_AlphaRadian,"%.10f"));
setstring ("BETA","DLGDATA.4DMOTION",formatstring(m_BetaRadian,"%.10f"));
setstring ("GAMMA","DLGDATA.4DMOTION",formatstring(m_GammaRadian,"%.10f"));

// Endpositionen ermitteln 
var i;
// X3D Templates erzeugen
var ProfileTemplate;
var X3DProfile;
var MutterPosition;
 ProfileTemplate=readfile (".\\catalog\\Docs\\4DProfileTemplate4.xml");
 // Maxima bestimmen
 var check_FX;
 var check_FY;
 var check_FZ;
 
 var anzMassen = getsize("DLGDATA.MASSEN", "")
 var anzKraefte = getsize("DLGDATA.KRAEFTE", "")
 
 var selMasseId=getstring("SELMASSEID","DLGDATA");
 if ((selMasseId===null) || (selMasseId=="")) {
	m_selectedMasse=-1;
 } else {
	m_selectedMasse=selMasseId;
 };
 var selKraftId=getstring("SELKRAFTID","DLGDATA");
 if (selKraftId===null || selKraftId=="") {
	m_selectedKraft=-1;
 } else {
	m_selectedKraft=selKraftId;
 };
 
 
 var masse;
  var masseAktiv;
  
  m_dx=getdouble ("X0.BASE","DLGDATA.KGTSYSTEM");
  m_L1=getdouble ("L_LAGER.BASE","DLGDATA.KGTSYSTEM");
  m_LS1=getdouble ("LS1.BASE","DLGDATA.KGTSYSTEM");
  m_LS2=getdouble ("LS2.BASE","DLGDATA.KGTSYSTEM");
 
 m_S_MAX=Number.NEGATIVE_INFINITY;
 m_S_MIN=Number.POSITVE_INFINITY;
 for (phase=0;phase<m_anzPhasen;phase++) {
    m_FX[phase]=0;
	m_FY[phase]=0;
	m_FZ[phase]=0;
	// Kraefte und deren Maxima bestimmen
	// (Gesamt Kraefte werden approximativ bestimmt, da Kraftangriffspunkt nicht beruecksichtigt wird)
	for (i=0;i<anzKraefte;i++ ) {
	    check_FX=getdouble("DLGDATA.KRAEFTE["+i+"].KRAFT.X.BASE","");
		check_FY=getdouble("DLGDATA.KRAEFTE["+i+"].KRAFT.Y.BASE","");
		check_FZ=getdouble("DLGDATA.KRAEFTE["+i+"].KRAFT.Z.BASE","");
		if (m_selectedOnly && (m_selectedKraft!=i)) { // ggfs nur selektierte  beruecksichtigen
			continue;
		};
		kraftAktiv=getbool("DLGDATA.KRAEFTE["+i+"].ZYKLUSDATEN["+phase+"].ACTIVE",""); 
		if (kraftAktiv || !m_UseActiveFlag) {
			m_FX[phase]+=check_FX;
			m_FY[phase]+=check_FY;
			m_FZ[phase]+=check_FZ;
			
		};
	}
	
	m_FX_MAX=(abs(m_FX[phase])>m_FX_MAX)?abs(m_FX[phase]):m_FX_MAX; 
	m_FY_MAX=(abs(m_FY[phase])>m_FY_MAX)?abs(m_FY[phase]):m_FY_MAX; 
	m_FZ_MAX=(abs(m_FZ[phase])>m_FZ_MAX)?abs(m_FZ[phase]):m_FZ_MAX; 
	// Effektive Massen und Maximum bestimmen 
	m_massen[phase]=0;
	for (i=0;i<anzMassen;i++ ) {
		masse=getdouble("DLGDATA.MASSEN["+i+"].MASSE.BASE","");
		if ((m_selectedOnly==true) && (m_selectedMasse!=i)) { // ggfs nur selektierte Masse beruecksichtigen
			continue;
		};
		masseAktiv=getbool("DLGDATA.MASSEN["+i+"].ZYKLUSDATEN["+phase+"].ACTIVE",""); 
	    if ((masse>0) && (masseAktiv || !m_UseActiveFlag)) {
			m_massen[phase]+=masse;
		}
	}
	m_M_MAX=(m_massen[phase]>m_M_MAX)?m_massen[phase]:m_M_MAX;
	
	// StreckenMaximum bestimmen
	s=getdouble ("SE.BASE","DLGDATA.DYNZYKLUS.PROFIL."+phase);
	m_S_MAX=(s>m_S_MAX)?s:m_S_MAX;
	m_S_MIN=(s<m_S_MIN)?s:m_S_MIN;

 };
};
// Pruefen, ob der laut Dynzyklus definierte Hub ueberhaupt moeglich ist
checkHub () {
  PosMaxProzent=(m_S_MAX+m_dx)/(m_L1-m_LS1-m_LS2)*100.0;
  PosMinProzent=(m_S_MIN+m_dx)/(m_L1-m_LS1-m_LS2)*100.0;
  if (PosMaxProzent>100.0 || PosMinProzent<0.0) { 
	return false;
  } else {
	return true;
  }
   
};
// Fuer die uebergebene Phase relevante Massen in 3D Darstellung aktivieren bzw. deaktivieren
SelectMasse (phase) {
  // Massen aktivieren
  if (m_massen[phase]>0 && m_ShowMasse) {
	setstring ("MASSESCALE","DLGDATA.4DMOTION",1.0);
  } else {
	setstring ("MASSESCALE","DLGDATA.4DMOTION",0.0);
  };
  // FX aktivieren
  
  
};

// Fuer die uebergebene Phase relevante Kraefte in 3D Darstellung aktivieren bzw. deativieren
SelectKraft (phase) {
  
  if (!m_ShowKraft && !m_ShowKoordSys) {
  	setstring ("FXSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FYSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FZSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FXSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FYSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FZSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FXSCALE_Z","DLGDATA.4DMOTION",0.0);
	setstring ("FYSCALE_Z","DLGDATA.4DMOTION",0.0);
	setstring ("FZSCALE_Z","DLGDATA.4DMOTION",0.0);
	return;
  };
  // FX aktivieren
  
  if (m_FX[phase]>0 || m_ShowKoordSys) {
	setstring ("FXSCALE_X","DLGDATA.4DMOTION",1.0);
	setstring ("FXSCALE_Y","DLGDATA.4DMOTION",1.0);
	setstring ("FXSCALE_Z","DLGDATA.4DMOTION",1.0);
  } else if (m_FX[phase]<0) {
    setstring ("FXSCALE_X","DLGDATA.4DMOTION",-1.0);
	setstring ("FXSCALE_Y","DLGDATA.4DMOTION",1.0);
	setstring ("FXSCALE_Z","DLGDATA.4DMOTION",1.0);
  } else {
    setstring ("FXSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FXSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FXSCALE_Z","DLGDATA.4DMOTION",0.0);
  };
   // FY aktivieren
  
  if (m_FY[phase]>0 || m_ShowKoordSys) {
	setstring ("FYSCALE_X","DLGDATA.4DMOTION",1.0);
	setstring ("FYSCALE_Y","DLGDATA.4DMOTION",1.0);
	setstring ("FYSCALE_Z","DLGDATA.4DMOTION",1.0);
  } else if (m_FY[phase]<0) {
    setstring ("FYSCALE_X","DLGDATA.4DMOTION",1.0);
	setstring ("FYSCALE_Y","DLGDATA.4DMOTION",-1.0);
	setstring ("FYSCALE_Z","DLGDATA.4DMOTION",1.0);
  } else {
    setstring ("FYSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FYSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FYSCALE_Z","DLGDATA.4DMOTION",0.0);
  };
   // FZ aktivieren
  
  if (m_FZ[phase]>0 || m_ShowKoordSys) {
	setstring ("FZSCALE_X","DLGDATA.4DMOTION",1.0);
	setstring ("FZSCALE_Y","DLGDATA.4DMOTION",1.0);
	setstring ("FZSCALE_Z","DLGDATA.4DMOTION",1.0);
  } else if (m_FZ[phase]<0) {
    setstring ("FZSCALE_X","DLGDATA.4DMOTION",1.0);
	setstring ("FZSCALE_Y","DLGDATA.4DMOTION",1.0);
	setstring ("FZSCALE_Z","DLGDATA.4DMOTION",-1.0);
  } else {
    setstring ("FZSCALE_X","DLGDATA.4DMOTION",0.0);
	setstring ("FZSCALE_Y","DLGDATA.4DMOTION",0.0);
	setstring ("FZSCALE_Z","DLGDATA.4DMOTION",0.0);
  };
};
// Parameterfile fuer die Phasen 0 bis anzPhasen Phasen erzeugen
// normalerweise verwendet um nur Startposition anzPhasen=0 oder alle Phasen zu erzeugen
genParameterFile(anzPhasen,imageSize) {
	// Parameterfile erzeugen
	write (m_TempDir+"MotionProfile.txt","");
	for (phase=0;phase<=anzPhasen;phase++) {
		writefile (m_TempDir+"MotionProfile.txt",m_TempDir+"Phase"+phase+".x3d,","A");
		writefile (m_TempDir+"MotionProfile.txt",m_TempDir+"S"+m_FileSeqNr+"Phase"+phase+".png,","A");
		if (m_ShowTitle) {
			writefile (m_TempDir+"MotionProfile.txt"," T"+phase+",","A");
		} else {
			writefile (m_TempDir+"MotionProfile.txt",",","A");
		};
		writefile (m_TempDir+"MotionProfile.txt","2000,","A");
		writefile (m_TempDir+"MotionProfile.txt",imageSize,"A");
		writefile (m_TempDir+"MotionProfile.txt","\n","A");
		
	};
};
// Grafiken fuer 4D Profil berechnen
calc4DProfile (imagesize) {
	incSeqNr();
    // Template einlesen
	ProfileTemplate=readfile (".\\catalog\\Docs\\4DProfileTemplate4.xml");
    
	// Startposition
	s=getdouble ("SA.BASE","DLGDATA.DYNZYKLUS.PROFIL."+0);
	MutterPosition=(s+m_dx)/(m_L1-m_LS1-m_LS2)*100.0

	SelectKraft(0);
	SelectMasse(0);
	setstring ("XLABEL","DLGDATA.4DMOTION",m_XLabel);
	setstring ("MUTTERPOSITION","DLGDATA.4DMOTION",MutterPosition);
	setstring ("MUTTERSTARTPOSITION","DLGDATA.4DMOTION",MutterPosition);
	var X3DProfile=eval("<<|"+ProfileTemplate+"|");
	write (m_TempDir+"Phase"+0+".x3d",X3DProfile);	
   
    // Endpositionen der einzelnen Phasen
	for (phase=0;phase<m_anzPhasen;phase++) {
	// Mutterposition
		s=getdouble ("SE.BASE","DLGDATA.DYNZYKLUS.PROFIL."+phase);
		MutterPosition=(s+m_dx)/(m_L1-m_LS1-m_LS2)*100.0
  
		setstring ("MUTTERPOSITION","DLGDATA.4DMOTION",MutterPosition);
		SelectKraft (phase);
		SelectMasse (phase);
  
		var X3DProfile=eval("<<|"+ProfileTemplate+"|");
		write (m_TempDir+"Phase"+(phase+1)+".x3d",X3DProfile);
	};

	genParameterFile (m_anzPhasen,imagesize);
	// Grafiken generieren
	//shellexecute ("4DWinProfiler.exe",m_TempDir+"MotionProfile.txt","");
	generateImagesFromX3D (m_TempDir+"MotionProfile.txt");
	setstring ("CURRENTIMAGEFILE","DLGDATA.4DMOTION","S"+m_FileSeqNr+"PHASE0.png");
	setstring ("CURRENTIMAGE","DLGDATA.4DMOTION",0);
	setstring ("MAXIMAGE","DLGDATA.4DMOTION",m_anzPhasen);
	setstring ("BASEPATH","DLGDATA.4DMOTION",'"'+m_TempDir+"S"+m_FileSeqNr+'PHASE"');
	setstring ("PLAYBUTTONIMAGE","DLGDATA.4DMOTION","img_pause.png");
	
};
// Nur Grafik fuer Startposition berechnen
calcStartPosition (imagesize) {
	incSeqNr();
  // Template einlesen
	ProfileTemplate=readfile (".\\catalog\\Docs\\4DProfileTemplate4.xml");
    
	// Startposition
	s=getdouble ("SA.BASE","DLGDATA.DYNZYKLUS.PROFIL."+0);
	MutterPosition=(s+m_dx)/(m_L1-m_LS1-m_LS2)*100.0

	SelectKraft (0);
	SelectMasse (0);
	setstring ("XLABEL","DLGDATA.4DMOTION",m_XLabel);
	setstring ("MUTTERPOSITION","DLGDATA.4DMOTION",MutterPosition);
	setstring ("MUTTERSTARTPOSITION","DLGDATA.4DMOTION",MutterPosition);
	var X3DProfile=eval("<<|"+ProfileTemplate+"|");
	write (m_TempDir+"Phase"+0+".x3d",X3DProfile);	
   
   

	genParameterFile (0,imagesize);
	// Grafiken generieren
	//shellexecute ("4DWinProfiler.exe",m_TempDir+"MotionProfile.txt","");
	generateImagesFromX3D (m_TempDir+"MotionProfile.txt");
	setstring ("STARTPOSIMAGEFILE","DLGDATA.4DMOTION","S"+m_FileSeqNr+"PHASE0.png");
};
// Grafik fuer Ausdruck berechnen
calcPrintProfile(imagesize ) {
	incSeqNr();
	// Template einlesen
	ProfileTemplate=readfile (".\\catalog\\Docs\\4DProfileTemplate4Print.xml");
    
	// Startposition
	s=getdouble ("SA.BASE","DLGDATA.DYNZYKLUS.PROFIL."+0);
	MutterPosition=(s+m_dx)/(m_L1-m_LS1-m_LS2)*100.0

	SelectKraft (0);
	SelectMasse (0);
	setstring ("MUTTERPOSITION","DLGDATA.4DMOTION",MutterPosition);
	setstring ("MUTTERSTARTPOSITION","DLGDATA.4DMOTION",MutterPosition);
	var X3DProfile=eval("<<|"+ProfileTemplate+"|");
	write (m_TempDir+"Phase"+0+".x3d",X3DProfile);	
   
   

	genParameterFile (0,imagesize);
	// Grafiken generieren
	//shellexecute ("4DWinProfiler.exe",m_TempDir+"MotionProfile.txt","");
	generateImagesFromX3D (m_TempDir+"MotionProfile.txt");
	setstring ("PRINTIMAGE","DLGDATA.4DMOTION",m_TempDir+"S"+m_FileSeqNr+"PHASE0.png");
};	
// Grafik fuer Ausdruck ohne Drehung um Winkel berechnen
calcPrintProfileAusgangsPos(imagesize ) {
	incSeqNr();
	// Template einlesen
	ProfileTemplate=readfile (".\\catalog\\Docs\\4DProfileTemplate4Print.xml");
    
	// Startposition
	s=getdouble ("SA.BASE","DLGDATA.DYNZYKLUS.PROFIL."+0);
	MutterPosition=(s+m_dx)/(m_L1-m_LS1-m_LS2)*100.0

	SelectKraft (0);
	SelectMasse (0);
	setstring ("MUTTERPOSITION","DLGDATA.4DMOTION",MutterPosition);
	setstring ("MUTTERSTARTPOSITION","DLGDATA.4DMOTION",MutterPosition);
	
	// Drehwinkel auf 0 setzen
	setstring ("ALPHA","DLGDATA.4DMOTION","0");
	setstring ("BETA","DLGDATA.4DMOTION","0");
	setstring ("GAMMA","DLGDATA.4DMOTION","0");

	var X3DProfile=eval("<<|"+ProfileTemplate+"|");
	write (m_TempDir+"Phase"+0+".x3d",X3DProfile);	
   
   

	genParameterFile (0,imagesize);
	// Grafiken generieren
	//shellexecute ("4DWinProfiler.exe",m_TempDir+"MotionProfile.txt","");
	generateImagesFromX3D (m_TempDir+"MotionProfile.txt");
	setstring ("PRINTIMAGE_START","DLGDATA.4DMOTION",m_TempDir+"S"+m_FileSeqNr+"PHASE0.png");
};	

// Auf verfuegbare Bilder warten
// z.z. reine Zeitverzoegerung

waitForImage () {
	//sleep(2000);
};
};
