// Pruefen, ob fuer gesetzte Steigung und gesetztem Spindelsupport auch ein Antrieb existiert
// falls Bedingung nicht erfuellt, entsprechende Storevariable setzen (aktiviert Fehlermeldung in KGT_AUSMASSE und KGT_DATEN)
// und false zurueckgeben
function CheckSPU() {
	if (getstring("BSPINDELUNTERSTUETZUNG", "DLGDATA.KGTSYSTEM") != "true")	{
		setstring ("BMSG_NOT_FOUND_SPU","DLGDATA.KGTAUSMASSE","false");
		return true;
	};
	
	var PM_STEIGUNG=abs(getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
	var sqlStr=<<|select * from KGT where PM_BAUREIHE='Antriebseinheit AGK' AND PM_STEIGUNG='$PM_STEIGUNG$'|;
	var resultList=Object.fromDatabase ("SYSTEM_DB",sqlStr);
	if (resultList.length==0) {
		setstring ("BMSG_NOT_FOUND_SPU","DLGDATA.KGTAUSMASSE","true");
		return false;
	} else {
		setstring ("BMSG_NOT_FOUND_SPU","DLGDATA.KGTAUSMASSE","false");
		return true;
	};
	
}
// ----------------------------------------------------------------------------------
// Prueft, ob fuer alle definierte Kraefte (d.h. Wert fuer eine Kraftkomponente eingetragen)
// auch koordinaten eingetragen sind
//
// ----------------------------------------------------------------------------------
function CheckKraefte()
{
	var branch=getint("CURRENTBRANCH", "");
	if (branch!=0) {
		return true; // Pruefung nur fuer Profilschienen notwendig
	};
	nAnzKraefte = getsize("DLGDATA.KRAEFTE", "")
	result=true;
	setstring ("BMSG_FORCE_KOORD_INCOMPLETE","DLGDATA","false");
	setstring ("BMSG_FORCE_INCOMPLETE","DLGDATA","false");
	for i = 0 to (nAnzKraefte - 1)
	{
		strPath="DLGDATA.KRAEFTE[" + i + "]";
		fx=getstring ("KRAFT.X.VALUE",strPath);
		fy=getstring ("KRAFT.Y.VALUE",strPath);
		fz=getstring ("KRAFT.Z.VALUE",strPath);
		if ((fx+fy+fz)!="") {
			xKoord=getstring ("KOORD.X.VALUE",strPath);
			yKoord=getstring ("KOORD.Y.VALUE",strPath);
			zKoord=getstring ("KOORD.Z.VALUE",strPath);
			if (xKoord=="" || yKoord=="" || zKoord=="") {
				result=false; // Koordinaten unvollstaendig
				setstring ("BMSG_FORCE_KOORD_INCOMPLETE","DLGDATA","true");
			};
			if (fx=="" || fy=="" || fz=="") {
				result=false; // Kraft Komponenten unvollstaendig
				setstring ("BMSG_FORCE_INCOMPLETE","DLGDATA","true");
			};
		}
	};
	return result;
}
// ----------------------------------------------------------------------------------
// Prueft, ob fuer Profilschienen, in der Maske Mae gueltige Werte eingebeben sind
//
// ----------------------------------------------------------------------------------
function CheckPFAbmessungen()
{
	var branch=getint("CURRENTBRANCH", "");
	if (branch!=0) {
		return true; // Pruefung nur fuer Profilschienen notwendig
	};
	
	var dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM");
	var dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM");
	
	
	
	if (!((dFWAnz == 1) or ((dFWAnz == 2) and (dFSAnz == 2)))) {
		var dLW1 = getdouble ("10007.VALUE","DLGDATA.SYSTEM");
		if (dLW1==0) {
		 return false;
		}
	};

	if (dFWAnz == 8) {
		var dLW2 = getdouble ("10008.VALUE","DLGDATA.SYSTEM");
		if (dLW2==0) {
		 return false;
		}
	};

	if (dFSAnz == 2) {
		var dLS  = getdouble ("10009.VALUE","DLGDATA.SYSTEM");
		if (dLS==0) {
		 return false;
		}
	};


	return true;
}
// ----------------------------------------------------------------------------------
// Prueft, ob fuer alle definierte Massen (d.h. Wert fuer Gewicht eingetragen)
// auch koorinaten eingetragen sind
//
// ----------------------------------------------------------------------------------
function CheckMassen()
{
	var branch=getint("CURRENTBRANCH", "");
	if (branch!=0) {
		return true; // Pruefung nur fuer Profilschienen notwendig
	};
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	result=true;
	setstring ("BMSG_MASS_KOORD_INCOMPLETE","DLGDATA","false");
	for i = 0 to (nAnzMassen - 1)
	{
		strPath="DLGDATA.MASSEN[" + i + "]";
		Masse=getstring ("MASSE",strPath);
		if (Masse!="") {
			xKoord=getstring ("KOORD.X.VALUE",strPath);
			yKoord=getstring ("KOORD.Y.VALUE",strPath);
			zKoord=getstring ("KOORD.Z.VALUE",strPath);
			if (xKoord=="" || yKoord=="" || zKoord=="") {
				result=false; // Koordinaten unvollstaendig
				setstring ("BMSG_MASS_KOORD_INCOMPLETE","DLGDATA","true");
			};
		}
	};
	return result;
}
// ----------------------------------------------------------------------------------
// Prueft, ob bei KGT mit aktivierter Spindelunterstuetzung 
// Horizontalbetrieb vorliegt
//
// ----------------------------------------------------------------------------------

function CheckHorizontal()
{
	var result=true;
	if(getbool("ISKGT", "DLGDATA"))	{	
		var Alpha=getdouble ("10003.BASE","DLGDATA.SYSTEM");//*Math.PI/180.0;
		var Beta=getdouble("10004.BASE","DLGDATA.SYSTEM");//*Math.PI/180.0;
		var hasSPU=getbool ("KGTSYSTEM.BSPINDELUNTERSTUETZUNG","DLGDATA");
		if (hasSPU==1 and (abs (cos(Alpha)*sin(Beta))>1.0e-8)) { // =0 mit Float ware tueckisch	, keine zu engen Grenzen da Ungenauigkeiten bei Winkelumrechnung		
			setstring ("BMSG_HORIZONTAL_ONLY","DLGDATA.WINKEL","true");
			result=false;
		} else {
			setstring ("BMSG_HORIZONTAL_ONLY","DLGDATA.WINKEL","false");
		};
	};

	return result;
	
}