#include "CDialogBase.b"
#include "Zyklus.b"
#include "DatenAllg.b"

function	onCalc()
{
	bRet = execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCQSFROMQTVM");
	
	CDialogBase	dlg;
	nAnzZyklen = 18;
	strResult = "<input></input>";
	for (i = 0; i < nAnzZyklen; ++i)	{
		strZyklusPath = "DLGDATA.DYNZYKLUS.PROFIL." + i;
		strResult += dlg.updateTableCellClient("IDC_ZEITANTEILE_LABEL" + (i + 1) + "_3", getstring("QT.VALUE", strZyklusPath));
		strResult += dlg.updateTableCellClient("IDC_ZEITANTEILE_LABEL" + (i + 1) + "_4", getstring("QS.VALUE", strZyklusPath));
	}
	return strResult;
}

function	onUnitVmChanged()
{
	CDialogBase	dlg;
	nAnzZyklen = 18;
	
	strElementIds = "";
	for (i = 1; i <= nAnzZyklen; ++i)	{
		strElementIds += "IDC_ZEITANTEILE_EDIT_" + i + "_2|";
	}
	strElementIds.trimRight("|");
	return dlg.getDialogElementEx("IDD_DYNZEITANTEILE", strElementIds);
}

function onUnitNmChanged()
{
	CDialogBase	dlg;
	nAnzZyklen = 18;
	
	strElementIds = "";
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	strUnit = getstring("N_PROTOTYPE.UNIT", strProfilePath);
	for (i = 1; i <= nAnzZyklen; ++i)	{
		strElementIds += "IDC_ZEITANTEILE_EDIT_" + i + "_N|";
		strTmpProfilePath = strProfilePath + "." + (i - 1);
		setstring("NE.UNIT", strTmpProfilePath, strUnit);
		setstring("NM.UNIT", strTmpProfilePath, strUnit);
	}
	strElementIds.trimRight("|");
	return dlg.getDialogElementEx("IDD_DYNZEITANTEILE", strElementIds);
};

function	copyVm2Ve()
{
	nAnzZyklen = 18;
	strZyklusPath = "DLGDATA.DYNZYKLUS.PROFIL.";
	for (i = 0; i < nAnzZyklen; ++i)	{
		strPath = strZyklusPath + i;
		dVm = getdouble("VM.RAW", strPath);
		setdouble("VE.RAW", strPath, dVm);
	}
}

function	onEditChanged()
{
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	eventPar	= getdlgvar("EKSUBMITEVENTPAR")		# Event aus der aktuellen Maske	
	strRowCol	= replace(eventPar,("IDC_ZEITANTEILE_EDIT_"),"") // vollstndige Form: 'IDC_ZEITANTEILE_EDIT_1_N'
	strElementIds = "";
	
	ClearResult();
	clearResultsKGT();

	dRet = split(strRowCol, strRow, strCol, "_")   
	nRow = 0 + strRow;
	// strRow (bzw. mRow) kann zwischen 1 und 18 liegen
	// strCol kann 2 (entspricht Spalte 3) oder N (entspricht spalte 4) sein
	
	// Wenn keine Drehzahl berechnet wird, nichts tun!
	if (getbool("KEINE_DREHZAHL","DLGDATA")) return 2;
	
	// Modifizierte Phase bestimmen und in Store schreiben:
	strModPhysValue = "T"
	nProfileIndex = strRow - 1	
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL"  
	strPhasePath = strProfilePath + "."+ nProfileIndex
	setstring("CURRENTMODIFIED", strPhasePath, strModPhysValue)

	// Modifikation der nicht ausgefllten Werte:
	if (strCol == "2")					// Abhngig von der genderten Spalte 
	{
		calcNM(nProfileIndex)
	}
	else								// d.h. strCol == "N"
	{
		calcVM(nProfileIndex)
	}
	
	// Response:
    if (true) //getstring("PREVMODIFIED", strPhasePath) != "") // ?????
	{
		strElementIds += "IDC_ZEITANTEILE_EDIT_" + nRow + "_2|";
		strElementIds += "IDC_ZEITANTEILE_EDIT_" + nRow + "_N";
	}
	CDialogBase	dlg;
	if (strElementIds != "")
	{
		strResult = dlg.getDialogElementEx("IDD_DYNZEITANTEILE", strElementIds);
		return strResult;
	}
	else
		return 2;
}


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");
	if (strIntEvent == "INIT")	{
		initDynZyklus();	
	}
		
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_ZEITANTEILE_DURCHSCHNITTSGESCHW_UNIT_COMBO":
		return onUnitVmChanged();
		break;
	case "*.DLGDATA.DYNZYKLUS.PROFIL.N_PROTOTYPE.UNIT":
		return onUnitNmChanged();
		break;
	case "IDC_CALC_BUT":
		return onCalc();
		break;
	case "IDC_DYNZEITANTEILE_EDIT":
		return onEditChanged();
		break;
	}
	copyVm2Ve();
	return "";
/*	
    CDialogBase	dlg;
	switch (event)	{
	case "IDC_DYNZYKLUS_COMBOBOX_2_2":
		strElementIds = getRowEditIds(2);
		strResult = dlg.getDialogElementEx("IDD_DYNZYKLUS", strElementIds);
		return strResult;
		break;
	}
*/	
}