#include "CDialogBase.b"
#include "Allgemein.b"
#include "Zyklus.b"
#include "DatenAllg.b"

getRowEditIds(nRow)
{
	strRes = "";
	nStart = 3;
	nAnzPhasen = 18;
	for (i = nStart; i < (nStart + nAnzPhasen); ++i)	{
		strRes += "IDC_DYNZYKLUS_EDIT_" + nRow + "_" + i + "|";
	}
	strRes.trimRight("|");
	return strRes;
}

getPQFromTabRow(strRow)
{
	if (strRow == "2")
		return "V"
	else if (strRow == "3")
		return "A"
	else if (strRow == "4")
		return "S"
	else if (strRow == "5")
		return "T"
	else if (strRow == "9")
		return "N"
	return ""
}

onEditChanged()
{
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	eventPar	= getstring("EKSUBMITEVENTPAR","")		# Event aus der aktuellen Maske	
	eventPar	= getdlgvar("EKSUBMITEVENTPAR")		# Event aus der aktuellen Maske	
	strRowCol	= replace(eventPar,(event+"_"),"")
	strElementIds = "";
	ClearResult();
	clearResultsKGT();

	dRet = split(strRowCol, strRow, strCol, "_")
	strModPhysValue = getPQFromTabRow(strRow)
	nProfileIndex = strCol - 3
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL"
	strPhasePath = strProfilePath + "."+ nProfileIndex
	bDrehzahlVisible = isDrehzahlVisible();
	strPrevMod = getstring("PREVMODIFIED", strPhasePath);

	if (strModPhysValue == "N")	{
		strModPhysValue = "V";
		calcVE(nProfileIndex);
		if (strPrevMod == "")
			strElementIds += event + "_2_" + strCol;
	}
	else if (strModPhysValue == "V")	{
		calcNE(nProfileIndex);
		if (bDrehzahlVisible && strPrevMod == "")
			strElementIds += event + "_9_" + strCol;
	}
	setstring("CURRENTMODIFIED", strPhasePath, strModPhysValue)

	nNextProfileIndex = nProfileIndex + 1
	setint("RESETSTART", strProfilePath, nNextProfileIndex)
	bRet = execute(strProfilePath, "RESET")

	for i = 0 to nProfileIndex
	{
		bRet = execute(strProfilePath + "." + i, "CALCFINALVALUES")
		bRet = execute(strProfilePath + "." + i, "CALCCURVELENGTH")
	}
	bRet = execute(strProfilePath, "CALCQS")
	bRet = execute(strProfilePath, "CALCQT")
	bRet = execute(strProfilePath, "CALCTOTALCURVELENGTH")

	dTe		= getdouble("TE.VALUE", strPhasePath)
	dTDelta = getdouble("DELTAT.VALUE", strPhasePath)
	dVa		= getdouble("VA.VALUE", strPhasePath)
	dVe		= getdouble("VE.VALUE", strPhasePath)
	dSe		= getdouble("SE.VALUE", strPhasePath)
	strNextPhasePath = strProfilePath + "."+ nNextProfileIndex
	setdouble("TA.VALUE", strNextPhasePath, dTe)
	setdouble("VA.VALUE", strNextPhasePath, dVe)
	setdouble("SA.VALUE", strNextPhasePath, dSe)
	bDlgOK = 1
	if (((dVa < 0) and (dVe > 0)) or ((dVa > 0) and (dVe < 0)))
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS",translate("MSG_ZEROS_IN_V"))
		bDlgOK = 0
	}
	else
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS","")
	}
	if (dTDelta < 0)
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS",translate("MSG_POSVALUESONLY_IN_T"))
		bDlgOK = 0
	}
	if (bDlgOK == 0)
	{
		setstring("INPUT_FOCUS", "DLGDATA.DYNZYKLUS", eventPar)
	}
	setint("BDLGOK", "DLGDATA.DYNZYKLUS", bDlgOK)
	
	specialexec("DRAW_MP");
    CDialogBase	dlg;
    if (getstring("PREVMODIFIED", strPhasePath) != "")	{
		for (nRow = 2; nRow < 6; ++nRow)	{
			strElementIds += event + "_" + nRow + "_" + strCol + "|";
		}
		if (bDrehzahlVisible)	{
			nRow = 9;
			strElementIds += event + "_" + nRow + "_" + strCol + "|";
		}
		strElementIds += "IDC_DYNZYKLUS_IMG|IDC_INIT_MSG";
	}
	if (strElementIds != "")	{
		strResult = dlg.getDialogElementEx("IDD_DYNZYKLUS", strElementIds);
		nActCol = 0 + strCol;
		for (i = 3; i <= nActCol; ++i)	{
			strTmpProfilePath = strProfilePath + "." + (i - 3);
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_6_"  + i, getstring("QS.VALUE", strTmpProfilePath));
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_7_"  + i, getstring("QT.VALUE", strTmpProfilePath));
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_8_"  + i, getstring("TOTALCURVELENGTH.VALUE", strTmpProfilePath));
		}
		return strResult;
	}
	else
		return 2;
}

getRowIndex(event, eventPar)
{
	strRet = eventPar.replace((event + "_"), "");
	astrRet = strRet.split("_");
	return 0 + astrRet[0];
}

onUnitChanged()
{
	eventPar	= getdlgvar("EKSUBMITEVENTPAR");		# Event aus der aktuellen Maske	
	nRow = getRowIndex("IDC_DYNZYKLUS_COMBOBOX", eventPar);
	
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	if (nRow == 9)	{	// Einheit Drehzahl in allen Phasen aendern
		strUnit = getstring("N_PROTOTYPE.UNIT", strProfilePath);
		nAnz = 18;
		for (i = 0; i < nAnz; ++i)	{
			strTmpProfilePath = strProfilePath + "." + i;
			setstring("NE.UNIT", strTmpProfilePath, strUnit);
			setstring("NM.UNIT", strTmpProfilePath, strUnit);
		}
	}
	
    CDialogBase	dlg;
	strElementIds = getRowEditIds(nRow);
	strResult = dlg.getDialogElementEx("IDD_DYNZYKLUS", strElementIds);
	if (nRow == 4)	{	// Weg -> Verfahrweg mitaendern!
		for (i = 3; i <= 20; ++i)	{
			strTmpProfilePath = strProfilePath + "." + (i - 3);
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_8_"  + i, getstring("TOTALCURVELENGTH.VALUE", strTmpProfilePath));
		}
	}
	strPQ = getPQFromTabRow(nRow);
	strCtrlID = "IDC_DYNZYKLUS_" + strPQ + "_UNIT2";
	strResult += dlg.updateTableCellClient(strCtrlID, "[" + getstring(strPQ + "_PROTOTYPE.UNIT.VALUE", strProfilePath) + "]");
	return strResult;
}

//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");
	if (strIntEvent == "INIT")	{
		initDynZyklus();	
		specialexec("DRAW_MP");
	}
		
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_DYNZYKLUS_EDIT":
		return onEditChanged();
		break;
	case "IDC_DYNZYKLUS_COMBOBOX":
		return onUnitChanged();
		break;
	
	}
/*	
    CDialogBase	dlg;
	switch (event)	{
	case "IDC_DYNZYKLUS_COMBOBOX_2_2":
		strElementIds = getRowEditIds(2);
		strResult = dlg.getDialogElementEx("IDD_DYNZYKLUS", strElementIds);
		return strResult;
		break;
	}
*/	
}