 // EASYGUITRANSFORM_BASE_OBJ / EKEasyGuiTransform
//
// Auflauf:
// Nach einem Submit erwartet der Browser eine neue HTML-Seite.
// Das "PROCESS.b" Script liefert die Dialog-Id fr den neuen Screen.
//
// 1. C++ ==> EasyScript  
// "EASYGUITRANSFORM.b" wird von C++ aus gestartet (von EKCatalogSystem oder
// CEKCustomHTMLDialog ) und soll den Lauf der beiden kombinierten 
// XML-Parser vorbereiten.
//
// 2. EasyScript ==> C++
// In transform() erfolgt der Sprung zurck nach C++ durch
//  easyguixmlparser() und aus dem Template-File m_pathInFile/m_DialogId
// wird die HTML Datei m_pathOutFile erzeugt. Durch Handlerfunktionen kann
// es zu sehr vielen Sprngen in's Script und zurck kommen.
// 3. C++ ==> EasyScript
//
// Das Ergebnis von "EASYGUITRANSFORM.b" ist der Pfad zum neu erzeugten
// HTML-File und wird an den Browser weitergeleitet.
// 4. EasyScript ==> C++
// -pf-


class EasyGuiTransformBaseObj
{
	var m_storageRootPath;
	var m_storagePath;
	var m_pathMapFiles;
	var m_DialogId;
	var m_pathInFile;
	var m_pathOutFile;
    var m_easyguiMode;
	var m_easyguiXPMode;
	var m_guiPath;
	var m_bAutoStyle;
	var m_bUtf8;
	var m_TempDir;
	var m_ProgDir;
	var m_ResultType;
	var m_bCdMode;
	var m_bCdSocketMode;
	var m_hostPort;
	var m_hostUrl;
	var m_aliasMethod;
	var m_reqURL;
	var m_reqContentType;
	var m_pathCustomMapFiles;

	
	EasyGuiTransformBaseObj()
	{
        uiSystem=tolower(getstring("CATALOG.UI.SYSTEM","ROOT"));
        if(uiSystem!="")
        {   // Eintrag in catalog.xws vorhanden
            m_easyguiMode= uiSystem=="easygui";
            m_easyguiXPMode= uiSystem=="easyguixp";
        }
        else
        {   // autoconfig
            m_easyguiMode=readfile("easygui/maps/components.map")!="";
            m_easyguiXPMode=readfile("easyguiXP/maps/components.map")!="";
			mode= m_easyguiXPMode ? "easyguixp" : m_easyguiMode ? "easygui" : "isycat";
            setstring("CATALOG.UI.SYSTEM","ROOT", mode);
        }
        
        m_guiPath = m_easyguiXPMode ? "easyguiXP" : m_easyguiMode ? "easygui" : "isycat";
		m_bAutoStyle = m_easyguiXPMode ? true : false;
		
		m_TempDir=trimright(getstring("CATALOG.HTMLTEMP","ROOT"),dirsep())+dirsep();
		m_bCdMode=tolower(getstring("CATALOG.INTERNETSERVERINCDMODE","ROOT"))=="true";
		m_bCdSocketMode=tolower(getstring("CATALOG.CDSOCKETMODE","ROOT"))=="true";
		m_ProgDir=getstddirectory("PROGRAM_SHORT"); 
		if(m_ProgDir=="")
		{	// Falls die Parameter "PROGRAM_SHORT" und "PROGRAM_UTF8" noch nicht funktionieren.
			// "PROGRAM_SHORT" sollte zu "PROGRAM" werden falls das '~' Zeichen keinen rger macht.
			m_ProgDir=getstddirectory("PROGRAM");
		}
		
		m_hostPort=getstring("CATALOG.PORT","ROOT");
		m_hostUrl= m_bCdMode ? "http://localhost:"+m_hostPort+"/" : "";
		
		if(!checkexist("CATALOG.ENCODING.SCREEN","ROOT"))
			setstring("CATALOG.ENCODING.SCREEN","ROOT","utf-8");
		m_bUtf8=tolower(getstring("CATALOG.ENCODING.SCREEN","ROOT"))=="utf-8";
		
		if(!checkexist("CATALOG.UI.INTERNALTRANSFORM","ROOT"))
			setstring("CATALOG.UI.INTERNALTRANSFORM","ROOT","false");	// xml output als default
		m_bInternalTransform=tolower(getstring("CATALOG.UI.INTERNALTRANSFORM","ROOT"))!="false";

		m_pathMapFiles=m_guiPath+"/maps/";
		
		if (checkexist('CATALOG.UI.CUSTOM_MAP_PATH','ROOT'))
			m_pathCustomMapFiles=getstring('CATALOG.UI.CUSTOM_MAP_PATH','ROOT');
			
		if ( m_pathCustomMapFiles == '' )
			m_pathCustomMapFiles = m_pathMapFiles;
			
		m_storageRootPath="EASYGUI";
		m_storagePath="EASYGUITRANSFORM";
	
		m_reqURL=getdlgvar("REQUEST_URL");				// Im Servermode als Ziel fr Action
		m_reqContentType=getdlgvar("REQUEST_URL");		// Was soll erzeugt werden?
				
		m_pathInFile=getstring("INFILE",m_storagePath);	// Parameter fr EasyGuiTransform
		m_DialogId=getstring("DLG_ID",m_storagePath);	// Parameter fr EasyGuiTransform
		if(!checkexist("RESULT_TYPE",m_storagePath))
			m_ResultType="AUTO";
		else
			m_ResultType=getstring("RESULT_TYPE",m_storagePath);
		

		// Soll XML oder HTML erzeugt werden?
		if (right(m_pathInFile, 4) == ".htm")	{
			m_pathOutFile=gettempfile(m_TempDir,"htm");	// HTML erzeugen
		}
		else if( m_ResultType=="HTML" && m_bInternalTransform==true )
		{
			m_pathOutFile=gettempfile(m_TempDir,"htm");	// HTML erzeugen
		}
		else
		{
			m_pathOutFile=gettempfile(m_TempDir,"xml");	// XML erzeugen
		}
		
		
		if(!checkexist(m_storageRootPath,"ROOT"))
		{	// Init nur einmal durchfhren oder nach delete("EASYGUI","ROOT");
			importMaps();
			prepareAliasReplace("FILE");
			prepareAliasReplace("RELATIVE");		
			initSpecialComponents();
		}
        
        
        if(!checkexist("CATALOG.UI.FORMATOUTPUT","ROOT"))
        {	// CATALOG.UI.FORMATOUTPUT:
			// "false"=klein,schnell (Ist dem Browser egal wie es aussieht) 
			// "true"=normale Ausgabe, schnell 
			// "full"=fr's Bilderbuch, langsamer (aber viel schneller als mit php)
			// Vergleich Dateigre: "false"=191KB, "true"=200KB, "full"=202KB
            formatOutput("true");
        }


		// Wie sollen die Aliase im Html ersetzt werden?
		m_aliasMethod= checkexist("ALIAS_METHOD",m_storagePath) ? getstring("ALIAS_METHOD",m_storagePath) : "";
		delete("ALIAS_METHOD",m_storagePath); // "Einwegparameter"`
		
		if( m_aliasMethod!="FILE" && m_aliasMethod!="RELATIVE" )
		{	// automatisch whlen
			m_aliasMethod= !m_bCdMode || (m_bCdMode && m_bCdSocketMode) ? "RELATIVE" : "FILE";
		}
	
		// und setzen
		setalias("ROOT"~m_storageRootPath~"REPLACE_TABLE", m_aliasMethod~"REPLACE_TABLE");
	}
	
	
	
	
    // override function
	initSpecialComponents()
	{
		// addHandler("button", "handleButton"); 
	}
	
	
	
	
	prepareAliasReplace(aliasMethod)
	{
		// -pf- Alle mglichen Alias Ersetzungen vorbereiten.
		setalias("ROOT"~m_storageRootPath~"REPLACE_TABLE", aliasMethod~"REPLACE_TABLE");
		
		storageAliasTablePath=m_storageRootPath~"REPLACE_TABLE";
		if(getsize(storageAliasTablePath,"ROOT")>0)
			return true;
		
		progDir=replace(m_ProgDir, "\\", "/");
		n=0;
		nAlias=getsize("CATALOG.ALIAS","ROOT");
		for(i=0;i<nAlias;i++)
		{
			itIN=arraypath("CATALOG.ALIAS",i);
			
			NAME=getstring(itIN~"NAME","ROOT");
			PATH=replace(getstring(itIN~"PATH","ROOT"), "\\", "/")+"/";
			
			if(aliasMethod=="RELATIVE")
			{	// Den Alias nicht ersetzen wenn Pfad ausserhalb
				// vom Programmverzeichnis ( z.B. temp Verzeichnis )
				PATH= find(PATH,progDir)>0 ? replace(PATH, progDir, "") : "/"+NAME+"/";
			}
			
			itOUT=arraypath(storageAliasTablePath,n++);
			setstring(itOUT~"SEARCH","ROOT", "/"+NAME+"/" );
			setstring(itOUT~"REPLACE","ROOT", PATH);
			
			// same pattern with backslash ...
			itOUT=arraypath(storageAliasTablePath,n++);
			setstring(itOUT~"SEARCH","ROOT", "/"+NAME+"\\" );
			setstring(itOUT~"REPLACE","ROOT", PATH);
		}
		
		
		if(m_bCdMode)
		{	// Im CD-Modus das Target ndern
			strPort=getstring("CATALOG.PORT","ROOT");
			
			// easygui target replace
			addAlias("action=\"index.php\"", 	"action=\"http://localhost:"+strPort+"/easygui.plso\"");
			addAlias("action=\"easygui.php\"", 	"action=\"http://localhost:"+strPort+"/easygui.plso\"");
			// isycat target replace
			addAlias("/isycat/isycat.php", 		"http://localhost:"+strPort+"/isycat.plso");
		}
		else
		{	// Im Server-Modus ist das Target immer index.php
			// easygui target replace
			
			//addAlias("action=\"index.php\"", 	"action=\"/\"");
			//addAlias("action=\"easygui.php\"",	"action=\"/\"");

			addAlias("action=\"index.php\"", 	"action=\""+m_reqURL+"\"");
			addAlias("action=\"easygui.php\"",	"action=\""+m_reqURL+"\"");
			
			//addAlias("action=\"index.php\"", 	"action=\"index.php\"");
			//addAlias("action=\"easygui.php\"","action=\"index.php\"");
			// isycat target replace
			addAlias("/isycat/isycat.php", 		"index.php");
		}
	}
	
	
	
	
	
	importMap(filename,storageSubPath);
	{
		storageMapPath=m_storageRootPath~"MAP_"+storageSubPath;
		
		CONTENT=readfile(m_pathMapFiles+filename);
		rows=stringtoarray(CONTENT,m_storagePath~"FILE","\n");
		
		for(i=0 ; i<rows ; i++)
		{
			IT=arraypath(m_storagePath~"FILE",i);
			CONTENT=trimright(getstring("VALUE",IT),"\r");
			CONTENT=trimright(CONTENT,"|");
			
			if( (POS=find(CONTENT,"|"))>0 )
			{
				KEY=mid(CONTENT,1,POS-1);
				VAL=right(CONTENT,strlen(CONTENT)-POS);

				if( m_easyguiMode )
				{	// easygui aliase
					strPrefix= m_bCdMode ? m_ProgDir : "";
					VAL=replace(VAL,"css/",strPrefix+m_guiPath+"/css/");
					VAL=replace(VAL,"js/", strPrefix+m_guiPath+"/js/");
					VAL=replace(VAL,"gfx/",strPrefix+m_guiPath+"/gfx/");
				}
				VAL=replace(VAL,"%c%",KEY);
				
				setstring(storageMapPath~KEY,"ROOT",VAL);
			}
		}
        delete(m_storagePath~"FILE","");
	}
	
	

	importScriptMap(filename,storageSubPath)
	{
		storageMapPath=m_storageRootPath~"MAP_"+storageSubPath;
		
		CONTENT=readfile(m_pathMapFiles+filename);
		CONTENT=CONTENT.replace("\r\n","\n");
		
		eval( CONTENT );
		
		if(typeof($components) != 'object')
			return false;
			
		addUserComponents($components);

		for( KEY in $components)
		{
			VAL = $components[KEY];
			VAL = VAL.replace("%c%",KEY);
			VAL = VAL.replace("(label|text)", "%label%%text%");
			
			setstring(storageMapPath~KEY,"ROOT",VAL);
		}
		
		CUSTOM = readfile(m_pathCustomMapFiles+'/custom.map')
		CUSTOM = CUSTOM.replace("\r\n","\n");
		
		eval(CUSTOM);
		
		if ( typeof ($custom) == 'object') {
			for( KEY in $custom ) {
				VAL = $custom[KEY];
				VAL = VAL.replace("(label|text)","%label%%text%");
				
				setstring(storageMapPath~KEY,"ROOT",VAL);
			}
		}
		
		return true;
	}


	importMaps()
	{
		if( m_easyguiXPMode )
        {
			if(!importScriptMap("components.map.b","COMPONENTS") )
				importMap("components.map","COMPONENTS");
				
            importMap("attributes.map","ATTRIBUTES");
            importMap("events.map","EVENTS");
            importMap("styles.map","STYLES");
            importMap("defaults.map","STANDARDS");
        }
        else if(m_easyguiMode)
        {
            importMap("attributes.map","ATTRIBUTES");
            importMap("components.map","COMPONENTS");
            importMap("events.map","EVENTS");
            importMap("styles.map","STYLES");
            importMap("defaults.map","STANDARDS");
        }
        else
        {
			if(!importScriptMap("components.b","COMPONENTS") )
				importMap("components","COMPONENTS");
				
            importMap("attributes","ATTRIBUTES");
            importMap("events","EVENTS");
            importMap("styles","STYLES");
            importMap("standards","STANDARDS");
        }
		
		// jetzt noch ein paar Standardwerte
		strPort=getstring("CATALOG.PORT","ROOT");
		build=readinistring(m_guiPath+"/easygui.ini", "" /*keine Section?*/, "build");
		version=readinistring(m_guiPath+"/easygui.ini", "" /*keine Section?*/, "version");
		strCharset=getstring("CATALOG.ENCODING.SCREEN","ROOT");
		documentclosedimg=getDefaultValue("documentclosedimg");
		folderclosedimg=getDefaultValue("folderclosedimg");
		
		setDefaultValue("port",strPort);
		setDefaultValue("appencoding",strCharset=="" ? "utf-8" : strCharset);
		setDefaultValue("appmode","ek_cdrom");
		setDefaultValue("build",build=="" ? "r3" : build );
		setDefaultValue("version",version=="" ? "1.0" : version);
		setDefaultValue("treeimg",folderclosedimg);
		setDefaultValue("ul", "\n<ul style=\"display:none\">\n");
		setDefaultValue("endul", "</ul>");
		setDefaultValue("text", ""); // Gute Idee oder nicht?!?
		
		
		if( m_easyguiXPMode )
		{
			if( m_bCdMode && !m_bCdSocketMode )
				EK_PATH=replace(m_ProgDir+m_guiPath, "\\", "/");
			else
				EK_PATH=replace(m_guiPath, "\\", "/");
				
			setDefaultValue("EK_PATH", EK_PATH );
			setDefaultValue("EK_ENCODING", strCharset=="" ? "utf-8" : strCharset );
			setDefaultValue("APPMODE", "ek_cdrom" );
			setDefaultValue("EK_VERSION", "XP" );
			setDefaultValue("EK_BUILD", "1" );
			setDefaultValue("EK_REVISION", "Revision: 100" );
			setDefaultValue("EK_SUBMIT_TARGET", "easygui.php" );
			setDefaultValue("EK_SESSNAME", "" );
			setDefaultValue("APP_LANG", getstring("EKCURRENTLANGUAGE","") );
			setDefaultValue("EK_SESSID", getstring("sessionid","") );
		}
	}
	
	setDefaultValue(key, value)
	{
		setstring(m_storageRootPath~"MAP_STANDARDS"~key, "ROOT", value);
	}



	getDefaultValue(key)
	{
		return getstring(m_storageRootPath~"MAP_STANDARDS"~key, "ROOT");
	}



    formatOutput(format)
    {
        setstring("CATALOG.UI.FORMATOUTPUT","ROOT", format);
    }
	
	addAlias(alias,repl)
	{
		tabPath=m_storageRootPath~"REPLACE_TABLE";
		pathNewAlias=arraypath(tabPath, getsize(tabPath,"ROOT"));
		setstring(pathNewAlias~"SEARCH", "ROOT", 	alias);
		setstring(pathNewAlias~"REPLACE", "ROOT", 	repl);
	}



	addHandler(COMPONENT_TAGNAME,HANDLERFUNCTION)
    {
        setstring(m_storageRootPath~"SPECIAL_COMPONENTS"~COMPONENT_TAGNAME,"ROOT",HANDLERFUNCTION);
    }    

	
	transform()
	{
		// Altes Temp File lschen 
		bDeleteOldFiles = 0
		if( bDeleteOldFiles && m_bCdMode && !m_bCdSocketMode )
			r=filecommand("unlink",getstring("EKHTMLTEMPFILE",""));
			
		setstring("EKHTMLTEMPFILE","",m_pathOutFile);
				
		// Das Parser-Duo CXMLSAXBuilder & EKEasyGuiTransform starten...
		// In: m_pathInFile (Template) / m_DialogId
		// Out: m_pathOutFile (Erzeugte Html oder XML Datei)
		easyguixmlparser();
		
		return m_pathOutFile;
	}
}
