///////////////////////////////////////////////////////////
// Input:
// PATH		 	= Pfad bzw. die URL
// HEADER 		= Request-Header
// CONTENT		= Request-Content (kann auch leer sein)
// 
// Output:
// RESULT		= Response (Content)
// MIMETYPE		= Response Mime-Type also z.B. text/plain (default), text/html, text/xml, ...
//
// return 1		= Request wurde hier verarbeitet
// return 0		= Normaler EasyKat Request

#include "HANDLE_REQUEST_BASE_OBJ"
#include "PROJECTLIST.b"
#include "FAVORITELIST.b"
#include "REQUESTHANDLER_IDD_OFFER.b"
#include "BOM_RTF_PDF_LOADER.b"
#include "PDF_GENERATOR.b"
#include "PDF_MANAGER.b"
#include "RTF_GENERATOR.b"
#include "OFFER_MANAGEMENT.b"
#include "OFFER_PRINTER_PDF.b"
#include "OFFER_PRINTER_RTF.b"
#include "SEARCHENGINE.b"
#include "DETAILS.b"
#include "READCONFIGDATA.b"
#include "PRODUCTS.b"
#include "EMAIL.b"
#include "CfgCtrlTableLoader.b"
#include "REQUESTHANDLER_PRINTING.b"
#include "REQUESTHANDLER_SAVING.b"
#include "CFGSUMMARY_BUILDER.b"


///////////////////////////////////////////////////////////
// Handler Klassen
///////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////
// Handler zum ffnen eines Dokuments
///////////////////////////////////////////////////////////
class ajaxOpenDocument : public httpRequestHandler
{
	ajaxOpenDocument()
	{
		httpRequestHandler("ajax/open_document");
	}
	
	execRequest(reqMap, requestObj)
	{
		f=reqMap.getVal("f");
		
		if( CDMode() )
		{	// Im CD-Modus direkt ffnen
			shellexecute(f,"","");	
			m_result="";
		}
		else
		{	// Pfad zurck
			m_result=f;	
		}
		
		return true;
	}
}


///////////////////////////////////////////////////////////
// Handler zum Kopieren von Daten in die Zwischenablage
///////////////////////////////////////////////////////////
class copy2Clipboard : public httpRequestHandler
{
	copy2Clipboard()
	{
		httpRequestHandler("ajax/copy2clipboard");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		// elementIds=reqMap.getVal("elementids");

		initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		// setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		// setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		// setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		// setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		// ekstoragesubmit();
		// processEvents(dialogId, eventId);
		
		m_result=BuildBezeichnung();
		// logtraceln("BuildBezeichnung: " + m_result);
		return m_result!="";
	}
}

///////////////////////////////////////////////////////////
class submitDlgElement : public httpRequestHandler
{
	submitDlgElement()
	{
		httpRequestHandler("ajax/submit_dialog_elements");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		// elementIds=reqMap.getVal("elementids");

		// initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		// setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		// setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		// setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		// setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		ekstoragesubmit();
		// processEvents(dialogId, eventId);
		
		m_result = scriptexec("BuildDlgVars"); // BuildBezeichnung();
		// logtraceln("BuildBezeichnung: " + m_result);
		return m_result!="";
	}
}

///////////////////////////////////////////////////////////
// Handler zum ffnen eines "Speichern / Laden" Fensters
///////////////////////////////////////////////////////////
class FileDialog : public httpRequestHandler
{
	FileDialog()
	{
		httpRequestHandler("ajax/filedialog");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		// elementIds=reqMap.getVal("elementids");

		initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		// setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		// setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		// setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		// setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		// ekstoragesubmit();
		// processEvents(dialogId, eventId);
		if (eventId == "IDC_BEZINTEXTDATEI")
			strResult = BuildBezeichnung();
		if (CDMode())
		{
			strRetPath = filedialog(0, "txt", "", "Text Files (*.txt)|*.txt|All Files(*.*)|*.*|", "");
			m_result = "";
		}
		else
		{
			strTmpAlias = "/tmp/";
			strDir = GetAbsPath(strTmpAlias);
			strRetPath = gettempfile(strDir, "txt");
			m_result = replace(strRetPath, (strDir + "\\"), strTmpAlias);
		}
		if (strRetPath != "")
		{
			write(strRetPath, strResult);
		}
        
		// logtraceln("BuildBezeichnung: " + m_result);
		return 1; // m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler zum Einlesen einer Datei
///////////////////////////////////////////////////////////
class ajaxGetFile : public httpRequestHandler
{
	ajaxGetFile()
	{
		httpRequestHandler("ajax/getfile");
	}
	
	execRequest(reqMap, requestObj)
	{
		f=reqMap.getVal("f");
		
		m_result=readfile(f);
		return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler zum dynamischen Austauschen von Teilen
// eines beliebigen Dialogs. Wird ber die Java-
// Script-Funktion "updateDialogElement" aufgerufen
///////////////////////////////////////////////////////////
class updateDialogElement : public httpRequestHandler
{
	updateDialogElement()
	{
		httpRequestHandler("ajax/update_dialog_element");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		elementIds=reqMap.getVal("elementids");
		
		//initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		
		ekstoragesubmit();
		m_result = processEvents(dialogId, eventId);
		if (m_result == "" || m_result == 0 || m_result == 1)
		{
			m_result=getDialogElement(dialogId, "HTML", elementIds, "FILE");
			m_result=readfile(m_result);
		}
		
		// m_result=getDialogElement(dialogId, "HTML", elementIds, "");
		// m_result=readfile(m_result);
		return m_result!="";
	}
}

///////////////////////////////////////////////////////////
class clickHandler : public httpRequestHandler
{
	clickHandler()
	{
		httpRequestHandler("ajax/click");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		elementIds=reqMap.getVal("elementids");

		initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		ekstoragesubmit();

		/*
		alert(eventId);
        switch(eventId)
        {
            case "WM_CLOSE":
				alert("gaga");
				return 0;
        }
		*/

		m_result = processEvents(dialogId, eventId);
		if (m_result == "" || m_result == 0 || m_result == 1)
		{
			m_result=getDialogElement(dialogId, "HTML", elementIds, "FILE");
			m_result=readfile(m_result);
		}
		return m_result!="";
	}
}

///////////////////////////////////////////////////////////
class sendToServerHandler : public httpRequestHandler
{
	sendToServerHandler()
	{
		httpRequestHandler("ajax/sendToServer");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId=reqMap.getVal("sessionid");
		stateId=reqMap.getVal("stateid");
		dialogId=reqMap.getVal("dialogid");
		eventId=reqMap.getVal("eventid");
		elementIds=reqMap.getVal("elementids");

		initdlgvars(requestObj.m_reqContent); 	// DlgVars aus den POST Daten
		setsessionpath(getsessionpath(sessionId));
		setsessiondialogid(sessionId, stateId, dialogId);
		
		setstring("EVENT","", eventId);
		setstring("EKSUBMITEVENT","", eventId);
		setstring("EKSUBMITEVENTPAR1","", getdlgvar("EKSUBMITEVENTPAR1"));
		setstring("EKSUBMITEVENTPAR2","", getdlgvar("EKSUBMITEVENTPAR2"));
		setstring("EKSUBMITEVENTPAR3","", getdlgvar("EKSUBMITEVENTPAR3"));
		setstring("EKSUBMITEVENTPAR4","", getdlgvar("EKSUBMITEVENTPAR4"));
		
		setstring("AKTUELLE_MASKE", "", dialogId);
		ekstoragesubmit();

		m_result = processEvents(dialogId, eventId);
		if (!m_result) {
			scriptexec ("sendToServerGeneralHandler.b");
		}

		return true;
	}
}

///////////////////////////////////////////////////////////
// Handler, der die Combobox-Tabelle neu aufbaut, nachdem
// in einer der Comboxen die Auswahl verndert oder der
// Produkttab angeklickt wurde
///////////////////////////////////////////////////////////
class rebuildComboboxTable : public httpRequestHandler
{
	rebuildComboboxTable()
	{
		httpRequestHandler("ajax/rebuildComboboxTable");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = reqMap.getVal("sessionid");
		stateId    = reqMap.getVal("stateid");
		dialogId   = reqMap.getVal("dialogid");
		eventId    = reqMap.getVal("eventid");
		elementIds = reqMap.getVal("elementids");
		stylePath = "DLGDATA.DLGVARS.EASYKATLIGHT.STYLEVARS";
		
		//setsessionpath(getsessionpath(sessionId));
		//setsessiondialogid(sessionId, stateId, dialogId);
		
		//setstring("AKTUELLE_MASKE", "", dialogId);
		
		ekstoragesubmit();
		//processEvents(dialogId, eventId);
		
		# Neuerzeugen der Combobox-Tabelle des Produkt-Tabs
		productTabBuilder = new productTabGenerator(stylePath);
		setdlgvar("COMBOBOX_TABLE", productTabBuilder.getComboboxTable("DATA"));
		
		m_result=getDialogElement(dialogId, "HTML", elementIds, "FILE");
		m_result=readfile(m_result);
		
			return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler zum Anpassen des Merkmalfilters des Pro-
// fukt-Dialogs (Combobox-Tabelle) bei Neuaufbau
// des Dialogs oder nderung einer Combobox-Aus-
// wahl.
///////////////////////////////////////////////////////////
class getComboboxTable_NoAjax : public httpRequestHandler
{
	getComboboxTable_NoAjax()
	{
		httpRequestHandler("ajax/getComboboxTable_NoAjax");
	}
	
	execRequest(reqMap, requestObj)
	{
		# Storepfad der CSS-Style-Bezeichnungen
		stylePath = "DLGDATA.DLGVARS.EASYKATLIGHT.STYLEVARS";
		
		# Store-Submit durchfhren
		ekstoragesubmit();
		
		# Combobox-Tabelle generieren
		productTabBuilder = new productTabGenerator(stylePath);
		setdlgvar("COMBOBOX_TABLE", productTabBuilder.getComboboxTable("DATA"));
		
		# Combobox-Tabelle in HTML umwandeln
		filePath = getDialogElement("IDD_PRODUCT", "HTML", "COMBOBOX_TABLE_CONTAINER", "FILE");
		
		#<body onload="parent.updateDialogElementExec(document.body.innerHTML);">
		
		# Tabelle in den easyIFrame senden und
		# per JavaScript im Dialog ersetzen.
		m_result = <<inputEnd
			<html><meta http-equiv='content-type' content='text/html; charset=utf-8'>
				<head>
					<script type="text/javascript" id="Script" src="catalog/System/SCRIPTS_CLIENT/dynrequest.js"></script>
				</head>
			<body onload="updateComboboxTableWidget();">
			
			<script>
				function updateComboboxTableWidget()
				{
					// Remember how many levels you have to
					// rise to reach the ComboboxTable widget
					var parentVariable = "parent";
					
					//  Check, if the ComboboxTable widget is
					//  accessible in the current document level
					var comboboxTableWidget = eval(parentVariable).document.getElementById('PRODUCT_COMBOBOX_TABLE_TABLE');
					
					var i = 1;
					
					//  Rise up to five levels to reach
					//  the ComboboxTable widget
					while(comboboxTableWidget == null && i <= 5)
					{
						parentVariable = parentVariable + ".parent";
						i = i + 1;
						
						comboboxTableWidget = eval(parentVariable).document.getElementById('PRODUCT_COMBOBOX_TABLE_TABLE');
						
						if(comboboxTableWidget != null)
							break;
					}
					
					// If the ComboboxTable widget got
					// found, update it
					if(comboboxTableWidget != null)
						eval(parentVariable).updateDialogElementExec(document.getElementById("Combobox_Table_Data").innerHTML);
				}
			</script>
			
			<div id="Combobox_Table_Data">
				$replace(readfile(filePath), "﻿", "")$
			</div>
			
			</body></html>
		inputEnd;
		
		return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler, der ein Produkt zum Warenkorb hinzufgt.
///////////////////////////////////////////////////////////
class addToShoppingCart : public httpRequestHandler
{
	addToShoppingCart()
	{
		httpRequestHandler("ajax/addToShoppingCart");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
		artNr      = reqMap.getVal("artNr");
        cfgProduct = reqMap.getVal("cfgProduct");
        lastDialog = reqMap.getVal("lastDialog");
		unitPrice  = reqMap.getVal("unitPrice");
        typecode   = reqMap.getVal("typecode");
        
		setsessionpath(getsessionpath(sessionId));
		//setsessiondialogid(sessionId, stateId, dialogId);
		
		ekstoragesubmit();
		
        # Falls es sich um ein Standardprodukt handelt
        if(cfgProduct == "false")
		{
            setstring("EVENT","", artNr);
            setstring("EKSUBMITEVENT","", artNr);
            
            setstring("ARTNR", "DLGDATA.PRODUCT.POSDATA", artNr);
            
			# Preis in einem Techwert-Objekt wegspeichern,
			# damit die Whrung umgestellt werden kann
			createobject("DLGDATA.PRODUCT.POSDATA", "UNIT_PRICE", 49);
			CopyOperator("OPERATORS.P_CURRENCY", "DLGDATA.PRODUCT.POSDATA.UNIT_PRICE.OPERATOR");
			setdouble("UNIT_PRICE.RAW", "DLGDATA.PRODUCT.POSDATA", unitPrice);
            
			# Detail-Ident des Produktes herausfinden (falls vorhanden)
			strDetailSelect = "SELECT ELC_IDENT_DETAILS FROM ELT_PRODUCT WHERE ELC_ARTNR = '" + artNr + "'";
			
			numDetailIds = dbselect("SYSTEM_DB", strDetailSelect, "RS_DetailId");
			
			if(numDetailIds == 1)
				setstring("DETAILS_IDENT", "DLGDATA.PRODUCT.POSDATA", dbgetstring("RS_DetailId", "ELC_IDENT_DETAILS"));
			else if(numDetailIds > 1)
				print("Fehler beim Suchen der Detail-Idents - Es wurden " + numDetailIds + " Idents gefunden !");
			
            # Festhalten, dass es sich um kein konfiguriertes Produkt handelt
            setstring("CONFIGURED_PRODUCT", "DLGDATA.PRODUCT.POSDATA", cfgProduct);
        }
        
        # Falls es sich um ein konfiguriertes Produkt handelt
        if(cfgProduct == "true")
        {
            setstring("EVENT","", "projlist_addCfgProduct");
            setstring("EKSUBMITEVENT","", "projlist_addCfgProduct");
            
            # Festhalten, dass es sich um ein konfiguriertes Produkt handelt
            setstring("CONFIGURED_PRODUCT", "DLGDATA.PRODUCT.POSDATA", cfgProduct);
			setstring("DETAILS_IDENT", "DLGDATA.PRODUCT.POSDATA", "<<<CFG>>>");
			
			# Speicher fr die alten Konfigurationsdaten im Store freigeben
            delete("CONFIGURATION_DATA", "DLGDATA.DLGVARS.EASYKATLIGHT");
			
			# Konfigurationsdaten zur Anzeige der Zusammenfassungs-
			# tabelle auswerten
			cfgData = new cfgDataReader();
			
			startCfgObject = new Array();
			startCfgObject.push("");
			cfgData.getConfigEntries(startCfgObject, "DLGDATA.DLGVARS.EASYKATLIGHT.CONFIGURATION_DATA", 1);
			
			# Preis so wegspeichern, dass die Whrung
			# umgerechnet werden kann
			copy("CFG_THIS.ROOTOBJ.BOM.GPREIS", "DLGDATA.PRODUCT.POSDATA.UNIT_PRICE");
        }
		
        
        # Zuletzt angezeigten Dialog zusammen mit dem Artikel merken
        setstring("MODIFY_ENTRY_SCREEN", "DLGDATA.PRODUCT.POSDATA", lastDialog);
        
        # Typenschlssel der Konfiguration je nach Parameter-Einstellung sichern
        if(getstring("TYPECODE_VISIBILITY", "DLGDATA.DLGVARS.EASYKATLIGHT.IDD_CONFIG") == "visible")
            setstring("TYPECODE", "DLGDATA.PRODUCT.POSDATA", typecode);
        
        projectListHandler = new ProjListMaintanance();
        projectListHandler.addItem();
        
        # Artikelnummer und Typenschlssel zurcksetzen, um keine unbeabsichtige
        # bernahme beim Speichern der nchsten Artikels zu veranlassen
        delete("ARTNR", "DLGDATA.PRODUCT.POSDATA");
        delete("TYPECODE", "DLGDATA.PRODUCT.POSDATA");
		
		messageText = translate("IDC_TEXT_SHOPPINGCART_NOTICE");
		
        # Meldung an Client zurckschicken, dass das Produkt nun in der
        # Projektliste ist
		m_result =<<inputEnd
			$getstring("UTF8BEGIN", "PROJECT.SETTINGS");$
            <script>
                dialog = top.frames['RFrame'].dialog;
                dialog.SHOPPINGCART_NOTICE.setText("$messageText$");
                dialog.SHOPPINGCART_NOTICE.show();
                
                setTimeout("parent.hidePopupNotice('SHOPPINGCART_NOTICE', 'RFrame')", 600);
            </script>
			$getstring("UTF8END", "PROJECT.SETTINGS");$
        inputEnd;
        
		return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler, der ein Produkt zu Favoritenliste hinzufgt,
// sofern es nicht bereits darin vorhanden ist.
///////////////////////////////////////////////////////////
class addToFavoriteList : public httpRequestHandler
{
	addToFavoriteList()
	{
		httpRequestHandler("ajax/addToFavoriteList");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
		artNr      = reqMap.getVal("artNr");
		unitPrice  = reqMap.getVal("unitPrice");
        cfgProduct = reqMap.getVal("cfgProduct");
        lastDialog = reqMap.getVal("lastDialog");
        typecode   = reqMap.getVal("typecode");
		
		favoritelistPath = "PROJECT.FAVORITELIST.FAVLIST_ITEMS";
		
		# Anzahl der Elemente in der Favoritenliste ermitteln
        numFavListItems = getsize(favoritelistPath, "");
        
		# Kennzeichnet, ob das hinzuzufgende Produkt bereits in
		# der Favoritenliste aufgefhrt ist
		isPresentInFavoritelist = false;
		
		setsessionpath(getsessionpath(sessionId));
		//setsessiondialogid(sessionId, stateId, dialogId);
		
		
        # Falls es sich um ein Standardprodukt handelt
        if(cfgProduct == "false")
		{
			# Prfen, ob das Produkt schon in der Favoritenliste ist
			for(i = 0; i < numFavListItems; i++)
			{
				if(getstring("ARTNR", favoritelistPath + "[" + i + "]") == artNr)
				{
					isPresentInFavoritelist = true;
					break;
				}
			}
        }
        
		# Sofern das Produkt noch nicht in der Liste existiert
		if(!isPresentInFavoritelist)
		{
			setstring("ARTNR", favoritelistPath + "[" + numFavListItems + "]", artNr);
			
			# Preis in einem Techwert-Objekt wegspeichern,
			# damit die Whrung umgestellt werden kann
			createobject(favoritelistPath + "[" + numFavListItems + "]", "UNIT_PRICE", 49);
			CopyOperator("OPERATORS.P_CURRENCY", favoritelistPath + "[" + numFavListItems + "]" + ".UNIT_PRICE.OPERATOR");
			setdouble("UNIT_PRICE.RAW", favoritelistPath + "[" + numFavListItems + "]", unitPrice);
			
			setstring("ISSELECTED", favoritelistPath + "[" + numFavListItems + "]", 'false');
			
			# Zuletzt angezeigten Dialog zusammen mit dem Artikel merken
			setstring("MODIFY_ENTRY_SCREEN", favoritelistPath + "[" + numFavListItems + "]", lastDialog);
			
			# Typenschlssel der Konfiguration je nach Parameter-Einstellung sichern
			if(getstring("TYPECODE_VISIBILITY", "DLGDATA.DLGVARS.EASYKATLIGHT.IDD_CONFIG") == "visible")
				setstring("TYPECODE", favoritelistPath + "[" + numFavListItems + "]", typecode);
			
			// noch nicht richtig implementiert !!!
			/*favoriteListHandler = new FavoriteListMaintenance();
			favoriteListHandler.addItem();
			
			# Artikelnummer und Typenschlssel zurcksetzen, um keine unbeabsichtige
			# bernahme beim Speichern der nchsten Artikels zu veranlassen
			delete("ARTNR", "DLGDATA.PRODUCT.POSDATA");
			delete("TYPECODE", "DLGDATA.PRODUCT.POSDATA");*/
			
			messageText = translate("IDC_TEXT_FAVORITELIST_ADDED_NOTICE");
			
			# Meldung an Client zurckschicken, dass das Produkt nun in der
			# Favoritenliste ist
			m_result =<<inputEnd
				$getstring("UTF8BEGIN", "PROJECT.SETTINGS");$
				<script>
					dialog = parent.dialog;
					dialog.FAVORITELIST_NOTICE.setText("$messageText$");
					dialog.FAVORITELIST_NOTICE.show();
					
					setTimeout("parent.hidePopupNotice('FAVORITELIST_NOTICE', 'RFrame')", 600);
				</script>
				$getstring("UTF8END", "PROJECT.SETTINGS");$
			inputEnd;
		}
		else
		{
			messageText = translate("IDC_TEXT_FAVORITELIST_DUPLICATE_NOTICE");
			
			# Meldung an Client zurckschicken, dass das Produkt bereits in der
			# Favoritenliste aufgefhrt ist
			m_result =<<inputEnd
				$getstring("UTF8BEGIN", "PROJECT.SETTINGS");$
				<script>
					dialog = parent.dialog;
					dialog.FAVORITELIST_NOTICE.setText("$messageText$");
					dialog.FAVORITELIST_NOTICE.show();
					
					setTimeout("parent.hidePopupNotice('FAVORITELIST_NOTICE', 'RFrame')", 600);
				</script>
				$getstring("UTF8END", "PROJECT.SETTINGS");$
			inputEnd;
		}
		
		return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler zum Ermitteln des Preises der Konfiguration
// unmittelbar nach deren Start (wenn noch kein Merkmal
// explizit vom Benutzer spezifiziert wurde).
// ACHTUNG: Dieser Handler wird nur dann aufgerufen,
// wenn der Konfigurations-Tab beim Eintritt in den
// Dialog ausgewhlt ist. Ist die Materialliste selek-
// tier, erfolgt ein normaler Request in den isy-
// iframe und die Aufgabe wird vom Dialog-Template
// "IDD_DDX_MATLISTTABLE.htm" erledigt !
///////////////////////////////////////////////////////////
class getCfgInitPrice : public httpRequestHandler
{
	getCfgInitPrice()
	{
		httpRequestHandler("ajax/getCfgInitPrice");
	}
	
	execRequest(reqMap, requestObj)
	{
		# Whrung und Preis des Konfigurationsobjekts
		# abfragen
		currency = getstring("UNIT", "OPERATORS.P_CURRENCY");
		price    = getstring("GPREIS.VALUE", getalias("CONFIGURATIONS_THIS") + ".ROOT.BOM");
		
		# Preis-Textfeld mit den Preisdaten fllen
		m_result = <<inputEnd
			<script>
				var dialog = parent.dialog;
				dialog.IDC_CFGPRICE.setText("$price$ $currency$");
			</script>
		inputEnd;
		
		return m_result!="";
	}
}


///////////////////////////////////////////////////////////
// Handler zum ffnen einer CAD-Zeichnung mit Caviar
///////////////////////////////////////////////////////////
class openCADDrawing : public httpRequestHandler
{
	openCADDrawing()
	{
		httpRequestHandler("ajax/openCADDrawing");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
		cadName    = reqMap.getVal("cadName");
        
		setsessionpath(getsessionpath(sessionId));
		
        # Lse den Aliasnamen "EKPages" auf
        docAliasPath = "";
        for(i = 0; i < getsize("ROOT.CATALOG.ALIAS",""); i++)
        {
            aliasArrayPath = "ROOT.CATALOG.ALIAS[" + i + "]";
            if(getstring("NAME", aliasArrayPath) == "EKPages")
            {
                docAliasPath = getstring("PATH", aliasArrayPath);
                break;
            }
        }
        
		executeString = docAliasPath + "\\" + cadName;
		
        # Lade den CAD-Viewer "Caviar" mit der angeklickten Zeichnung
        shellexecuteex("caviar.exe", docAliasPath + "\\" + cadName, getstddirectory("PROGRAM"),"1");
        
		return 1;
	}
}


///////////////////////////////////////////////////////////
// Handler zum Versand einer Anfrage-eMail des
// Kunden an den Vertrieb mit den Daten seines
// Warenkorbs. Nur aufrufbar, wenn der Konfi-
// gurator im kundenseitigen Modus luft
///////////////////////////////////////////////////////////
class sendRequestEmail : public httpRequestHandler
{
	sendRequestEmail()
	{
		httpRequestHandler("ajax/sendRequestEmail");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
        
		setsessionpath(getsessionpath(sessionId));
        
        ekstoragesubmit();
		
		# Lse den Alias "EKTemp" zum Speichern des
		# Warenkorbs auf
		tempPath = "";
		for(i = 0; i < getsize("ROOT.CATALOG.ALIAS",""); i++)
		{
			aliasArrayPath = "ROOT.CATALOG.ALIAS[" + i + "]";
			if(getstring("NAME", aliasArrayPath) == "EKTemp")
			{
				tempPath = getstring("PATH", aliasArrayPath);
				break;
			}
		}
		
		# Aktuelle Whrung der Anwendung speichern
		setstring("CURRENCY", "PROJECT.POSITIONS", setstring("PROJECT_CURRENCY", "PROJECT.SETTINGS.CURRENCY"));
		
		# Warenkorb speichern
		savexml("PROJECT", tempPath + "\\Request.xml")
		
		# Daten fr den eMail-Versand per
		# MAPI-Mail sammeln
		setstring("TO", "DLGDATA.DLGVARS.TEMP.EMAIL", getstring("MAIL", "PROJECT.SETTINGS.SALES"));
		setstring("SUBJECT", "DLGDATA.DLGVARS.TEMP.EMAIL", utf8toansi(translate("IDC_OFFER_REQUESTMAIL_SUBJECT")));
		mailText  = utf8toansi(translate("IDC_OFFER_REQUESTMAIL_BODY1")) + "\n\n" + utf8toansi(translate("IDC_OFFER_REQUESTMAIL_BODY2")) + " ";
		mailText += utf8toansi(getstring("COMPANY", "PROJECT.SETTINGS.CLIENT")) + "\n       " + utf8toansi(getstring("NAME", "PROJECT.SETTINGS.CLIENT"));
		mailText += "\n\n" + utf8toansi(translate("IDC_OFFER_REQUESTMAIL_BODY3")) + " " + getdatestring("DATE", "DLGDATA.TEMP", "%d.%m.%Y");
		setstring("TEXT", "DLGDATA.DLGVARS.TEMP.EMAIL", mailText);
		
		# XML-Anhang (Warenkorb) zippen
		zipParams = "a -tzip \"" + tempPath + "\\Request.zip\" \"" + tempPath + "\\Request.xml\"";
		shellexecuteex (getstddirectory("PROGRAM") + "\\7za.exe", zipParams, getstddirectory("PROGRAM"), 0);
		
		# ZIP-Datei an die eMail anhngen
		setstring("ATTACH", "DLGDATA.DLGVARS.TEMP.EMAIL", tempPath + "\\Request.zip");
		
		sendMAPIMail("DLGDATA.DLGVARS.TEMP.EMAIL");
		
		return 1;
	}
}


///////////////////////////////////////////////////////////
// Handler, der die Projektliste in eine CSV-Datei
// auf der Festplatte speichert
///////////////////////////////////////////////////////////
class createCSV : public httpRequestHandler
{
	createCSV()
	{
		httpRequestHandler("ajax/createCSV");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
        
		setsessionpath(getsessionpath(sessionId));
        
        ekstoragesubmit();
		
        offerManagement = new OfferManagement();
        offerManagement.getCSVOfferTable();
        
		return 1;
	}
}


///////////////////////////////////////////////////////////
// Handler zum Einblenden der Produktdetails bzw. Konfi-
// gurationsdaten in die Produkt- bzw. Warenkorb-Tabelle
///////////////////////////////////////////////////////////
class toggleDetails : public httpRequestHandler
{
	toggleDetails()
	{
		httpRequestHandler("ajax/toggleDetails");
	}
	
	execRequest(reqMap, requestObj)
	{
		sessionId  = getdlgvar("sessionid");
		stateId    = getdlgvar("stateid");
		tableRowId = reqMap.getVal("tableRowId");
		detailsId  = reqMap.getVal("detailsId");
		buttonId   = reqMap.getVal("buttonId");
		mode       = reqMap.getVal("mode");
		artNr      = reqMap.getVal("artNr");
		colspan    = reqMap.getVal("colspan");
		
		stylePath         = "DLGDATA.DLGVARS.EASYKATLIGHT.STYLEVARS";
		projectlistPath   = "PROJECT.POSITIONS.PROJECTLIST_ITEMS";
        
		# Styles fr Tabelle und <DIV>-Element laden
		detailsTableStyle = getstring('POPUPDETAILSTABLESTYLE', stylePath);
		detailsTableFrameDivStyle   = getstring('POPUPDETAILSTABLEFRAMEDIVSTYLE', stylePath);
		detailsTableContentDivStyle = getstring('POPUPDETAILSTABLECONTENTDIVSTYLE', stylePath);
		detailsTableButtonDivStyle  = getstring('POPUPDETAILSTABLEBUTTONDIVSTYLE', stylePath);
		detailsTableTableDivStyle   = getstring('POPUPDETAILSTABLETABLEDIVSTYLE', stylePath);
		
		setsessionpath(getsessionpath(sessionId));
        
        ekstoragesubmit();
		
		
		# Der Handler wird von der Produkttabelle aus aufgerufen
		if(mode == "PRODUCT")
		{
			# Artikelnummer wegspeichern, damit die Merkmale
			# in die Detail-Tabelle geladen werden knnen
			setstring("DETAILS_PRODUCT_ARTNR", "DLGDATA.TEMP", artNr);
			
			# Merker zur Ausgabe der Daten der selektierten
			# Produkttabellen-Zeile zurcksetzen
			setstring("PRINT_NO_PRODUCT_DATA", "DLGDATA.DLGVARS.EASYKATLIGHT.IDD_DETAILS", "false");
			
			# Detail-Tabelle aufbauen
			tempContent = buildDetails(detailsId, stylePath, "RAW");
			
			detailsTableContent = <<inputEnd
				<DIV class="$detailsTableButtonDivStyle$" onclick="removeDetailsTable();">
					<img id="DETAILS_TABLE_LINKBUTTON" src="/EKImage/Button/Pull_up.gif"
					 style="padding-left: 10px; cursor: hand;" onmouseover="exchangeGraphic(this);" 
					 onmouseout="exchangeGraphic(this);" onclick="removeDetailsTable();">
				</DIV>
				<DIV class="$detailsTableTableDivStyle$">
					<TABLE class="$detailsTableStyle$" onclick="removeDetailsTable();" >
					$tempContent$
					</TABLE>
				</DIV>
			inputEnd;
			
			detailsTableContent = replace(detailsTableContent, "\n", "");
			
			# Detail-Tabelle in die Projektliste einblenden
			# oder weglschen, falls bereits eingeblendet
			m_result =<<inputEnd
				$getstring("UTF8BEGIN", "PROJECT.SETTINGS");$
				<script>
					if(parent.document.getElementById('PRODUCT_DETAILS_TABLE'))
					{
						parent.document.body.removeChild(parent.document.getElementById('PRODUCT_DETAILS_TABLE'));
					}
					
					// Eigenes HTML-Element zum Einblenden
					// der Produktdetails erzeugen
					var myDiv = parent.document.createElement('div');
					myDiv.id  = "PRODUCT_DETAILS_TABLE_CONTENT";
					myDiv.className = "$detailsTableContentDivStyle$";
					myDiv.innerHTML = '$detailsTableContent$';
					
					var myFrameDiv = parent.document.createElement('div');
					myFrameDiv.id  = "PRODUCT_DETAILS_TABLE";
					myFrameDiv.className = "$detailsTableFrameDivStyle$";
					myFrameDiv.appendChild(myDiv);
					
					// Element einhngen
					parent.document.body.appendChild(myFrameDiv);
				</script>
				$getstring("UTF8END", "PROJECT.SETTINGS");$
			inputEnd;
		}
		
		# Der Handler wird von der Projektliste aus aufgerufen
		else if(mode == "SHOPPINGCART")
		{
			# Das Produkt ist ein konfiguriertes Produkt
			if(find(detailsId, "<<<CFG>>>") > 0)
			{
				projectListItem = trimleft(detailsId, "<<<CFG>>>");
				
				# Aktuelle Pfade des Konfigurators sichern, um diese
				# nach Abfrage der Details-Tabelle wiederherstellen zu
				# knnen.
				oldCfg_This = getalias("CFG_THIS");
				oldCfgdata_This = getalias ("CFGDATA_THIS");
				oldConfigurations_This = getalias("CONFIGURATIONS_THIS");
				
				# Dialogdaten des selektierten Produkts wiederherstellen, um
				# eine korrekte Anzeige der Detailtabelle zu gewhrleisten
				strConfigObject = getstring("ID", projectlistPath + "[" + projectListItem + "]" + ".CONFIGURATIONS");
				strConfigPath   = projectlistPath + "[" + projectListItem + "].CONFIGURATIONS"
				setalias("CFG_THIS", strConfigPath);
				setalias("CFGDATA_THIS", strConfigPath + ".CFGDATA." + strConfigObject);
				setalias("CONFIGURATIONS_THIS", strConfigPath + ".CONFIG." + strConfigObject);
				
				# Produktbild-Informationen (Dateiname und TreeIdent)
				# aus den Positionsdaten des selektierten Produktes
				# laden
				setstring("CFG_IMAGE_FILENAME", "DLGDATA.PRODUCT.POSDATA", getstring("CFG_IMAGE_FILENAME", projectlistPath + "[" + projectListItem + "]" + ".PRODUCT.POSDATA"));
				setstring("CFG_IMAGE_TREEIDENT", "DLGDATA.PRODUCT.POSDATA", getstring("CFG_IMAGE_TREEIDENT", projectlistPath + "[" + projectListItem + "]" + ".PRODUCT.POSDATA"));
				
				# Speicher fr die alten Konfigurationsdaten im Store freigeben
				delete("CONFIGURATION_DATA", "DLGDATA.DLGVARS.EASYKATLIGHT");
				
				cfgDataReader = new cfgDataReader();
				startObject = new Array();
				startObject.push("");
				cfgDataReader.getConfigEntries(startObject, "DLGDATA.DLGVARS.EASYKATLIGHT.CONFIGURATION_DATA", 1)
				
				# Detail-Tabelle aufbauen
				cfgSummary = new cfgSummaryBuilder();
				tempContent = cfgSummary.buildConfigDataTable(stylePath, "DLGDATA.DLGVARS.EASYKATLIGHT.CONFIGURATION_DATA", "RAW", "PROJECTLIST");
				
				detailsTableContent = <<inputEnd
					<DIV class="$detailsTableButtonDivStyle$" onclick="removeDetailsTable();">
						<img id="DETAILS_TABLE_LINKBUTTON" src="/EKImage/Button/Pull_up.gif"
						 style="padding-left: 10px; cursor: hand;" onmouseover="exchangeGraphic(this);" 
						 onmouseout="exchangeGraphic(this);" onclick="removeDetailsTable();">
					</DIV>
					<DIV class="$detailsTableTableDivStyle$">
						<TABLE class="$detailsTableStyle$" onclick="removeDetailsTable();" >
						<TR><TD>
							$tempContent$
						</TD></TR>
						</TABLE>
					</DIV>
				inputEnd;
				
				detailsTableContent = replace(detailsTableContent, "\n", "");
				
				# Alte Pfade des Konfigurators wiederherstellen
				setalias("CFG_THIS", oldCfg_This);
				setalias("CFGDATA_THIS", oldCfgdata_This);
				setalias("CONFIGURATIONS_THIS", oldConfigurations_This);
			}
			else
			{
				# Artikelnummer wegspeichern, damit die Merkmale
				# in die Detail-Tabelle geladen werden knnen
				setstring("DETAILS_PRODUCT_ARTNR", "DLGDATA.TEMP", artNr);
				
				# Detail-Tabelle aufbauen
				tempContent = buildDetails(detailsId, stylePath, "RAW");
				
				detailsTableContent = <<inputEnd
					<DIV class="$detailsTableButtonDivStyle$" onclick="removeDetailsTable();">
						<img id="DETAILS_TABLE_LINKBUTTON" src="/EKImage/Button/Pull_up.gif"
						 style="padding-left: 10px; cursor: hand;" onmouseover="exchangeGraphic(this);" 
						 onmouseout="exchangeGraphic(this);" onclick="removeDetailsTable();">
					</DIV>
					<DIV class="$detailsTableTableDivStyle$">
						<TABLE class="$detailsTableStyle$" onclick="removeDetailsTable();" >
						$tempContent$
						</TABLE>
					</DIV>
				inputEnd;
				
				detailsTableContent = replace(detailsTableContent, "\n", "");
			}
			
			# Detail-Tabelle in die Projektliste einblenden
			m_result =<<inputEnd
				$getstring("UTF8BEGIN", "PROJECT.SETTINGS");$
				<script>
					if(parent.document.getElementById('PRODUCT_DETAILS_TABLE'))
					{
						parent.document.body.removeChild(parent.document.getElementById('PRODUCT_DETAILS_TABLE'));
					}
					
					// Eigenes HTML-Element zum Einblenden
					// der Produktdetails erzeugen
					var myDiv = parent.document.createElement('div');
					myDiv.id  = "PRODUCT_DETAILS_TABLE_CONTENT";
					myDiv.className = "$detailsTableContentDivStyle$";
					myDiv.innerHTML = '$detailsTableContent$';
					
					var myFrameDiv = parent.document.createElement('div');
					myFrameDiv.id  = "PRODUCT_DETAILS_TABLE";
					myFrameDiv.className = "$detailsTableFrameDivStyle$";
					myFrameDiv.appendChild(myDiv);
					
					// Element einhngen
					parent.document.body.appendChild(myFrameDiv);
				</script>
				$getstring("UTF8END", "PROJECT.SETTINGS");$
			inputEnd;
		}
		
		# Aliase ersetzen je nach Betriebszustand des Systems
		cdMode = tolower(getstring("INTERNETSERVERINCDMODE", "ROOT.CATALOG"));
		
		if(cdMode == "true")
			m_result = replacealiases(m_result, 1);
		else
			m_result = replacealiases(m_result, 0);
		
		
		return 1;
	}
}


///////////////////////////////////////////////////////////
// Main-Funktion des Request-Handlers
///////////////////////////////////////////////////////////
{
	RET=0;
	logtraceresetclock();  // Zeit ab jetzt stoppen...
	
    initdlgvars( CONTENT );
    
    POSTVARS = new PostVars;
    setsessionpath( getsessionpath( POSTVARS.sessionid ) );
    
	httpRequest reqObj(PATH, HEADER, CONTENT);
    

	///////////////////////////////////////////////////////
	// Handler Instanzen anlegen
	
	// allgemeine verwendbare Handler
	ajaxGetFile					ajaxGetFileInst();
	ajaxOpenDocument			ajaxOpenDocumentInst();
	updateDialogElement			updateDialogElementInst();
	copy2Clipboard				copy2ClipboardInst();
	submitDlgElement			submitDlgElementInst();
    addToShoppingCart           addToShoppingCartInst();
	addToFavoriteList			addToFavoriteListInst();
	getCfgInitPrice				getCfgInitPriceInst();
	clickHandler				clickHandlerInst();
	sendToServerHandler			sendToServerHandlerInst();
	
/*	
    setCalcValues               setCalcValuesInst();
    doCalculation               doCalculationInst();
    changeSelection             changeSelectionInst();
    openCADDrawing              openCADDrawingInst();
    printDocument               printDocumentInst();
    saveProject                 saveProjectInst();
    saveOffer                   saveOfferInst();
    createCSV                   createCSVInst();
	saveSearchIFrameData        saveSearchIFrameDataInst();
	saveFavList					saveFavListInst();
	saveSettings				saveSettingsInst();
	toggleDetails				toggleDetailsInst();
	sendRequestEmail			sendRequestEmailInst();
	saveConfiguration			saveConfigurationInst();
	rebuildComboboxTable		rebuildComboboxTableInst();
	getComboboxTable_NoAjax		getComboboxTable_NoAjaxInst();
*/	
//	FileDialog					FileDialogInst();

	///////////////////////////////////////////////////////
	// Handler registieren
	reqObj.addHandler( ajaxGetFileInst );
	reqObj.addHandler( ajaxOpenDocumentInst );
	reqObj.addHandler( updateDialogElementInst );
	reqObj.addHandler( copy2ClipboardInst );
	reqObj.addHandler( submitDlgElementInst );
    reqObj.addHandler( addToShoppingCartInst );
	reqObj.addHandler( addToFavoriteListInst );
	reqObj.addHandler( clickHandlerInst );
	reqObj.addHandler( sendToServerHandlerInst);
	
/*	
    reqObj.addHandler( setCalcValuesInst );
    reqObj.addHandler( doCalculationInst );
    reqObj.addHandler( changeSelectionInst );
    reqObj.addHandler( openCADDrawingInst );
    reqObj.addHandler( printDocumentInst );
    reqObj.addHandler( saveProjectInst );
    reqObj.addHandler( saveOfferInst );
    reqObj.addHandler( createCSVInst );
	reqObj.addHandler( saveSearchIFrameDataInst );
	reqObj.addHandler( saveFavListInst );
	reqObj.addHandler( saveSettingsInst );
	reqObj.addHandler( toggleDetailsInst );
	reqObj.addHandler( sendRequestEmailInst );
	reqObj.addHandler( saveConfigurationInst );
	reqObj.addHandler( rebuildComboboxTableInst );
	reqObj.addHandler( getComboboxTable_NoAjaxInst );
	reqObj.addHandler( getCfgInitPriceInst );
*/	
    //	reqObj.addHandler( FileDialogInst );
	
	///////////////////////////////////////////////////////
	// Request verarbeiten - bei passendem Handler
	breakpoint("Handle_Request");
	if(reqObj.processRequest())
	{
		// Ergebnis vom Handler zurckschicken
		RESULT = reqObj.getResult();
		MIMETYPE = reqObj.getMimeType();
		//ADDITIONAL_HEADER = reqObj.getAdditionalHeader();
		logtraceln("\tFINISH - HANDLE_REQUEST: URL="+PATH+"\n");
		RET=1;
	}
	
	return RET;	// Request hat sich noch nicht erledigt...
}