

///////////////////////////////////////////////////////////
// class httpRequestHandler
//
// Basisklasse fr Request Handler. Diese Handler mssen
// dann noch im httpRequest Objekt registriert werden.

class httpRequestHandler
{
	var m_path;
	var m_result;
	var m_mimeType;
	var m_additionalHeader;

	
	httpRequestHandler(path)
	{
		m_path = path;
		m_mimeType = "text/html";
		m_additionalHeader =
			  "Pragma: no-cache\r\n" +
			  "Cache-Control: no-store, no-cache, must-revalidate\r\n";
	}
	
	
	execRequest(reqMap, requestObj)
	{
		return false;	
	}
	
	
	getDialogElement(dlgId, format)
	{
		return getDialogElement(dlgId, format, "", "");
	}

	getDialogElement(dlgId, format, elementIds)
	{
		return getDialogElement(dlgId, format, elementIds, "");
	}
	
	getDialogElement(dlgId, format, elementIds, aliasMethod)
	{
		templateFile=getstring("CATALOG.TEMPLATES.DIR","ROOT")+dlgId+".xml";
		path="EASYGUITRANSFORM";
		
		setstring("DLG_ID", path, dlgId);
		setstring("INFILE", path, templateFile);
		setstring("RESULT_TYPE", path, format);
		setstring("ALIAS_METHOD", path, aliasMethod);
		
		elementIds+="|END"; id="";
		logtraceln("elementIds="+elementIds);
		while( split(elementIds, id, elementIds, "|") )
		{	
			//logtraceln("BUILD_ONLY"~id);
			setint("BUILD_ONLY"~id, path, 1);
		}
		
		return scriptexec("EASYGUITRANSFORM");
	}
	

	
	processEvents(dlgId, eventId)
	{
		RS="RECSET_EVENTS";
		DBID=getstring("CATALOG.DEFAULTDATABASE.ID","ROOT");
		S=<<"SELECT DISTINCT * FROM DLG_EVENTS WHERE DLG_ID='$dlgId$' and (EVENT='$eventId$' or EVENT='' or EVENT is NULL) ORDER BY abs(SEQ_ID) ASC";
		n=dbselect(DBID,S,RS);
		res = "";
		while( !dbiseof(RS) )
		{
			ACTION_TYPE=dbgetstring(RS,"ACTION_TYPE");
			ACTION=dbgetstring(RS,"ACTION");
			
			if( tolower(ACTION_TYPE)=="script" )
			{	// SCRIPT
				res=scriptexec( ACTION );
			}
			else
			{	// C++
				specialexec( ACTION );
			}
			dbskip(RS);
		}
		return res;
	}
	
		
	CDMode()
	{
		return tolower(getstring("CATALOG.INTERNETSERVERINCDMODE","ROOT"))=="true";
	}
	
}



///////////////////////////////////////////////////////////
// class httpRequestMap
//
// Map Objekt fr Daten und Request Handler.

class httpRequestMap
{
	httpRequestMap()
	{
	}
	
	setVal(id,val)		{ objectset(this,id,val); }
	getVal(id)			{ return objectget(this,id); }
	getLength()			{ return objectsize(this); }
	getAt(idx)			{ return objectat(this,idx); }
}

///////////////////////////////////////////////////////////
// class httpHandlerMap

class httpHandlerMap : public httpRequestMap
{
	httpHandlerMap()
	{
	}

	addHandler(handlerObj)			{ setVal(handlerObj.m_path, handlerObj); }
	
	searchHandler(path)
	{
		n=getLength();
		for(i=0;i<n;i++) {
			handlerObj=getAt(i);
			if( find(path,handlerObj.m_path)!=-1 )
				return i;
		}
		return -1;
	}
}




///////////////////////////////////////////////////////////
// class httpRequest
//
// Klasse um irgendwelche GET Requests (z.B. AJAX) zu verarbeiten.
// Die Daten hinter dem ? kommen in eine Map, ber den vorderen Pfad
// wird dann ein passender Handler gesucht.
// Bsp.:  /ajax/tree?tree=WF&root=WF20&...
// Der Handler (die Funktion) wird durch /ajax/tree festgelegt.

class httpRequest
{
	var m_requestMap;		// Parameter Map (DlgVars)
	var m_handlerMap;		// Request Handler Map
	var m_reqPath;			// GET Daten (ohne GET)
	var m_reqPathFront;		// Pfad ohne Daten, also alles vor dem ?
	var m_reqHeader;		// HTTP Request Header
	var m_reqContent;		// POST Daten (werden z.Z. ignoriert)
	var m_handlerObj;		// das gefundene Handler Objekt
	var m_host;				// Der Host aus m_referer

		
	httpRequest(reqPath, reqHeader, reqContent)
	{
		m_reqPath=reqPath;
		m_reqHeader=reqHeader;
		m_reqContent=reqContent;
		httpRequestMap m_requestMap();
		httpHandlerMap m_handlerMap();
		
		//if(find(m_reqContent,"%")>0)	// fr indirekte Request via Apache/php
		//	m_reqContent=urldecode(m_reqContent);
			
		initdlgvars(m_reqContent);
		if(getdlgvar("ek_ajax_url")!="")	// fr indirekte Request via Apache/php
			m_reqPath=getdlgvar("ek_ajax_url");
		
		parsePath();
		//parseHeader();
	}
	
	
	// Die GET Daten parsen
	parsePath()
	{
		pos=find(m_reqPath,"?");
		params= pos>0 ? right(m_reqPath,strlen(m_reqPath)-pos)+"&END" : "";
		m_reqPathFront= pos>0 ? left(m_reqPath,pos-1) : m_reqPath;
		while(params!="" && split(params,id,params,"=") && split(params,value,params,"&") )
		{
			m_requestMap.setVal(id,value);
		}
	}
	
	parseHeader()
	{
		p=find(m_reqHeader,"\r\nReferer:");
		p= p<0 ? find(m_reqHeader,"\r\nreferer:") : p;
		p= p<0 ? find(m_reqHeader,"\r\nREFEER:") : p;
		if(p>0) {
			m_host=right(m_reqHeader, strlen(m_reqHeader)-p-9);
			m_host=replace(replace(m_host, "https://", ""), "http://","");
			m_host= (p=find(m_host,"/"))>0 ? left(m_host,p-1) : m_host;
			m_host=trimleft( trimright(m_host," ") ," ");
		}
	}
	
	
	processRequest()
	{
		idx=m_handlerMap.searchHandler(m_reqPathFront);
		if(idx>=0)
		{
			logtraceln("\n\t\t\tSTART - HANDLE_REQUEST: URL="+m_reqPath);
			m_handlerObj=m_handlerMap.getAt(idx);
			return m_handlerObj.execRequest(m_requestMap, this);
		}
		return false;
	}
	
	addHandler(handlerObj)	{ m_handlerMap.addHandler(handlerObj); }
	getResult()				{ return m_handlerObj.m_result; }
	getMimeType()			{ return m_handlerObj.m_mimeType; }
	getAdditionalHeader()	{ return m_handlerObj.m_additionalHeader; }
}
