//////////////////////////////////////////////////////////////////
// Diese Script wird innerhalb von CEKCatalogSystem::Init
// aufgerufen.
// Bitte beachten dass hier noch keine Datenbank erreichbar ist.
// Es gibt noch keine Sessions usw.
// Es sollten auch keine externen Scripte gestartet werden weil
// der scripts-Ordner nicht unbedingt vorhanden ist und noch keine
// Scripte aus der Datenbank geladen werden knnen.


//////////////////////////////////////////////////////////////////
// init: Das eingelesene XML-File im alten Format im Store ablegen
init(src,dst)
{
	i=0;
	size=getsize(src,"");
	
	while( i < size )
	{
		it=arraypath(src,i);
		TAGNAME=getstring("TAGNAME",it);

		if(toupper(getstring("STORAGETYPE",it~"VALUES"))=="ARRAY")
		{	// Array anlegen
			if(checkexist(TAGNAME,dst))
			{	// Array vorhanden
				n=getsize(TAGNAME,dst);
			}
			else
			{	// noch kein Array -> mit Index 0 starten
				n=0;
			}
			
			array_dst=arraypath(dst~TAGNAME,n);
			copy(it~"VALUES",array_dst)
		}
		else
		{	// Normale Werte
			copy(it~"VALUES",dst~TAGNAME);
		}
		
		if(getsize("XML",it)>0)
		{	// Unterknoten vorhanden -> Funktion rekursiv aufrufen
			init(it~"XML",dst~TAGNAME);
		}
		i=i+1;
	}
}

initDlgOrdNumbers()
{
	setdouble("DLGORDNUMBERS.IDD_START", "ROOT", 1);
	setdouble("DLGORDNUMBERS.IDD_AUSWAHL", "ROOT", 2);
	setdouble("DLGORDNUMBERS.IDD_KOORDINATENSYS", "ROOT", 3);
	setdouble("DLGORDNUMBERS.IDD_AUSMASSE", "ROOT", 4);
	setdouble("DLGORDNUMBERS.IDD_KGTAUSMASSE", "ROOT", 4);
	setdouble("DLGORDNUMBERS.IDD_WINKEL", "ROOT", 5);
	setdouble("DLGORDNUMBERS.IDD_DYNAUSWAHL", "ROOT", 6);
	setdouble("DLGORDNUMBERS.IDD_DYNZYKLUS", "ROOT", 7);
	setdouble("DLGORDNUMBERS.IDD_DYNZEITANTEILE", "ROOT", 7);
	setdouble("DLGORDNUMBERS.IDD_DYNSTRECKEN", "ROOT", 7);
	setdouble("DLGORDNUMBERS.IDD_MASSENDYNZYKLUS", "ROOT", 8);
	setdouble("DLGORDNUMBERS.IDD_MASSENDYNZEITANTEILE", "ROOT", 8);
	setdouble("DLGORDNUMBERS.IDD_MASSENDYNSTRECKEN", "ROOT", 8);
	setdouble("DLGORDNUMBERS.IDD_KRAEFTEDYNZYKLUS", "ROOT", 9);
	setdouble("DLGORDNUMBERS.IDD_KRAEFTEDYNZEITANTEILE", "ROOT", 9);
	setdouble("DLGORDNUMBERS.IDD_KRAEFTEDYNSTRECKEN", "ROOT", 9);
	setdouble("DLGORDNUMBERS.IDD_HINWEISE", "ROOT", 10);
	setdouble("DLGORDNUMBERS.IDD_DATEN", "ROOT", 11);
	setdouble("DLGORDNUMBERS.IDD_KGTDATEN", "ROOT", 11);
	setdouble("DLGORDNUMBERS.IDD_VERLAGERUNGEN", "ROOT", 12);
	setdouble("DLGORDNUMBERS.IDD_PROJECTLIST", "ROOT", 13);
}



//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	// catalog.xws laden und im Store ablegen
	importxmlfile("catalog.xws","TEMP.CATALOG",1);
	// Den Inhalt von "Workspace" im alten Format in den Store
	// bertragen
	init("TEMP.CATALOG.XML[0].XML","");	
	// Importierte XML-Struktur wieder lschen 	
	delete("CATALOG","TEMP");

	// -mw- debug und logtrace automatisch anschalten, wenn wir im Testmodus sind
	var automatictest = getstring("CATALOG.AUTOMATICTEST","ROOT");		
	if (automatictest == "true") {
		debug(1);
		logtracestate(1);
		logtrace("\n\n\n\n\n\n\n//////////////////////////////////////////////////////////////////////////////\nINIT_CATALOG\n");	
	}
	else {
		debug(0);
		logtracestate(0);
	}
	
	// Ab hier knnen spezielle Funktionen in den IndiSpecialFunctions aufgerufen werden.
	res=filecommand("mkdir","PROJFILE");
	// specialexec("MY_INIT_FUNCTIONS");
	initDlgOrdNumbers();
}
