#include "Daten_Calc.b"

function	berechneLebensdauerH()	// Lebensdauer in h
{
	var dLebensdauer = getdouble("GEF_LEBENSDAUER.BASE", "DLGDATA.DATEN");
	var vm			= getdouble("VM.BASE", "DLGDATA.DYNZYKLUS.PROFIL");
	dLebensdauerH = (vm == 0) ? 0 : dLebensdauer / vm;
	if (dLebensdauerH != 0)
		setdouble("GEF_LEBENSDAUER_H.BASE", "DLGDATA.DATEN", dLebensdauerH);
	else
		setstring("GEF_LEBENSDAUER_H.RAW", "DLGDATA.DATEN", "");
	return dLebensdauerH;
}

function	berechneLebensDauerU()	// Lebensdauer in Umdrehungen
{
	var dLebensdauer = getdouble("GEF_LEBENSDAUER.BASE", "DLGDATA.DATEN");
	var P = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");	// Spindelsteigung
	var L_U10 = (P != 0) ? dLebensdauer / P : 0;
	return L_U10;
}

function	berechneLebensdauer()		// Lebensdauer in m
{
	var dLebensdauerH = getdouble("GEF_LEBENSDAUER_H.BASE", "DLGDATA.DATEN");
	var vm			= getdouble("VM.BASE", "DLGDATA.DYNZYKLUS.PROFIL");
	dLebensdauer = dLebensdauerH * vm;
	if (dLebensdauer != 0)
		setdouble("GEF_LEBENSDAUER.BASE", "DLGDATA.DATEN", dLebensdauer);
	else
		setstring("GEF_LEBENSDAUER.RAW", "DLGDATA.DATEN", "");
	return dLebensdauer;
}

function	berechneKraft(nPhase, dZusatzmasse, a)
{
	if (a == 0)
		return 0;
	strPathMassen = "DLGDATA.MASSEN";
	F_XB = dZusatzmasse * a;
	nMasseAnz = getsize(strPathMassen, "");	
	for (i = 0; i < nMasseAnz; i++)	{
		strPathM = strPathMassen + "[" + i + "]";
		if (getbool("ZYKLUSDATEN[" + nPhase + "].ACTIVE", strPathM))	{
			m = getdouble("MASSE.BASE", strPathM);
			F_XB += m * a;
		}
	}
	F_XB = -F_XB;

	return F_XB;
}

// Formel 2.1
function	berechneGewichtskraft(nPhase, dZusatzmasse)
{
	Alpha = getdouble("10003.BASE", "DLGDATA.SYSTEM");
	Beta  = getdouble("10004.BASE", "DLGDATA.SYSTEM");
	g = GetGlobalConst("g");
	a = g * cos(Alpha) * sin(Beta);
	F_XG = berechneKraft(nPhase, dZusatzmasse, a);
	return F_XG;
}

// Formel 2.3
function	berechneBeschleunigungskraft(nPhase, dZusatzmasse)
{
	strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL.";
	strPathPhase = strPathProfil + nPhase;
	a = getdouble("AE.BASE", strPathPhase);
	F_XB = berechneKraft(nPhase, dZusatzmasse, a);
	return F_XB;
}

// Formel 2.4
function	berechneProzesskraft(nPhase)
{
	F_XP = 0;
	strPathKraefte = "DLGDATA.KRAEFTE";
	nAnz = getsize(strPathKraefte, "");	
	for (i = 0; i < nAnz; i++)	{
		strPathF = strPathKraefte + "[" + i + "]";
		if (getbool("ZYKLUSDATEN[" + nPhase + "].ACTIVE", strPathF))	{
			F_XP += getdouble("KRAFT.X.BASE", strPathF);
		}
	}
	return F_XP;
}

// Formel 2.5
function	berechneFExtern(nPhase, dZusatzmasse)
{
	F_Ext = berechneGewichtskraft(nPhase, dZusatzmasse) + berechneBeschleunigungskraft(nPhase, dZusatzmasse) + berechneProzesskraft(nPhase);
	return F_Ext;
}

// Formel 2.6 / 2.7
function	berechneFGes(F_Extern, F_V, strVorspannung)
{
	var dFVFak = 2.828;
	var dVSPGrenz = 3;
	var F_K = dFVFak * F_V;
	// -mw- 14.11.2013: Vorspannung ist jetzt ein String - gendert nach Rcksprache mit Hr. Schmee
	// F_Ges = (F_Extern <= F_K && dVorspannung >= dVSPGrenz) ? pow((1 + abs(F_Extern) / F_K), 3/2) * F_V : abs(F_Extern);
	var bVorspannungWirkt = false;
	if (strVorspannung != 'C0') 
		bVorspannungWirkt = true;
	F_Ges = (F_Extern <= F_K && bVorspannungWirkt) ? pow((1 + abs(F_Extern) / F_K), 3/2) * F_V : abs(F_Extern);
	return F_Ges;
}

// Formel 4.1
/*
function	berechneFAeguiGes()
{
	strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
	nAnz = getint("SIZE", strPathProfil);
	F_Aequi = 0;
	for (i = 0; i < nAnz; i++)	{
		strPathPhase = strPathProfil + "." + i;
		F_Ges	= getdouble("....BASE", strPathPhase);
		qs		= getdouble("QS.RAW", strPathPhase) / 100;
		F_Aequi += F_Ges * F_Ges * F_Ges * qs;
	}
	F_Aequi = root(F_Aequi, 3);
	return F_Aequi;
}
*/

function	initKGTCalcKraefte()
{
	strDestPath="DLGDATA.KGTDATEN_KRAEFTE";
	var strUPDrehmoment =	"10016";
	var strUPKraft		=	"11";
	var strUPBeschleunigung = "8";
	if (getsize(strDestPath+"_ARRAY", "") == 0)	{
		
		var nAnz = 18 ; //	Anzahl Fix, da Profil bei Aufruf ggfs. noch nicht initialisiert
		for (i = 0; i < nAnz; i++)	{
			var strTmpPath = strDestPath+"_ARRAY" + "[" + i + "]";
			//dRet = createobject(strTmpPath, "F_XB", 49, strUPKraft);
			//dRet = createobject(strTmpPath, "F_XG", 49, strUPKraft);
			//dRet = createobject(strTmpPath, "F_XP", 49, strUPKraft);
			dRet = createobject(strTmpPath, "F_EXT", 49, strUPKraft);
			dRet = createobject(strTmpPath, "F_GES", 49, strUPKraft);
			dRet = createobject(strTmpPath, "M_AXIAL", 49, strUPDrehmoment);
			dRet = createobject(strTmpPath, "M_TRAEGHEIT", 49, strUPDrehmoment);
			dRet = createobject(strTmpPath, "M_SYSTEM", 49, strUPDrehmoment);
			dRet = createobject(strTmpPath, "A_MAX_ZUL", 49, strUPBeschleunigung);
			
		}
		dRet = createobject(strDestPath, "F_AEQUI_EXT", 49, strUPKraft,"",292);
		dRet = createobject(strDestPath, "F_AEQUI_GES", 49, strUPKraft,"",292);
		dRet = createobject(strDestPath, "F_AEQUI_MASSEN", 49, strUPKraft,"",292); // F_Aequi fuer KGTMASSENDYNZYKLUS ..., Nur Massen ohne externe Kraefte
		dRet = createobject(strDestPath, "F_AEQUI_KRAEFTE", 49, strUPKraft,"",292); // F_Aequi fuer KGTMKRAEFTEDYNZYKLUS ..., Massen,externe Kraefte
		dRet = createobject(strDestPath, "M_GESMAX", 49, strUPDrehmoment);
		dRet = createobject(strDestPath, "F_GESMAX", 49, "11");
		
	}
}

function	berechneKGTKraefte(StoreDestinationNode,dZusatzmasse, dZusatzkraft, bProzesskraft)
// StoreDestinationNode beschreibt, in welchen Unterknoten von DLGDATA.KGTDATEN_KRAEFTE 
// der berechne F_Aeuqi Wer gespeicht wird
// (Verschiedene Knoten, je nachdem welche Kraefte beruecksichtigt werden)
{
	
	initKGTCalcKraefte();
	strDestPath="DLGDATA.KGTDATEN_KRAEFTE";
	var strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
	var nAnz = getint("SIZE", strPathProfil);
	var P = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");	// Spindelsteigung
	var eta = 0.9;
	P /= (GetGlobalConst("twoPi") * eta);
	F_Aequi = 0;	
	for (i = 0; i < nAnz; i++)	{
		var strPathPhase = strPathProfil + "." + i;
		var strTmpPath = strDestPath + "_ARRAY[" + i + "]";
		var F_XB = berechneBeschleunigungskraft(i, dZusatzmasse);
		var F_XG = berechneGewichtskraft(i, dZusatzmasse);
		var F_XP = 0;
		if (bProzesskraft)	{
			F_XP = berechneProzesskraft(i);
			//setdouble("F_XP.BASE", strTmpPath, F_XP);
		}
		else	{
			//setstring("F_XP.RAW", strTmpPath, "");
		}
		var F_EXT = F_XG + F_XB + F_XP + dZusatzkraft;
		var F_EXTABS = abs(F_XG) + abs(F_XB) + abs(F_XP) + abs(dZusatzkraft);
		var qs		= getdouble("QS.RAW", strPathPhase) / 100;
		//setdouble("F_XB.BASE", strTmpPath, F_XB);
		//setdouble("F_XG.BASE", strTmpPath, F_XG);
		setdouble("F_EXT.BASE", strTmpPath, F_EXT);
		//F_EXT=getdouble("F_EXT.BASE", strTmpPath); // Wert aus Store auslesen 
		//um Rundungsdifferen im Vergleich zur Berechnung in berechneKGTDaten zur vermeiden, wo F_EXT aus dem Store gelesen wird
		F_EXT = abs(F_EXT);
		M_Axial = F_EXTABS * P;
		setdouble("M_AXIAL.BASE", strTmpPath, M_Axial);
		F_Aequi += F_EXT * F_EXT * F_EXT * qs;
	}
	F_Aequi = root(F_Aequi, 3);
	//F_Aequi = 111.11;
	setdouble(StoreDestinationNode~"BASE", strDestPath, F_Aequi);
	var t=getstring ("F_AEQUI_MASSEN.BASE", strDestPath);
	var tv=getstring ("F_AEQUI_MASSEN.VALUE", strDestPath);
	var tunit=getstring ("F_AEQUI_MASSEN.UNIT", strDestPath);
	return F_Aequi;
}

function	berechneFAequiInKGTMassen()
{
	return berechneKGTKraefte( "F_AEQUI_MASSEN",0, 0, false);
}

function	berechneFAequiInKGTKraefte()
{
	return berechneKGTKraefte( "F_AEQUI_KRAEFTE",0, 0, true);
}

function	checkLebensdauer(Tab)
{
	if (getstring("GEF_LEBENSDAUER.RAW", "DLGDATA.DATEN") == "")
		return;

	var L_U10gef = berechneLebensDauerU();
	Tab.goTop();
	while (!Tab.isEof())	{
		CKGTCalc	Calc(Tab, true);
		var L_U10 = Calc.berechneKGTLebensdauer();
		if (L_U10 < L_U10gef)
			Tab.delete();
		else
			Tab.skip();
	}
};



class	CKGTCalc
{
	var	d_2;		// Kerndurchmesser [mm]
	var L_Lager;	// Lagermittenabstand [mm] aus Maske KGTAUSMASSE
	var L_Mutter;	// Gesamtlaenge der Mutter [mm]
	var a_maxzul;	// max. zul. Beschleunigung [m/s^2]
	var v_maxzul;	// max. zul. Geschwindigkeit [m/s]
	var C;			// dyn. Tragzahl der Mutter [N]
	var C0;			// stat. Tragzahl der Mutter [N]
	var CRed;		// red. dyn. Tragzahl der Mutter [N]
	var C0Red;		// red. stat. Tragzahl der Mutter [N]
	var	d_0;		// Nenndurchmesser der Spindel [mm]
	var	D_W;		// Kugeldurchmesser [mm]
	var strLagerart;// Lagerart aus Maske KGTAUSMASSE (FEST_FEST, FEST_LOS, FEST_FREI)
	var nSPU;		// Anzahl Spindelunterstuetzungen aus Maske KGTAUSMASSE (0,...,4)
	var R_nu;		// Axiale Steifigkeit der KGT Mutter [N/um]
	var m_KGTMutter;	// Masse der KGT-Mutter [kg]
	var m_SPU;		// Masse einer Spindelunterstuetzung [kg]
	var F_V;		// Vorspannkraft [N]
	var P;			// Spindelsteigung [m]
	var J_Mutter;	// Traegheitsmoment Mutter [kgm^2]
	var J_SpindelSpz;// spez. Traegheitsmoment Spindel kgm^2/m
	var M_RL;		// Reibmoment der Mutternlagerung [Nm]
	var M_Reib_SPU;	// Reibmoment der Spindelunterstuetzung (bei AGK) [Nm]
	var T_prO;		// Leerlaufdrehmoment KGT ohne Dichtung [Nm]
	var T_RD;		// Leerlaufdrehmoment der 2 Dichtungen [Nm]
	var Baureihe;	// Baureihe der Mutter
	var Baureihe_KGT; // Baureihe des KGT
	var Vorspannung;// Vorspannungsklasse (frher in [%], jetzt freier String)
	var KFTragabFak;// Betriebsfaktor und Tragzahlabschlag vernudelt
	var UmlAnz;		// Anzahl Umlaeufe (i)
	var z_1;		// Kugeln im Eingriff

	var mueWert;	// m     = Reibwert PLSA eingelaufen
	var pkWert;		// PK     = Konvektionsleistung
	var mWert;		// m      = Interpolation u-Wert aus Vorspannung
	var vierFpr;	// 4 Fpr  = Vierfache Vorspannkraft
	var MRD;		// MRD    = Reibmoment Standarddichtungen
	var MRPLSA;		// MRPLSA = Reibmoment PLSA-Mutter aus "Vorsp."

	CKGTCalc(strProductPath)
	{
		init(strProductPath);
	}
	
	CKGTCalc(Table, bAll)
	{
		C			= Table.getValue("P_C.BASE");
		m_KGTMutter = Table.getValue("P_MASSE_KGT_MUTTER.BASE");
		m_SPU		= Table.getValue("P_MASSE_SPU.BASE");
		F_V			= Table.getValue("P_FV.BASE");
		Vorspannung = Table.getValue("P_VORSPANNKLASSE_BEZ_C.RAW");
		KFTragabFak = getKFTragabFak();
		CRed		= getCRed();
	}
	
	function	init(strProductPath)
	{
		m_strProductPath = (strProductPath == "") ? "DLGDATA.KGTDATEN.KGT" : strProductPath;
		d_2 = getdouble("P_D2.BASE", m_strProductPath) * 1000;
		L_Lager = getdouble("L_LAGER.BASE", "DLGDATA.KGTSYSTEM") * 1000;
		L_Mutter = getdouble("P_L_GESAMT_KGT.BASE", m_strProductPath) * 1000;
		
		a_maxzul	= getdouble("P_AMAX_ZUL.BASE", m_strProductPath);
		v_maxzul	= getdouble("P_VMAX_ZUL.BASE", m_strProductPath);
		C			= getdouble("P_C.BASE", m_strProductPath);
		C0			= getdouble("P_C0.BASE", m_strProductPath);
		d_0			= getdouble("PM_D0.BASE", m_strProductPath) * 1000;
		D_W			= getdouble("P_DW.BASE", m_strProductPath) * 1000;
		strLagerart = getstring("LAGERART", "DLGDATA.KGTSYSTEM");
		nSPU		= getint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
		R_nu		= getdouble("P_STEIFIGKEIT_KGT.RAW", m_strProductPath);
		m_KGTMutter = getdouble("P_MASSE_KGT_MUTTER.BASE", m_strProductPath);
		m_SPU		= getdouble("P_MASSE_SPU.BASE", m_strProductPath);
		F_V			= getdouble("P_FV.BASE", m_strProductPath);
		P			= getdouble("PM_STEIGUNG.BASE", m_strProductPath);
		J_Mutter	= getdouble("P_MASSENTRAEGHEIT_KGT.BASE", m_strProductPath)*10000.0; // In Datenbank ist BASE Unit kgcm2 statt kgm2 
						// wegen moeglicher globaler Effekte in DB nicht korrigiert
		J_SpindelSpz= getdouble("P_SPEZ_TRAEGHEIT_SPINDEL.BASE", m_strProductPath);
		M_RL		= getdouble("P_REIBMOM_KGT_MU.BASE", m_strProductPath);
		M_Reib_SPU	= getdouble("P_REIBMOM_SPU_ABD_KGT.BASE", m_strProductPath);
		T_RD		= getdouble("P_REIBMOM_DICHTG_KGT.BASE", m_strProductPath);
		Baureihe	= getstring("PM_BR_MUTTER.RAW", m_strProductPath);
		Baureihe_KGT = getstring("PM_BAUREIHE.RAW", m_strProductPath);
		Vorspannung = getstring("P_VORSPANNKLASSE_BEZ_C.RAW", m_strProductPath);
		KFTragabFak = getKFTragabFak();
		CRed		= getCRed();
		C0Red		= getC0Red();
		UmlAnz		= getdouble("P_UML", m_strProductPath);
		z_1;		= getdouble("P_Z1", m_strProductPath);
		
		if (this.Baureihe_KGT=="Standard PLSA") {
			mueWert	= replace(getstring("P_REIBWERT_PLSA_EINGELAUFEN.RAW", m_strProductPath),',','.');    // m     = Reibwert PLSA eingelaufen
			pkWert	= replace(getstring("P_KONVEKTIONSLEISTUNG.RAW", m_strProductPath),',','.');    	  // PK     = Konvektionsleistung
			mWert	= replace(getstring("P_INTERPOL_MUEWERT.RAW", m_strProductPath),',','.');    		  // m      = Interpolation u-Wert aus Vorspannung
			vierFpr	= replace(getstring("P_VIERFACHE_VORSPKRAFT.RAW", m_strProductPath),',','.');    	  // 4 Fpr  = Vierfache Vorspannkraft
			MRD		= replace(getstring("P_REIBM_STANDARD_DICHTUNGEN.RAW", m_strProductPath),',','.');    // MRD    = Reibmoment Standarddichtungen
			MRPLSA	= replace(getstring("P_REIBM_PLSA_MUTTER_AUS_VORSP.RAW", m_strProductPath),',','.');  // MRPLSA = Reibmoment PLSA-Mutter aus "Vorsp."
			
			// Fv = Vorspannkraft F_V aus Datenbank (s.o.) 
			strMatNr = replace(strMatNr, "IDC_SEARCH_TAB_", "")
		}
	}
	
	function	berechneKGTMasse()
	{
		var nSPUAnz = getint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
		return (m_KGTMutter + nSPUAnz * m_SPU);	// vorlaeufig!!!!
	}
	
	function	 isAGK()
	{
		return (Baureihe_KGT == "Antriebseinheit AGK") ? true : false;
	}

	function	 isFAR()
	{
		return (Baureihe_KGT == "Antriebseinheit FAR") ? true : false;
	}
	function	 isFAR_Mutter()
	{
		return (Baureihe == "FAR") ? true : false;
	}

	function	getKFTragabFak()
	{	
		var dFak = 1.;
		var dBetriebsfaktor = getdouble("KF", "DLGDATA.KGTDATEN");
		if (dBetriebsfaktor > 1.) {
			dFak = 1. / dBetriebsfaktor;
		}
		
		var dTragzahlabschlag = getdouble("TRAGZAHLABSCHLAG", "DLGDATA.KGTDATEN");
		if (dTragzahlabschlag >= 0. && dTragzahlabschlag <= 100.) {
			dFak *= (1 - dTragzahlabschlag / 100.);
		}
		return dFak;
	}
	
	function	getCRed()
	{
		return C * KFTragabFak;
	}
	
	function	getC0Red()
	{
		return C0 * KFTragabFak;
	}
	
	function	getf_nk()
	{
		if (nSPU == 0)	{
			switch (strLagerart)	{
			case "FEST_LOS":
				return (getstring("FL2ROTATIONSLAGER", "DLGDATA.KGTSYSTEM")== "true") ? 27.4 : 18.9;
				break;
			case "FEST_FEST":
				return 27.4;
				break;
			case "FEST_FREI":
				return 4.3;
				break;
			}
		}
		else
			return (nSPU > 1) ? 12.1 : 16.9;
		return 0;
	}
	
	function	getl_n()	// (5.1.2, 5.1.3)
	{
	/*	
		var strVorsp	= getstring("P_VORSPANNKLASSE_BEZ_C","DLGDATA.KGTDATEN");
		if (nSPU == 0)
			return (strVorsp == "") ? L_Lager : (L_Lager - L_Mutter/2);
		return (L_Lager / (2 + nSPU) + L_Mutter);
	*/
		return (nSPU == 0) ? L_Lager : (L_Lager / (1 + nSPU) + L_Mutter);
	}
	
	function	getl_K()
	{
		return (L_Lager - L_Mutter/2);
	}
	
	function	getf_FK()	//
	{
		switch (strLagerart)	{
		case "FEST_LOS":
			return 20.4;
			break;
		case "FEST_FEST":
			return 40.6;
			break;
		case "FEST_FREI":
			return 2.6;
			break;
		}
		return 0;
	}
	
	function getn_kzul()
	{
		var dFak	= (nSPU == 0) ? 0.8 : 0.64;
		var f_nk	= getf_nk();
		var l_n		= getl_n();
		// -mw- 14.11.2013: Vorspannung ist jetzt ein String - gendert nach Rcksprache mit Hr. Schmee
		// if ((Vorspannung>0) && (nSPU==0)) {
		if ((this.Vorspannung != 'C0') && (this.nSPU==0)) {
			l_n=l_n-this.L_Mutter/2.0;
		};
		if (l_n == 0)
			return 0;
		var n_kzul	= dFak * f_nk * d_2 / (l_n * l_n) * 1E7;
		return n_kzul;
	}
	
	function	getF_kzul()
	{
		var dFak = 0.5;
		var f_FK = getf_FK();
		var l_K = getl_K();
		if (l_K == 0)
			return 0;
		var dTmp = d_2 * d_2 / l_K;
		var F_kzul = dFak * f_FK * dTmp * dTmp * 1E4;
		return F_kzul;
	}
	
	function	getRSpindelFak()
	{
		return (strLagerart == "FEST_FEST") ? 660 : 165;
	}
	
	function	getR_Spindel()
	{
		var dSPFak = getRSpindelFak();
		if (L_Lager == 0)
			return 0;
		var dTmp = d_0 - 0.71 * D_W;
		var R_Spindel = dSPFak * dTmp * dTmp / L_Lager;
		return R_Spindel;
	}
	
	function	getR_totohneLager()
	{
		var strVorsp	= getstring("P_VORSPANNKLASSE_BEZ_C","DLGDATA.KGTDATEN");
		if (strVorsp == "")
			return 0;

		var R_Spindel = getR_Spindel();
		var R_totohneLager = R_Spindel * R_nu / (R_Spindel + R_nu);
		return R_totohneLager;
	}
	
	function	berechneMReibGes()
	{
		var M_Reib_SPU_ges = 0;
		if (isAGK())	{
			var nAnzSPU = getint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
			M_Reib_SPU_ges = M_Reib_SPU * nAnzSPU;
		}
		return (M_RL + T_RD + M_Reib_SPU_ges);
	}
	
	function	getJ()
	{
		// return isAGK() ? (J_SpindelSpz * L_Lager) : J_Mutter;
		return isFAR() ? J_Mutter : (J_SpindelSpz * L_Lager / 1000);
	}
	
	function	berechneKGTDaten()
	{
		logtraceln("berechneKGTDaten()");
		var strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
		var strDestPath = "DLGDATA.KGTDATEN_KRAEFTE";
		var dMasse = berechneKGTMasse();
		setstring ("KGTMASSE",strDestPath,dMasse);
		var dFZusatz = abs(getdouble("ZUSATZLAST.RAW", "DLGDATA.KGTHINWEISE"));
		berechneKGTKraefte("F_AEQUI_EXT",dMasse, dFZusatz, true);
		
		// var P = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");	// Spindelsteigung
		var eta = 0.9;
		
		twoPi = GetGlobalConst("twoPi");
		var Pi= GetGlobalConst("Pi");
		P_Eta = this.P / (twoPi * eta);
		
		var nAnz = getint("SIZE", strPathProfil);
		var mu=0.004; // Rollreibwert
		var rho=7850; // Dichte Kugelnd in [kg/m3]
		var F_GesMax = 0;	// F_qMax
		var F_ExtMax = 0;
		var M_GesMax = 0;
		var nPhaseMax = -1;
		var nPhaseFMax = -1;
		var nPhaseMMax = -1;
		var F_Aequi = 0;
		var F_Aequi_ext = 0;
		var PR_gesamt = 0;
		var M_Reibung_Ges = berechneMReibGes();
		var J = getJ();
		var a_max_zul_limit=50.0; // Obergrenze fuer maximale Beschleunigung, abhaengig von Baureihe
		if (this.Baureihe_KGT=="eLINE KGT") {
			a_max_zul_limit=20.0
		};
		for (i = 0; i < nAnz; i++)	{
			var strPathPhase = strPathProfil + "." + i;
			var strTmpPath = strDestPath + "_ARRAY[" + i + "]";
			var F_EXT = abs(getdouble("F_EXT.BASE", strTmpPath));
			// F_EXT += dFZusatz;
			var F_GES = berechneFGes(F_EXT, F_V, Vorspannung);
			var qs		= getdouble("QS.RAW", strPathPhase) / 100;
			var qt		= getdouble("QT.RAW", strPathPhase) / 100;
			/* Wir bentigen hier die durchschnittliche Drehzahl pro Phase.
			   Die Werte im Store bedeuten NE = End-Drehzahl, NM = Mittlere Drehzahl, V analog
			   Problem: NM scheint nicht zu stimmen, bei Phase mit 0 Drehzahl haben wir statt dessen den Wert der vorigen Phase!
			   Also berechnen wir NM aus VM mit VM in [m/sec]: VM * 1000 * 60 = [mm/min] / Spindelsteigung [mm] = NM in [1/min]
			   Das sollte dann fr alle Dynamik-Eingabevarianten stimmen
			*/
			var nPhaseX	= getdouble("NE.RAW", strPathPhase);
			var nPhase	= getdouble("NM.RAW", strPathPhase) * 60;
			var dVM	= getdouble("VM.RAW", strPathPhase);
			var dVE	= getdouble("VE.RAW", strPathPhase);
			var dNmittelPhase = dVM * 60 / this.P;
			// -mw- 8.11.2013: von und auf oder gendert, weil sonst Stillstandsphasen mit hoher Kraft nicht bercksichtigt werden (Meldung Hr. Schmee)
			if (((qs > 0) || (qt > 0)) && F_GES > F_GesMax)	{
				F_GesMax = F_GES;
				nPhaseMax = i;
			}
			if (((qs > 0) || (qt > 0)) && F_EXT > F_ExtMax)	{
				F_ExtMax = F_EXT;
			}
			var a		= abs(getdouble("AE.BASE", strPathPhase));
			var M_Axial	= abs(F_EXT) * P_Eta;
			
			// a_max_zul Berechnung Formel 3.1 (Welche Formel 3.1? kann nicht zugeordnet werden )
			var a_max_zul;
			if (this.Baureihe_KGT=="Standard PLSA") {
				a_max_zul=30.0
				
				var Mrpr = 0;
				if (F_EXT >= (this.vierFpr - 0)) {
					// -mw- 21.11.2013:d0 ist in [mm], soll hier aber in [m] benutzt werden:
					Mrpr = F_EXT * (this.mueWert - 0) *  this.d_0 / (2.0 * 1000);
				} else {
					Mrpr = (this.mWert - 0) * F_EXT + (this.MRPLSA - 0);
				}
				var Mr = Mrpr + (this.MRD - 0); 
				var Pr = Mr * ((2.0 * Pi * dNmittelPhase) / 60.0) * qt;
				PR_gesamt += Pr;
				
			} else {
				a_max_zul=mu*F_GES*this.P*1000.0/(this.d_0*Pi)/(2*this.z_1*0.5*sqrt(2)*4/3*pow(this.D_W,3)/8.0e9*Pi*rho*(1+4/5*this.D_W/(2*this.d_0)));
				a_max_zul=(a_max_zul<a_max_zul_limit)?a_max_zul:a_max_zul_limit;
			};
			
			setdouble("F_GES.BASE", strTmpPath, F_GES);
			setdouble("M_AXIAL.BASE", strTmpPath, M_Axial);
			setdouble("A_MAX_ZUL.BASE",strTmpPath,a_max_zul);
			//var M_Traegheit_ges_Phase = getJ() * twoPi * a / P;
			var M_Traegheit_ges_Phase = J * twoPi * a / P;
			setdouble("M_TRAEGHEIT.BASE", strTmpPath, M_Traegheit_ges_Phase);
			var M_System_KGT = M_Axial + M_Traegheit_ges_Phase + M_Reibung_Ges;
			setdouble("M_SYSTEM.BASE", strTmpPath, M_System_KGT);
			if (qs > 0 && qt > 0 && M_System_KGT > M_GesMax)	{
				M_GesMax = M_System_KGT;
				nPhaseMMax = i;
			}
			var dTmp = F_GES * F_GES * F_GES * qs;
			F_Aequi += dTmp;
			logtraceln("Phase "+i+": F_EXT="+F_EXT+" F_GES "+F_GES+"^3 * qs "+qs+" = "+dTmp + " (Summe: "+F_Aequi+")");
			//F_Aequi_ext += F_EXT * F_EXT * F_EXT * qs;
		}
		F_Aequi = root(F_Aequi, 3);
		logtraceln(">>> F_Aequi = "+F_Aequi);
		
		// -mw- 14.11.2013: Wir berechnen im Fall des PLSA jetzt die quivalente Leistung, als Wrmebetrachtung
		setdouble("PR_GESAMT", "DLGDATA.KGTDATEN", PR_gesamt);
		
		//F_Aequi_ext = root(F_Aequi_ext, 3);
		//if (getstring("F_AEQUI_GES.PROFILEID", strDestPath) == "")	{
		//	dRet = createobject(strDestPath, "F_AEQUI_GES", 49, "11");
		//}
		setdouble("F_AEQUI_GES.BASE", strDestPath, F_Aequi);
		/*
		if (getstring("F_AEQUI_EXT_GES.PROFILEID", strDestPath) == "")	{
			dRet = createobject(strDestPath, "F_AEQUI_EXT_GES", 49, "11");
		}
		setdouble("F_AEQUI_EXT_GES.BASE", strDestPath, F_Aequi_ext);
		*/
		if (getstring("F_GESMAX.PROFILEID", strDestPath) == "")	{
			dRet = createobject(strDestPath, "F_GESMAX", 49, "11");
		}
		setdouble("F_GESMAX.BASE", strDestPath, F_GesMax);
		setstring("PHASE_F_GESMAX", strDestPath, ("T" + (nPhaseMax + 1)));
		
		if (getstring("F_EXTMAX.PROFILEID", strDestPath) == "")	{
			dRet = createobject(strDestPath, "F_EXTMAX", 49, "11");
		}
		setdouble("F_EXTMAX.BASE", strDestPath, F_ExtMax);
		
		if (F_GesMax != 0)	{
			setdouble("CFMAX_VRHLTNS", strDestPath, CRed / F_GesMax);
			setdouble("C0FMAX_VRHLTNS", strDestPath, C0Red / F_GesMax);
		}
		else	{
			setdouble("CFMAX_VRHLTNS", strDestPath, 0);
			setdouble("C0FMAX_VRHLTNS", strDestPath, 0);
		}
		if (getstring("M_GESMAX.PROFILEID", strDestPath) == "")	{
			dRet = createobject(strDestPath, "M_GESMAX", 49, "10016"); // Unit Drehmoment
		}
		setdouble("M_GESMAX.BASE", strDestPath, M_GesMax);
		setstring("PHASE_M_GESMAX", strDestPath, ("" + (nPhaseMMax + 1)));
		
		var dCFaequiVrhltns = (F_Aequi != 0) ? CRed / F_Aequi : 0;
		var L_10 = dCFaequiVrhltns * dCFaequiVrhltns * dCFaequiVrhltns * 1E6;
		
		setdouble("CFAEQUI_VRHLTNS", strDestPath, dCFaequiVrhltns);
		setdouble("L_10", strDestPath, L_10);
		var NM = getdouble("VM.BASE", strPathProfil) / P;
		var L_H10 = L_10 / (3600 * NM);
		var L_KM10 = (L_10 * P / 1000);
	
		setdouble("L_H10", strDestPath, L_H10);
		setdouble("L_KM10", strDestPath, L_KM10);
		setdouble("R_TOT", strDestPath, getR_totohneLager());
		
		createobject (strDestPath,"L_DIST",49,"10010");
		setdouble ("L_DIST.BASE",strDestPath,L_KM10*1000); // Basiseinheit m (der Dimension) wird verwendet, nicht Basiseinheit km dees Profils)
		
		
		return F_Aequi;
	}
	
	function	berechneFExt(dZusatzmasse, bProzesskraft)
	{
		var strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
		var nAnz = getint("SIZE", strPathProfil);
		var aFExt = new Array(nAnz);
		Alpha = getdouble("10003.BASE", "DLGDATA.SYSTEM");
		Beta  = getdouble("10004.BASE", "DLGDATA.SYSTEM");
		g = GetGlobalConst("g");
		a = g * cos(Alpha) * sin(Beta);
		
		for (i = 0; i < nAnz; i++)	{
			var F_XB = berechneBeschleunigungskraft(i, dZusatzmasse);
			var F_XG = berechneKraft(i, dZusatzmasse, a);
			var F_XP = 0;
			if (bProzesskraft)	{
				F_XP = berechneProzesskraft(i);
			}
			var F_EXT = F_XG + F_XB + F_XP;
			aFExt[i] = F_EXT;
		}
		return aFExt;
	}

	function	berechneKGTLebensdauer()
	{
		var strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
		var dMasse = berechneKGTMasse();
		var aFext = berechneFExt(dMasse, true);
		var dFZusatz = abs(getdouble("ZUSATZLAST.RAW", "DLGDATA.KGTHINWEISE"));
		
		var nAnz = getint("SIZE", strPathProfil);
		var F_Aequi = 0;
		for (i = 0; i < nAnz; i++)	{
			var strPathPhase = strPathProfil + "." + i;
			var F_EXT = abs(aFext[i]) + dFZusatz;
			var F_GES = berechneFGes(F_EXT, F_V, Vorspannung);
			var qs		= getdouble("QS.RAW", strPathPhase) / 100;
			if (qs > 0)
				F_Aequi += F_GES * F_GES * F_GES * qs;
		}
		F_Aequi = root(F_Aequi, 3);
		
		var dCFaequiVrhltns = (F_Aequi != 0) ? CRed / F_Aequi : 0;
		var L_10 = dCFaequiVrhltns * dCFaequiVrhltns * dCFaequiVrhltns * 1E6;
		return L_10;
	}
	 
	function	generiereWarnhinweise()
	{
		var strPath = "DLGDATA.KGTDATEN";
		delete("WARNHINWEISE", strPath);
		var strProdDynamikPath = "DLGDATA.KGTDATEN_KRAEFTE";
		var strMsg;
		var oldHinweisCount=getdouble ("WARNHINWEISCOUNT",strPath);
		var showLebensdauer=true;
		
		BestimmeDynZyklusMaxima();
		// BestimmeDynamikDiverseMaxima();

		dVmaxZyklus		= getdouble("VMAX", "DLGDATA.DYNZYKLUS.MAXIMA");
		dHubmaxZyklus	= getdouble("HUBMAX", "DLGDATA.DYNZYKLUS.MAXIMA");
		dAmaxZyklus		= getdouble("AMAX", "DLGDATA.DYNZYKLUS.MAXIMA");
		
		bSevereError = 0
		n = 0
		var strMsg;
		
		// Kinematik
		var strPathProfil = "DLGDATA.DYNZYKLUS.PROFIL";
		var strKraeftePath = "DLGDATA.KGTDATEN_KRAEFTE";
		var nAnz = getint("SIZE", strPathProfil);
		
		for (i = 0; i < nAnz; i++)	{
			var strPathPhase = strPathProfil + "." + i;
			var strTmpPath = strKraeftePath + "_ARRAY[" + i + "]";
		
			var a		= abs(getdouble("AE.BASE", strPathPhase));
			var a_max_zul=getdouble("A_MAX_ZUL.BASE",strTmpPath);
			if (a > a_max_zul)	{
				strMsg = translate("IDC_MSG_AMAX_VIOLATION");
				setstring("WARNHINWEISE[" + n +"].text", strPath, sprintf(strMsg, a_max_zul,i+1, a));
				n++;
				showLebensdauer=false;
			}
		}

		if (dVmaxZyklus > v_maxzul)	{
			strMsg = translate("IDC_MSG_VMAX_VIOLATION");
			setstring("WARNHINWEISE[" + n +"].text", strPath, sprintf(strMsg, v_maxzul, dVmaxZyklus));
			n++;
			showLebensdauer=false;
		}
		
		var n_kzul = getn_kzul();
		var dNmaxZyklus = dVmaxZyklus / P * 60;
		// Bedingung pruefen!!!
		
		if (!isFAR() || (this.strLagerart!="FEST_FEST")) {
			if (dNmaxZyklus > n_kzul)	{
				strMsg = translate("IDC_MSG_NZUL_VIOLATION");
				var strTmp = sprintf(strMsg, n_kzul, dNmaxZyklus)
				setstring("WARNHINWEISE[" + n +"].text", strPath, strTmp);
				n++;
				showLebensdauer=false;
			}
		};
		
		// Geometrie
		// Kurzhub
		strEingabeart = getstring("EINGABEART","DLGDATA")
		if ((strEingabeart != "ZEITANTEILE") && (dHubmaxZyklus <= (3.5 * UmlAnz * P)))	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_KURZHUB");
			n++;
		}
		
		if (L_Mutter > L_Lager)	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_LMUTTER_VIOLATION");
			n++;
		}
		
		if ((L_Mutter + dHubmaxZyklus) > L_Lager)	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_HUBLMUTTER_VIOLATION");
			n++;
		}
		
		// Dynamik
		var F_GesMax	= getdouble("F_GESMAX.BASE", strProdDynamikPath);
		var F_ExtMax	= getdouble("F_EXTMAX.BASE", strProdDynamikPath);
		var F_Aequi		= getdouble("F_AEQUI_GES.BASE", strProdDynamikPath);
		var F_Aequi_ext = getdouble("F_AEQUI_EXT.BASE", strProdDynamikPath);
		
		var F_kzul		= getF_kzul(); // zul. axiale Spindelbelastung
		
		if (F_GesMax > 0.5*CRed)	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_KGTMAXBELASTUNG");
			showLebensdauer=false;
			n++;
		}
		if (F_ExtMax > F_kzul)	{
			strMsg = translate("IDC_MSG_FKZUL_VIOLATION");
			setstring("WARNHINWEISE[" + n +"].text", strPath, sprintf(strMsg, F_kzul, F_ExtMax));
			showLebensdauer=false;
			n++;
		}
		/* -mw- 14.11.2013: Nach Rcksprache mit Hr. Schmee ausgeklammert, weil "Vorspannung" jetzt ein freier String und kein Wert mehr ist
		if (F_GesMax > (2.5 * CRed * Vorspannung / 100))	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_KGTVORSPANNUNGSFREI");
			n++;
		}
		*/
		
		if ( (CRed / F_Aequi) < 4)	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_DYNLASTVERHAELTNIS");
			n++;
		}
		if ( (C0Red / F_GesMax) < 4)	{
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MSG_STATLASTVERHAELTNIS");
			n++;
		}
			// Zusaetzlicher Warnhinweis (Feedback 5815)
			// nur wenn Berechnung erfolgt ist
		if (getstring('WAGEN.ID','DLGDATA.DATEN')!='') {
			var KGTSteifigkeit=getdouble ("R_TOT","DLGDATA.KGTDATEN_KRAEFTE")*1000000.0; // umrechnen in N/m
			var PFSSteifigkeit=getdouble ("10010.BASE","DLGDATA.SYSTEM");
			
			if ((KGTSteifigkeit!=0) && (PFSSteifigkeit>KGTSteifigkeit)) {
			setstring("WARNHINWEISE[" + n +"].text", strPath, "IDS_HIGHER_STIFFNESS")
			n = n + 1
			};
		};
		if (this.Baureihe_KGT=="Standard PLSA") {
			// -mw- 14.11.2013: Wir berechnen im Fall des PLSA jetzt die quivalente Leistung, als Wrmebetrachtung
			var dPr = getdouble("PR_GESAMT", strPath);
			if (dPr > this.pkWert) {
				// setstring("WARNHINWEISE[" + n +"].text", strPath, "IDS_MSG_WAERME_PLSA")
				setstring("WARNHINWEISE[" + n +"].text", strPath, "IDC_MELDUNG_PLSA_GEHT_NICHT")
				showLebensdauer=false;
				n = n + 1
			}
		};

		setstring ("WARNHINWEISCOUNT",strPath,n);
		if ((n>0) && (n!=oldHinweisCount)) {
			setbool ("NEWWARNHINWEIS",strPath,true);
		} else {
			setbool ("NEWWARNHINWEIS",strPath,false);
		};
		if (showLebensdauer) {
			setstring ("SHOWLEBENSDAUER",strPath,"visible");
		} else {
			setstring ("SHOWLEBENSDAUER",strPath,"hidden");
		};
		
		
	}
}
