#include "CDialogBase.b"
#include "Massen.b"
#include "MassenDynZyklus_Calc.b"
#include "KGTCalc.b"
#include "DatenAllg.b"
#include "4DMotionProfiler.b"

calcImage() {
	var profiler = new MotionProfiler();
	profiler.disableKraft();
	profiler.disableTitle();
	profiler.disableKoordSys();
	profiler.disableActiveFlag();
	profiler.initData();
	profiler.calcStartPosition(300);
	profiler.waitForImage();

};

updateMotionProfile() {
	calcImage();
	var strImg = GetAbsPath("/EKTemp/",true) + "\\"+getstring("STARTPOSIMAGEFILE","DLGDATA.4DMOTION");
	strImg=strImg.replace ("\\","/");
	var strResult=<<|<input></input><script>document.getElementById("IDC_4DMOTION_PROFILE").src="";document.getElementById("IDC_4DMOTION_PROFILE").src="$strImg$";</script>|;
    return strResult;	
};

//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initMassen();	
		InitMassenComboItems();
		TransferAxAlleMassen(false);		
		F_Aequi = berechneFAequiInKGTMassen();
		calcImage();
	}

    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_MASSE_UNIT_COMBO":
		strUnitID = getstring("MASSE.UNIT", "SELMASSE")
		nAnz = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			setstring("MASSE.UNIT", strPath, strUnitID)
		}
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_KGTMASSENDYNZEITANTEILE", "IDC_MASSENSCHWERPUNKT_EDIT_1_2|IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_2":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_3":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_4":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_5":
		clearResultsKGT();
		ClearResult();
	case "IDC_MASSENNAME_EDIT":
		InitMassenComboItems();
		strResult=updateMotionProfile();
		strResult += dlg.getDialogElementEx("IDD_KGTMASSENDYNZEITANTEILE", "IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSEN_BESCHLEUNIGUNGX_PHASE_UNIT_COMBO":
		strUnitID = getstring("A_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
		nAnzMassen = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			nAnzZyklen = getsize(strPath + ".ZYKLUSDATEN", "")
			for n = 0 to (nAnzZyklen - 1)
			{
				strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
				setstring("A.UNIT", strZyklusDatenPath, strUnitID)
			}
		}

		strElementIds = "";
		for (n = 1; n <= nAnzZyklen; ++n)	{
			strElementIds += "IDC_MASSEN_BESCHLEUNIGUNGX_PHASE_T" + n + "|";
			strElementIds += "IDC_MASSEN_BESCHLEUNIGUNGY_PHASE_T" + n + "|";
			strElementIds += "IDC_MASSEN_BESCHLEUNIGUNGZ_PHASE_T" + n + "|";
		}
		strElementIds.trimRight("|");
		strResult = dlg.getDialogElementEx("IDD_KGTMASSENDYNZEITANTEILE", strElementIds);
		
		return strResult;
		break;
	case "IDC_CALC_BUT":
		TransferAxAlleMassen(false);
		F_Aequi = berechneFAequiInKGTMassen();
		strResult=updateMotionProfile();
		strResult += "<input></input>" + dlg.updateTableCellClient("IDC_KRAFTBELASTUNG", getstring("F_AEQUI_MASSEN.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
		return strResult;
		break;
	case "IDC_MASSEN_COMBO":
		strSelMasseID = getstring("", "DLGDATA.SELMASSEID")
		TransferAxAlleMassen(false);
		setalias("SELMASSE", "DLGDATA.MASSEN[" + strSelMasseID + "]")
		InitMassenComboItems();
		calcImage();
		// kein return -> kompletter Refresh!
		break;
	case "IDC_CONTINUE_BUT":
		TransferAxAlleMassen(false);
		F_Aequi = berechneFAequiInKGTMassen();
		break;
	case "IDC_ALPHA_EDIT":
	case "IDC_BETA_EDIT":
	case "IDC_GAMMA_EDIT":		
		return updateMotionProfile();
		break;
		case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		InitMassenComboItems();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		InitMassenComboItems();
		break;

	}
}