#include "4DMotionProfiler.b"
#include "KGTCalc.b"
#include "KGT_DatenblattTools.b"

KGTProjectList_Datenblatt() {
	strRetPath = filedialog(0, "xml", "", "Project Files (*.xml)|*.xml|All Files(*.*)|*.*|", "")
	if (strRetPath != "")
	begin
		dPPos = rfind(strRetPath, ".")
		if (dPPos < 0)	
		{
			strRetPath = strRetPath + ".xml"
			dPPos = rfind(strRetPath, ".")
		}
		setstring("PROJECTFILE", "", strRetPath)
		savexml("DLGDATA", strRetPath)
		strRetPath = left(strRetPath, dPPos-1)
		strRetPath = strRetPath + "_KGT.rtf"
	end

#	strRetPath = filedialog(0, "rtf", "", "Data sheets (*.rtf)|*.rtf|All Files(*.*)|*.*|", "")
	if (strRetPath != "")
	{
		strProfilePath	= "DLGDATA.DYNZYKLUS.PROFIL"
		dXKoordFactor = getdouble("10080", "SELKOSYS")
	#	print dXKoordFactor
		if (dXKoordFactor < 0)
		{
			bRet = execute(strProfilePath, "REVERSESIGN")
		}

#		getdate("DATUM", "TMPDATA")
		strDate = getdatestring("DATUM", "TMPDATA", "%d.%m.%Y %H:%M:%S")
		setstring("DATENBLATT_FILENAME", "PROJECT.SETTINGS", strRetPath)
		strRetPath = replace(strRetPath, "\\", "\\\\")
		setstring("FILENAME", "TMPDATA", strRetPath)
		nLeftMargin = 96
		nTopMargin	= 10
		nBottomMargin = 40
		dXStep		= 57
		nHeight		= 155
		nMPSize		= 18
		nMPStart	= 0
		nMPEnd		= 9
		nWidth		= dXStep * (nMPEnd - nMPStart) + nLeftMargin
		
		updateDrehZahlZyklus();

		setint("LEFTMARGIN","TMPDATA.DYNZYKLUS.GRAPH1", nLeftMargin);
		setint("TOPMARGIN", "TMPDATA.DYNZYKLUS.GRAPH1", nTopMargin);
		setint("BOTTOMMARGIN", "TMPDATA.DYNZYKLUS.GRAPH1", nBottomMargin);
		setdouble("XSTEP", "TMPDATA.DYNZYKLUS.GRAPH1", dXStep);
		setint("WIDTH", "TMPDATA.DYNZYKLUS.GRAPH1", nWidth);
		setint("HEIGHT", "TMPDATA.DYNZYKLUS.GRAPH1", nHeight);
		setint("STARTPHASE", "TMPDATA.DYNZYKLUS.GRAPH1", nMPStart);
		setint("ENDPHASE", "TMPDATA.DYNZYKLUS.GRAPH1", nMPEnd);
		setalias("MPGRAPH", "TMPDATA.DYNZYKLUS.GRAPH1");
		specialexec("DRAW_MP")
		nMPStart	= nMPEnd
		nMPEnd		= nMPSize
		setint("LEFTMARGIN","TMPDATA.DYNZYKLUS.GRAPH2", nLeftMargin);
		setint("TOPMARGIN", "TMPDATA.DYNZYKLUS.GRAPH2", nTopMargin);
		setint("BOTTOMMARGIN", "TMPDATA.DYNZYKLUS.GRAPH2", nBottomMargin);
		setdouble("XSTEP", "TMPDATA.DYNZYKLUS.GRAPH2", dXStep);
		setint("WIDTH", "TMPDATA.DYNZYKLUS.GRAPH2", nWidth);
		setint("HEIGHT", "TMPDATA.DYNZYKLUS.GRAPH2", nHeight);
		setint("STARTPHASE", "TMPDATA.DYNZYKLUS.GRAPH2", nMPStart);
		setint("ENDPHASE", "TMPDATA.DYNZYKLUS.GRAPH2", nMPEnd);
		setalias("MPGRAPH", "TMPDATA.DYNZYKLUS.GRAPH2");
		specialexec("DRAW_MP")

		if (getstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_VERLAGERUNGEN_NOTIMPLEMENTED_LABEL")
		}
		else if (getstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_NO_VERLAGERUNGEN_LABEL")
		}
		else if (getstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_NO_VERLAGERUNGEN_WEGENBELASTUNGEN_LABEL")
		}
		else
		{
			strVerlPhase = getstring("VERLAGERUNGEN_SELPHASE", "DLGDATA")
			if ((strVerlPhase == "") or (strVerlPhase == "EMPTY"))	
			{
				strVerlText = translate("IDC_VERLAGERUNGEN_TEXT_UNBELASTET")
			}
			else	
			{
				strVerlText = translate("IDC_VERLAGERUNGEN_TEXT_PHASE_X")
				strVerlText = replace(strVerlText, "%s", strVerlPhase) 
			}
		}
		setstring("VERLAGERUNGEN_TEXT","TMPDATA", strVerlText)

		strRTF = "\\par @@@@\\pntext\\pard\\plain\\s21 \\f3\\fs20\\cf1\\insrsid11225590 "
		strRTF = strRTF + "\\loch\\af3\\dbch\\af0\\hich\\f3 \\'b7\\tab!@@@!@@@\\pard \\s21\\ql "
		strRTF = strRTF + "\\fi-360\\li360\\ri0\\widctlpar\\jclisttab\\tx360"
		strRTF = strRTF + "@@@@\\*\\pn \\pnlvlblt\\ilvl0\\ls7\\pnrnot0\\pnf3\\pnstart1\\pnindent360\\pnsp120\\pnhang "
		strRTF = strRTF + "@@@@\\pntxtb \\'b7!@@@!@@@\\aspalpha\\aspnum\\faauto\\ls7\\adjustright\\rin0\\lin360\\itap0 "
		strRTF = strRTF + "@@@@\\f1\\fs20\\cf1\\insrsid11225590 "

#		write("Test.txt", strRTF)

		nWarnAnz = getsize("WARNHINWEISE", "DLGDATA.DATEN")
		if (nWarnAnz == 0)
			setstring("WARNHINWEISE_1", "TMPDATA.DATEN", translate("IDC_MSG_NO_WARNING"))
		else
			setstring("WARNHINWEISE_1", "TMPDATA.DATEN", translate(getstring("WARNHINWEISE[0].text", "DLGDATA.DATEN")))
		strWarnHinweise = ""
		for n = 1 to (nWarnAnz - 1)
		{
			strWarnHinweise = strWarnHinweise + strRTF + translate(getstring("WARNHINWEISE[" + n + "].text", "DLGDATA.DATEN"))
#			print strWarnHinweise
		}
#		write("Test2.txt", strWarnHinweise)
#		print strWarnHinweise
		setstring("WARNHINWEISE", "TMPDATA.DATEN", strWarnHinweise)

		dZusatzLast = getdouble("ZUSATZLAST.RAW", "DLGDATA.HINWEISE")
		dFVorsp		= getdouble("F_VORSP.RAW", "DLGDATA.DATEN")
#		strZusatzlast	= getstring("ZUSATZLAST.RAW", "DLGDATA.HINWEISE")
#		strFVorsp		= getstring("F_VORSP.RAW", "DLGDATA.DATEN")
		strZusatzlast	= formatstring(dZusatzLast, "%.0f")
		strFVorsp		= formatstring(dFVorsp, "%.0f")
		nAnzZyklen = 18
		for n = 0 to (nAnzZyklen - 1)
		{
			strSrcZyklusDatenPath = "DLGDATA.DYNZYKLUS.PROFIL." + n
			dQt = getdouble("QT.RAW", strSrcZyklusDatenPath)
			dQs = getdouble("QS.RAW", strSrcZyklusDatenPath)
			strDestPathZusatzlast	= "TMPDATA.ZUSATZLAST[" + n + "]"
			strDestPathFVorsp		= "TMPDATA.FVORSP[" + n + "]"
			if ((dQt > 0 and dQs > 0))
			{
				setstring("VALUE",strDestPathZusatzlast, strZusatzlast)
				setstring("VALUE",strDestPathFVorsp, strFVorsp)
			}
			else	
			{
				setstring("VALUE",strDestPathZusatzlast, "")
				setstring("VALUE",strDestPathFVorsp, "")
			}
		}

		dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
		dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")

		if ((dFWAnz == 1) or ((dFWAnz == 2) and (dFSAnz == 2)))
			setstring("10007.VALUE", "TMPDATA.SYSTEM", "/")
		else
			setstring("10007.VALUE", "TMPDATA.SYSTEM", getstring("10007.VALUE", "DLGDATA.SYSTEM"))

		if (dFWAnz == 8)
			setstring("10008.VALUE", "TMPDATA.SYSTEM", getstring("10008.VALUE", "DLGDATA.SYSTEM"))
		else
			setstring("10008.VALUE", "TMPDATA.SYSTEM", "/")

		if (dFSAnz == 1)
			setstring("10009.VALUE", "TMPDATA.SYSTEM", "/")
		else
			setstring("10009.VALUE", "TMPDATA.SYSTEM", getstring("10009.VALUE", "DLGDATA.SYSTEM"))

		if (getdouble("10073.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10073.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10073", "TMPDATA.DATEN.WAGEN.10073")
		if (getdouble("10074.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10074.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10074", "TMPDATA.DATEN.WAGEN.10074")
		if (getdouble("10075.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10075.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10075", "TMPDATA.DATEN.WAGEN.10075")
		if (getdouble("10076.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10076.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10076", "TMPDATA.DATEN.WAGEN.10076")
		if (getdouble("10078.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10078.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10078", "TMPDATA.DATEN.WAGEN.10078")
		if (getdouble("10079.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10079.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10079", "TMPDATA.DATEN.WAGEN.10079")


		nStatus = getint("STATUS", "DLGDATA.DATEN")
		if ((isbitset(nStatus, 1) == 0) and (isbitset(nStatus, 4) == 0) and (isbitset(nStatus, 5) == 0))
		{
			for n = 0 to (dFWAnz - 1)
			{
				strSrc	= "DLGDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				dValue	= getdouble("VALUE", strSrc)
				strTmp = formatstring(dValue,"%.2e")
				setstring("VALUE", strDest, strTmp)
#				copy(strSrc, strDest)
				strSrc	= "DLGDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
				dValue	= getdouble("", strSrc)
				strTmp = formatstring(dValue,"%.2e")
#				copy(strSrc, strDest)	# funzt nicht!!
				setstring("", strDest, strTmp)
			}
		}
		else
		{
			for n = 0 to (dFWAnz - 1)
			{
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				setstring("VALUE", strDest, "/")
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
#				copy(strSrc, strDest)	# funzt nicht!!
				setstring("", strDest, "/")
			}
		}
		 // Zahl der Zyklen im Bewegungsablauf bestimmen
		var anzZyklen=getsize("DLGDATA.MASSEN[0].ZYKLUSDATEN", "");
		var ss="";
		var anzAktivZyklen=0;
		for (var i=0;i<anzZyklen;i++) {
			ss=getstring("QT.RAW","DLGDATA.DYNZYKLUS.PROFIL."+i);
		if (ss!="0" && ss!="" ) {
			anzAktivZyklen=i+1;
			};
		};
		anzZyklen=anzAktivZyklen;
		// Daten fuer Kraefte, Vorspannung und Antriebsmomente fuer Ausdruck in Store speichern
		// Loeschen
		for (i=0; i<18;i++) {
			delete ("F_GES_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT");
			delete("F_VORSP_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT");
			delete("GESAMT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT");
			delete("M_KGT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT");
			delete("N_KGT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT");
		};
		// aktuelle Daten Uebertragen
		var f_ges;
		var f_ext;
		var ne;
		var m_kgt
		var f_v=getdouble ("P_FV","KGT");
		var f_v_text;
		for (i=0; i<anzZyklen;i++) {

			f_ext=getdouble("F_EXT.BASE","DLGDATA.KGTDATEN_KRAEFTE_ARRAY["+i+"]");
			f_ges=getdouble("F_GES.BASE","DLGDATA.KGTDATEN_KRAEFTE_ARRAY["+i+"]");
			m_kgt=getdouble("M_SYSTEM.BASE","DLGDATA.KGTDATEN_KRAEFTE_ARRAY["+i+"]");
			ne=getdouble("NE.VALUE","DLGDATA.DYNZYKLUS.PROFIL."+i);
			if (abs(f_ext)<2.5*f_v) {
				f_v_text=translate ("IDC_KGT_JA");
			} else {
				f_v_text=translate ("IDC_KGT_NEIN");
			};

			setstring ("F_GES_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT",formatstring(f_ext,"%.0f"));
			setstring ("F_VORSP_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT",f_v_text);
			setstring ("GESAMT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT",formatstring(f_ges,"%.0f"));
			setstring ("M_KGT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT",formatstring(m_kgt,"%.1f"));
			setstring ("N_KGT_T_"+i,"DLGDATA.KGTDATEN.DATENBLATT",formatstring(ne,"%.0f"));
		};
  
		
		
		// Werte fuer Antriebsattribute in Store uebertragen
		var KGTCalc= new CKGTCalc("KGT");
		
		var fnk= KGTCalc.getf_nk(); // Beiwert biegekritische Drehzahl
		var nkzul= KGTCalc.getn_kzul();// zulaessige Betriebsdrehzahl	  
		var ffk= KGTCalc.getf_FK();// Beiwert Knickung
		var fkzul= KGTCalc.getF_kzul(); // zulaessige axiale Spindelbelastung
		var rspindel= KGTCalc.getR_Spindel();
		var rtot= KGTCalc.getR_totohneLager();
		var mreibges=KGTCalc.berechneMReibGes();
		var P_DW=getdouble ("P_DW.VALUE","KGT");
		KGTCalc.generiereWarnhinweise();
		var nmax = getdouble ("NMAX","DLGDATA.DYNZYKLUS.MAXIMA")*60.0;
		var nm= getdouble ("NM.BASE","DLGDATA.DYNZYKLUS.PROFIL")*60.0;
		
		var lagerart= getstring ("LAGERART","DLGDATA.KGTSYSTEM");
		if (KGTCalc.isFAR() && lagerart=="FEST_FEST") {
			setstring ("FNK","DLGDATA.KGTDATEN.DATENBLATT","");   // Diese Werte sind bei FAR irrelevant => Keine Ausgabe
			setstring ("NKZUL","DLGDATA.KGTDATEN.DATENBLATT","");		
		} else {
			setstring ("FNK","DLGDATA.KGTDATEN.DATENBLATT",fnk);
			setstring ("NKZUL","DLGDATA.KGTDATEN.DATENBLATT",nkzul);
		};
		setstring ("FFK","DLGDATA.KGTDATEN.DATENBLATT",ffk);
		setstring ("FKZUL","DLGDATA.KGTDATEN.DATENBLATT",fkzul);
		setstring ("R_SPINDEL","DLGDATA.KGTDATEN.DATENBLATT",rspindel);
		setstring ("NMAX","DLGDATA.KGTDATEN.DATENBLATT",nmax);
		setstring ("NM","DLGDATA.KGTDATEN.DATENBLATT",nm);
		setstring ("R_GESAMT","DLGDATA.KGTDATEN.DATENBLATT",rtot);
		setstring ("M_LEER","DLGDATA.KGTDATEN.DATENBLATT",mreibges);
		var P_DW_STRING=P_DW+"";
		setstring ("P_DW","DLGDATA.KGTDATEN.DATENBLATT",P_DW_STRING);
		
		
		// Texte fuer Traegheitmomente bestimmen
		if (KGTCalc.isFAR_Mutter()) {
			setstring ("J_TEXT","DLGDATA.KGTDATEN.DATENBLATT",translate ("Massentraegheitsmoment_der_KGT_Mutter"));
			setstring ("J_SYM","DLGDATA.KGTDATEN.DATENBLATT",translate ("KGT_J_MUTTER"));
			setstring ("J_VALUE","DLGDATA.KGTDATEN.DATENBLATT",getdouble ("P_MASSENTRAEGHEIT_KGT.VALUE","KGT"))
			setstring ("J_UNIT","DLGDATA.KGTDATEN.DATENBLATT","[kgm<sup>2</sup>]");		
		} else {
			setstring ("J_TEXT","DLGDATA.KGTDATEN.DATENBLATT",translate ("spezifisches_Massentraegheitsmoment_der_KGT_Spindel"));
			setstring ("J_SYM","DLGDATA.KGTDATEN.DATENBLATT",translate ("KGT_J_SPINDEL"));
			setstring ("J_VALUE","DLGDATA.KGTDATEN.DATENBLATT",getdouble ("P_SPEZ_TRAEGHEIT_SPINDEL.VALUE","KGT"));
			setstring ("J_UNIT","DLGDATA.KGTDATEN.DATENBLATT","[kgm<sup>2</sup>/m]");
		};
		// Texte fuer Lebensdauer setze
		var DisplayWarnhinweise=getstring ("SHOWLEBENSDAUER","DLGDATA.KGTDATEN");
		if (DisplayWarnhinweise=="visible") {
			setstring ("L_KM10.VALUE","DLGDATA.KGTDATEN.DATENBLATT",formatstring (getdouble ("L_KM10","DLGDATA.KGTDATEN_KRAEFTE"),"%.2e"));
			setstring ("L_H10.VALUE","DLGDATA.KGTDATEN.DATENBLATT",formatstring (getdouble ("L_H10","DLGDATA.KGTDATEN_KRAEFTE"),"%.2e"));
			setstring ("L_10.VALUE","DLGDATA.KGTDATEN.DATENBLATT",formatstring (getdouble ("L_10","DLGDATA.KGTDATEN_KRAEFTE"),"%.2e"));
			
		} else {
			setstring ("L_KM10.VALUE","DLGDATA.KGTDATEN.DATENBLATT","");
			setstring ("L_H10.VALUE","DLGDATA.KGTDATEN.DATENBLATT","");
			setstring ("L_10.VALUE","DLGDATA.KGTDATEN.DATENBLATT","");
			
		};
		
		
		

		//var kosys=getstring ("DLGDATA.USER_KO.KO_SYSTEM.SELKOSYS");
		var alias=getalias ("SELKOSYS");
		var kosys=getstring("SELKOSYS.ID","");
		
		// Achsenbezeichnung und Richtung unter Berucksichtigung des User Koordinatensystems ermitteln
		var coord_label=new Array();
		var coord_dir=new Array();
		var coord_data=processUserCoordSysData();
		var coord_label=coord_data.label;
		var coord_dir=coord_data.dir;
		
		// Kraftwerte fuer Ausdruck unter Beruecksichtigung des User Koordinatensystems ermitteln
		//delete ("KRAFT","DLGDATA.KGTDATEN.DATENBLATT");
		
		
		for (var i=0;i<12;i++) {
			var kraft_x=getdouble ("KRAFT.X.VALUE","DLGDATA.KRAEFTE["+i+"]");
			kraft_x=kraft_x*coord_dir['X'];
			setstring ("KRAFT_"+i,"DLGDATA.KGTDATEN.DATENBLATT",kraft_x);
		};
		
		
		
		
		// Winkel anpassen
		// Entfernt gemaess FB 0005352 die Konvertierung
		//var adj_alpha=coord_dir['X']*getdouble ("10003.VALUE","DLGDATA.SYSTEM");
		//var adj_beta=coord_dir['Y']*getdouble ("10004.VALUE","DLGDATA.SYSTEM");
		//var adj_gamma=coord_dir['Z']*getdouble ("gamma","DLGDATA.WINKEL");
		var adj_alpha=getdouble ("10003.VALUE","DLGDATA.SYSTEM");
		var adj_beta=getdouble ("10004.VALUE","DLGDATA.SYSTEM");
		var adj_gamma=getstring ("GAMMA","DLGDATA.WINKEL")*1.0;
		
		// Texte fuer Namen der Drehachse und Tabellenuebeschrift fuer Kraefte in Ausdruck festlegen
		var axis_alpha_id;  // 
		var kraft_label_id;
		var richtung_kraft_id;
		switch (coord_label['X']) {
			case 'X':
				axis_alpha_id="KGT_DREHACHSE_X";
				kraft_label_id="KGT_F_GES_X";
				richtung_kraft_id="Richtung_Kraft_X";
			break;
			case 'Y':
				axis_alpha_id="KGT_DREHACHSE_Y";
				kraft_label_id="KGT_F_GES_Y";
				richtung_kraft_id="Richtung_Kraft_Y";
			break;
			case 'Z':
				axis_alpha_id="KGT_DREHACHSE_Z";
				kraft_label_id="KGT_F_GES_Z";
				richtung_kraft_id="Richtung_Kraft_Z";
			break;
		}
		switch (coord_label['Y']) {
			case 'X':
				axis_beta_id="KGT_DREHACHSE_X";
			break;
			case 'Y':
				axis_beta_id="KGT_DREHACHSE_Y";
			break;
			case 'Z':
				axis_beta_id="KGT_DREHACHSE_Z";
			break;
		}
		
		setstring ("DREHACHSE_ALPHA","DLGDATA.KGTDATEN.DATENBLATT",translate(axis_alpha_id));
		setstring ("DREHACHSE_BETA","DLGDATA.KGTDATEN.DATENBLATT",translate(axis_beta_id));
		setstring ("LABEL_KRAFT","DLGDATA.KGTDATEN.DATENBLATT",translate(kraft_label_id));
		setdouble ("ALPHA","DLGDATA.KGTDATEN.DATENBLATT",adj_alpha);
		setdouble ("BETA","DLGDATA.KGTDATEN.DATENBLATT",adj_beta);
		setdouble ("GAMMA","DLGDATA.KGTDATEN.DATENBLATT",adj_gamma);
		setstring ("RICHTUNG_KRAFT","DLGDATA.KGTDATEN.DATENBLATT",translate(richtung_kraft_id));

        // Text fuer Spindelunterstuetzung wahlen
		if  getbool("BSPINDELUNTERSTUETZUNG","DLGDATA.KGTSYSTEM") {
		    var stuetzanzahl=getstring("STUETZSTELLENANZ","DLGDATA.KGTSYSTEM");
			var imgSPU = GetAbsPath("/EKCatImage/") + "/" + translate ("IDC_KGT_IMG_SPU_"+stuetzanzahl);
			imgSPU = imgSPU.replace ("\\","/");
			var stuetzdist=getstring("L_SPINDEL.VALUE","DLGDATA.KGTSYSTEM");
			var stuetzfak=getstring("L_SPINDEL_FAK","DLGDATA.KGTSYSTEM");
			setstring ("HAS_SPU","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen
			setstring ("SPU_IMAGE","DLGDATA.KGTDATEN.DATENBLATT",imgSPU);
			setstring ("STUETZCOUNT","DLGDATA.KGTDATEN.DATENBLATT",stuetzanzahl);
			setstring ("STUETZDIST","DLGDATA.KGTDATEN.DATENBLATT",stuetzdist);
			stuetzfak=left(stuetzfak,strlen(stuetzfak)-2); // Hack , um = Zeichen zu entfernen
			setstring ("STUETZFAKTOR","DLGDATA.KGTDATEN.DATENBLATT",stuetzfak);
		} else {
			setstring ("HAS_SPU","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen
		};

		// Bild fuer Lagerart setzen
		var LagerImageFile= new FileName();
		var imgLagerArt=getstring ("LAGERARTIMAGE","DLGDATA.KGTSYSTEM");
		var LagerImageFile= new FileName(imgLagerArt);
		imgLagerArt=LagerImageFile.getFullName();
		imgLagerArt=imgLagerArt.split(".");
		imgLagerArt=imgLagerArt[0];
		// Image Filename fuer GUI in Filename Fuer Ausdruck uebersetzen
		imgLagerArtPrint=translate ("IDC_KGT_IMG_PRINT_"+imgLagerArt);
		imgLagerArtPrint = GetAbsPath("/EKCatImage/") + "/" + imgLagerArtPrint;
		imgLagerArtPrint = imgLagerArtPrint.replace("\\", "/");
		setstring ("LAGERARTIMAGE","DLGDATA.KGTDATEN.DATENBLATT",imgLagerArtPrint);
		// Text fuer zwei Rotationslager setzen
		
		var antriebsart= getstring ("PM_ANTRIEBSART","DLGDATA.KGTDATEN");
		
		
		
		if (lagerart=="FEST_LOS" && getbool("FL2ROTATIONSLAGER","DLGDATA.KGTSYSTEM")) {
			setstring ("HAS_TWO_ROTATIONSLAGER","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen
		} else {
			setstring ("HAS_TWO_ROTATIONSLAGER","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen		
		};
		
		if (getbool("FL2ROTATIONSLAGER","DLGDATA.KGTSYSTEM")) {
			setstring ("ZWEI_LAGER_TEXT","DLGDATA.KGTDATEN.DATENBLATT","$mit_2_Rotationslagern_auf_der_Loslagerseite$");
		} else {
			setstring ("ZWEI_LAGER_TEXT","DLGDATA.KGTDATEN.DATENBLATT","");
		};
		// Zusaetzliche Bemerkungen aktivieren oder abschalten
		if (lagerart=="FEST_FEST") {
			setstring ("ENABLE_ANNAHME_7","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen
		} else {
			setstring ("ENABLE_ANNAHME_7","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen
		}
		if (KGTCalc.isFAR()) {
			setstring ("ENABLE_ANNAHME_8","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen	
		} else {
			setstring ("ENABLE_ANNAHME_8","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen
		};
		
		if (antriebsart=="Angetriebene Spindel") {
			setstring ("ENABLE_ANNAHME_9","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen
		} else {
			setstring ("ENABLE_ANNAHME_9","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen
		};
		if (KGTCalc.isFAR() && lagerart=="FEST_FEST") {
			setstring ("ENABLE_ANNAHME_10","DLGDATA.KGTDATEN.DATENBLATT",'"1"="1"'); // Bedingung fuer Feldfunktion auf true setzen
		} else {
			setstring ("ENABLE_ANNAHME_10","DLGDATA.KGTDATEN.DATENBLATT",'"1"="2"'); // Bedingung fuer Feldfunktion auf false setzen
		};
		// Warnhinweise Bearbeiten
		var hinweiscount=getdouble ("WARNHINWEISCOUNT","DLGDATA.KGTDATEN");
		var hinweistext="";
		for (i=0;i<hinweiscount;i++) {
		    if (i>0) {
				hinweistext+=" <rtf> \\par </rtf> "; // Bis auf erste Zeile neuen Absatz Spaces sind Wichig!
			};
			hinweistext+=translate(getstring("WARNHINWEISE["+i+"].text","DLGDATA.KGTDATEN"));
			
		};
		setstring ("WARNUNG","DLGDATA.KGTDATEN.DATENBLATT",hinweistext);
		
		// Von Tragzahlabschlag abhaengige Texte setzen
		if (KGTCalc.getKFTragabFak()<1.0) {
		  // Tragzahlabschlag
		  setstring ("STAT_FORMEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_STAT_RED_FORMEL"));
		  setstring ("DYN_FORMEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_DYN_RED_FORMEL"));
		  setstring ("C_LABEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_C_RED"));
		  setstring ("LAST_LABEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_LOAD_RATIO_REDUCED"));
		} else {
		  // Kein Tragzahlabshlag
		  setstring ("STAT_FORMEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_STAT_FORMEL"));
		  setstring ("DYN_FORMEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_DYN_FORMEL"));
		  setstring ("C_LABEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_C"));
		  setstring ("LAST_LABEL","DLGDATA.KGTDATEN.DATENBLATT",translate("IDS_KGT_LOAD_RATIO"));
		};
		
		// 3D Grafik fuer Druck generieren
		var profiler=new MotionProfiler();
		profiler.enableKoordSys();
		profiler.disableMasse();
		profiler.disableKraft();
		profiler.disableTitle();
		profiler.initData();
		profiler.calcPrintProfile(1024);
		
		profiler.initData();
		profiler.calcPrintProfileAusgangsPos(1024);
		
		strDablaTempl	= getstring("10112.VALUE", "DLGDATA.SYSTEM")
		strDablaTemplID = getstring("10112.RAW", "DLGDATA.SYSTEM")
		strDablaTempl=dsgetstring ("10113.VALUE","11784");
		strDablaTemplID=dsgetstring ("10113.RAW","11784");
#		print strDablaTempl + "(ID:" + strDablaTemplID + ")"
		rtfread(strDablaTemplID, strDablaTempl)
		rtfparseandreplace(strDablaTemplID)
		rtfwrite(strDablaTemplID, strRetPath)
		// Dokumentvorlage fuer RTF Datei in das gleiche Verzeichnis kopieren
		var RtfFileName= new FileName(strRetPath);
		var RtfTemplateName = new FileName (strDablaTempl);
		var DocTemplateSrc= RtfTemplateName.getDir()+"EasyKatReport.dot";
		var DocTemplateDst=RtfFileName.getDir()+"EasyKatReport.dot";
		DocTemplateSrc=DocTemplateSrc.replace("\\", "/");
		DocTemplateDst=DocTemplateDst.replace("\\", "/");
		DocTemplateDst=DocTemplateDst.replace("//", "/");
		FileName.copyFile (DocTemplateSrc,DocTemplateDst,true);
		
		setalias("MPGRAPH", "DLGDATA.DYNZYKLUS.GRAPH");

		if (dXKoordFactor < 0)
		{
			bRet = execute(strProfilePath, "REVERSESIGN")
		}

	}
	delete("TMPDATA", "")
}
updateDrehZahlZyklus()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	strObjID = getstring("ID", strProfilePath);
	nMPSize = getint("RANGE.SIZE", strProfilePath);
	if (strObjID == "" || nMPSize <= 0)
		return ;
		
	dP = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");
	
	if (dP > 0)	{
		for (i = 0; i < nMPSize; ++i)	{
			dVe = getdouble("VE.BASE", strProfilePath + "." + i);
			dVm = getdouble("VM.BASE", strProfilePath + "." + i);
			if (dVe != 0)
				setdouble("NE.BASE", strProfilePath + "." + i, (dVe/dP));
			if (dVm != 0)
				setdouble("NM.BASE", strProfilePath + "." + i, (dVm/dP));
		}
	}
	
	return ;
}
