ProjectList_Datenblatt() {
	strRetPath = filedialog(0, "xml", "", "Project Files (*.xml)|*.xml|All Files(*.*)|*.*|", "")
	if (strRetPath != "")
	begin
		dPPos = rfind(strRetPath, ".")
		if (dPPos < 0)	
		{
			strRetPath = strRetPath + ".xml"
			dPPos = rfind(strRetPath, ".")
		}
		setstring("PROJECTFILE", "", strRetPath)
		savexml("DLGDATA", strRetPath)
		strRetPath = left(strRetPath, dPPos-1)
		strRetPath = strRetPath + "_PSF.rtf"
	end

#	strRetPath = filedialog(0, "rtf", "", "Data sheets (*.rtf)|*.rtf|All Files(*.*)|*.*|", "")
	if (strRetPath != "")
	{
		strProfilePath	= "DLGDATA.DYNZYKLUS.PROFIL"
		dXKoordFactor = getdouble("10080", "SELKOSYS")
	#	print dXKoordFactor
		if (dXKoordFactor < 0)
		{
			bRet = execute(strProfilePath, "REVERSESIGN")
		}

#		getdate("DATUM", "TMPDATA")
		strDate = getdatestring("DATUM", "TMPDATA", "%d.%m.%Y %H:%M:%S")

		// 21.6.2013 -mw- neu: Datenblatt ber Shellexecute anzeigen, um Probleme mit JS-Fehler im Browser auszuschliessen:
		// setstring("DATENBLATT_FILENAME", "PROJECT.SETTINGS", strRetPath)

		strRetPath = replace(strRetPath, "\\", "\\\\")
		setstring("FILENAME", "TMPDATA", strRetPath)
		nLeftMargin = 96
		nTopMargin	= 10
		nBottomMargin = 40
		dXStep		= 57
		nHeight		= 155
		nMPSize		= 18
		nMPStart	= 0
		nMPEnd		= 9
		nWidth		= dXStep * (nMPEnd - nMPStart) + nLeftMargin

		setint("LEFTMARGIN","TMPDATA.DYNZYKLUS.GRAPH1", nLeftMargin);
		setint("TOPMARGIN", "TMPDATA.DYNZYKLUS.GRAPH1", nTopMargin);
		setint("BOTTOMMARGIN", "TMPDATA.DYNZYKLUS.GRAPH1", nBottomMargin);
		setdouble("XSTEP", "TMPDATA.DYNZYKLUS.GRAPH1", dXStep);
		setint("WIDTH", "TMPDATA.DYNZYKLUS.GRAPH1", nWidth);
		setint("HEIGHT", "TMPDATA.DYNZYKLUS.GRAPH1", nHeight);
		setint("STARTPHASE", "TMPDATA.DYNZYKLUS.GRAPH1", nMPStart);
		setint("ENDPHASE", "TMPDATA.DYNZYKLUS.GRAPH1", nMPEnd);
		setalias("MPGRAPH", "TMPDATA.DYNZYKLUS.GRAPH1");
		specialexec("DRAW_MP")
		nMPStart	= nMPEnd
		nMPEnd		= nMPSize
		setint("LEFTMARGIN","TMPDATA.DYNZYKLUS.GRAPH2", nLeftMargin);
		setint("TOPMARGIN", "TMPDATA.DYNZYKLUS.GRAPH2", nTopMargin);
		setint("BOTTOMMARGIN", "TMPDATA.DYNZYKLUS.GRAPH2", nBottomMargin);
		setdouble("XSTEP", "TMPDATA.DYNZYKLUS.GRAPH2", dXStep);
		setint("WIDTH", "TMPDATA.DYNZYKLUS.GRAPH2", nWidth);
		setint("HEIGHT", "TMPDATA.DYNZYKLUS.GRAPH2", nHeight);
		setint("STARTPHASE", "TMPDATA.DYNZYKLUS.GRAPH2", nMPStart);
		setint("ENDPHASE", "TMPDATA.DYNZYKLUS.GRAPH2", nMPEnd);
		setalias("MPGRAPH", "TMPDATA.DYNZYKLUS.GRAPH2");
		specialexec("DRAW_MP")

		if (getstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_VERLAGERUNGEN_NOTIMPLEMENTED_LABEL")
		}
		else if (getstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_NO_VERLAGERUNGEN_LABEL")
		}
		else if (getstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "visible")
		{
			strVerlText = translate("IDC_NO_VERLAGERUNGEN_WEGENBELASTUNGEN_LABEL")
		}
		else
		{
			strVerlPhase = getstring("VERLAGERUNGEN_SELPHASE", "DLGDATA")
			if ((strVerlPhase == "") or (strVerlPhase == "EMPTY"))	
			{
				strVerlText = translate("IDC_VERLAGERUNGEN_TEXT_UNBELASTET")
			}
			else	
			{
				strVerlText = translate("IDC_VERLAGERUNGEN_TEXT_PHASE_X")
				strVerlText = replace(strVerlText, "%s", strVerlPhase) 
			}
		}
		setstring("VERLAGERUNGEN_TEXT","TMPDATA", strVerlText)

		strRTF = "\\par @@@@\\pntext\\pard\\plain\\s21 \\f3\\fs20\\cf1\\insrsid11225590 "
		strRTF = strRTF + "\\loch\\af3\\dbch\\af0\\hich\\f3 \\'b7\\tab!@@@!@@@\\pard \\s21\\ql "
		strRTF = strRTF + "\\fi-360\\li360\\ri0\\widctlpar\\jclisttab\\tx360"
		strRTF = strRTF + "@@@@\\*\\pn \\pnlvlblt\\ilvl0\\ls7\\pnrnot0\\pnf3\\pnstart1\\pnindent360\\pnsp120\\pnhang "
		strRTF = strRTF + "@@@@\\pntxtb \\'b7!@@@!@@@\\aspalpha\\aspnum\\faauto\\ls7\\adjustright\\rin0\\lin360\\itap0 "
		strRTF = strRTF + "@@@@\\f1\\fs20\\cf1\\insrsid11225590 "

#		write("Test.txt", strRTF)

		nWarnAnz = getsize("WARNHINWEISE", "DLGDATA.DATEN")
		if (nWarnAnz == 0)
			setstring("WARNHINWEISE_1", "TMPDATA.DATEN", translate("IDC_MSG_NO_WARNING"))
		else
			setstring("WARNHINWEISE_1", "TMPDATA.DATEN", translate(getstring("WARNHINWEISE[0].text", "DLGDATA.DATEN")))
		strWarnHinweise = ""
		for n = 1 to (nWarnAnz - 1)
		{
			strWarnHinweise = strWarnHinweise + " \\par " + translate(getstring("WARNHINWEISE[" + n + "].text", "DLGDATA.DATEN"))
#			print strWarnHinweise
		}
#		write("Test2.txt", strWarnHinweise)
#		print strWarnHinweise
		setstring("WARNHINWEISE", "TMPDATA.DATEN", strWarnHinweise)

		dZusatzLast = getdouble("ZUSATZLAST.RAW", "DLGDATA.HINWEISE")
		dFVorsp		= getdouble("F_VORSP.RAW", "DLGDATA.DATEN")
#		strZusatzlast	= getstring("ZUSATZLAST.RAW", "DLGDATA.HINWEISE")
#		strFVorsp		= getstring("F_VORSP.RAW", "DLGDATA.DATEN")
		strZusatzlast	= formatstring(dZusatzLast, "%.0f")
		strFVorsp		= formatstring(dFVorsp, "%.0f")
		nAnzZyklen = 18
		for n = 0 to (nAnzZyklen - 1)
		{
			strSrcZyklusDatenPath = "DLGDATA.DYNZYKLUS.PROFIL." + n
			dQt = getdouble("QT.RAW", strSrcZyklusDatenPath)
			dQs = getdouble("QS.RAW", strSrcZyklusDatenPath)
			strDestPathZusatzlast	= "TMPDATA.ZUSATZLAST[" + n + "]"
			strDestPathFVorsp		= "TMPDATA.FVORSP[" + n + "]"
			if ((dQt > 0 and dQs > 0))
			{
				setstring("VALUE",strDestPathZusatzlast, strZusatzlast)
				setstring("VALUE",strDestPathFVorsp, strFVorsp)
			}
			else	
			{
				setstring("VALUE",strDestPathZusatzlast, "")
				setstring("VALUE",strDestPathFVorsp, "")
			}
		}

		dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
		dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")

		if ((dFWAnz == 1) or ((dFWAnz == 2) and (dFSAnz == 2)))
			setstring("10007.VALUE", "TMPDATA.SYSTEM", "/")
		else
			setstring("10007.VALUE", "TMPDATA.SYSTEM", getstring("10007.VALUE", "DLGDATA.SYSTEM"))

		if (dFWAnz == 8)
			setstring("10008.VALUE", "TMPDATA.SYSTEM", getstring("10008.VALUE", "DLGDATA.SYSTEM"))
		else
			setstring("10008.VALUE", "TMPDATA.SYSTEM", "/")

		if (dFSAnz == 1)
			setstring("10009.VALUE", "TMPDATA.SYSTEM", "/")
		else
			setstring("10009.VALUE", "TMPDATA.SYSTEM", getstring("10009.VALUE", "DLGDATA.SYSTEM"))

		if (getdouble("10073.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10073.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10073", "TMPDATA.DATEN.WAGEN.10073")
		if (getdouble("10074.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10074.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10074", "TMPDATA.DATEN.WAGEN.10074")
		if (getdouble("10075.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10075.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10075", "TMPDATA.DATEN.WAGEN.10075")
		if (getdouble("10076.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10076.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10076", "TMPDATA.DATEN.WAGEN.10076")
		if (getdouble("10078.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10078.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10078", "TMPDATA.DATEN.WAGEN.10078")
		if (getdouble("10079.VALUE", "DLGDATA.DATEN.WAGEN") == 0)
			setstring("10079.VALUE", "TMPDATA.DATEN.WAGEN", "/")
		else
			copy("DLGDATA.DATEN.WAGEN.10079", "TMPDATA.DATEN.WAGEN.10079")


		nStatus = getint("STATUS", "DLGDATA.DATEN")
		if ((isbitset(nStatus, 1) == 0) and (isbitset(nStatus, 4) == 0) and (isbitset(nStatus, 5) == 0))
		{
			for n = 0 to (dFWAnz - 1)
			{
				strSrc	= "DLGDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				dValue	= getdouble("VALUE", strSrc)
				strTmp = formatstring(dValue,"%.2e")
				setstring("VALUE", strDest, strTmp)
#				copy(strSrc, strDest)
				strSrc	= "DLGDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
				dValue	= getdouble("", strSrc)
				strTmp = formatstring(dValue,"%.2e")
#				copy(strSrc, strDest)	# funzt nicht!!
				setstring("", strDest, strTmp)
			}
		}
		else
		{
			for n = 0 to (dFWAnz - 1)
			{
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_LAENGE"
				setstring("VALUE", strDest, "/")
				strDest = "TMPDATA.DATEN_FW[" + n + "].LEBENSDAUER_ZEIT"
#				copy(strSrc, strDest)	# funzt nicht!!
				setstring("", strDest, "/")
			}
		}

		strTest = getstring("SELBAUARTID", "DLGDATA.DATEN");
		setstring("SELBAUARTID_TRANS", "DLGDATA.DATEN", translate(strTest));
		// print strTest;
		// IDC_MELDUNG_PLSA_GEHT_NICHT

		strDablaTempl	= getstring("10056.VALUE", "DLGDATA.SYSTEM")
		strDablaTemplID = getstring("10056.RAW", "DLGDATA.SYSTEM")
#		print strDablaTempl + "(ID:" + strDablaTemplID + ")"
		rtfread(strDablaTemplID, strDablaTempl)
		rtfparseandreplace(strDablaTemplID)
		rtfwrite(strDablaTemplID, strRetPath)
		setalias("MPGRAPH", "DLGDATA.DYNZYKLUS.GRAPH");
		
		if (dXKoordFactor < 0)
		{
			bRet = execute(strProfilePath, "REVERSESIGN")
		}

		// 21.6.2013 -mw- neu: Datenblatt ber Shellexecute anzeigen, um Probleme mit JS-Fehler im Browser auszuschliessen:
		shellexecute (strRetPath,"","");
	}
	delete("TMPDATA", "")
}