#include "Allgemein.b"
#include "MassenDynZyklus_Calc.b"
#include "KraefteDynZyklus_Calc.b"
#include "DatenAllg.b"
#include "ProjectList_ReadSales.b"
#include "4DMotionProfiler.b"
#include "Kraefte.b"
#include "CheckFunctions.b"

// #include "TransferAxAlleMassen.b"

InitDefault()
{
	setdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN", 100)
	setdouble("TRAGZAHLABSCHLAG", "DLGDATA.DATEN", 0)
	setdouble("KF", "DLGDATA.DATEN", 1)
	setdouble("TRAGZAHLABSCHLAG", "DLGDATA.KGTDATEN", 0)
	setdouble("KF", "DLGDATA.KGTDATEN", 1)
	setdouble ("MASSEX_OFFSET_Y","DLGDATA",0)
	setdouble ("MASSEY_OFFSET_Y","DLGDATA",0)
	setdouble ("KRAFTX_OFFSET_Y","DLGDATA",0)
	setdouble ("KRAFTY_OFFSET_Y","DLGDATA",0)
	
	setstring("DISABLE_4DMOTIONPROFILER","DLGDATA","true"); // 4D Motion Profiler deaktivieren
	setstring ("KGTDATEN.DISABLESONDERMUTTER","DLGDATA","true"); // Aufruf Sondermutter deaktivieren, bis Password korrekt eingegeben
}

CopySystem(strNewSystemID)
{
	strOldID = getstring("ID", "DLGDATA.SYSTEM")
	if (strOldID == strNewSystemID)
		return;
	if (strOldID != "")
	{
		dAlpha	= getdouble("10003.RAW", "DLGDATA.SYSTEM")
		dBeta	= getdouble("10004.RAW", "DLGDATA.SYSTEM")
		dLY		= getdouble("10005.RAW", "DLGDATA.SYSTEM")
		dLZ		= getdouble("10006.RAW", "DLGDATA.SYSTEM")
		dAntriebssteifigkeit = getdouble("10010.RAW", "DLGDATA.SYSTEM")
		if (strNewSystemID != strOldID)
		{
			setstring("MSG_SYSTEMCHANGED", "DLGDATA.AUSMASSE", "true")
		}
		delete("MASSEN_FW", "DLGDATA")
		delete("KRAEFTE_FW", "DLGDATA")
		ClearResult()
	}
	dscopy(strNewSystemID, "DLGDATA.SYSTEM")
	// Bei Initialisierung mm voreinstellen
	setstring("10005.UNIT", "DLGDATA.SYSTEM", "284"); // Defaulteinstellung: 284 steht bei Bosch fuer mm
	setstring("10006.UNIT", "DLGDATA.SYSTEM", "284");
	setstring("10007.UNIT", "DLGDATA.SYSTEM", "284");
	setstring("10008.UNIT", "DLGDATA.SYSTEM", "284");
	setstring("10009.UNIT", "DLGDATA.SYSTEM", "284");
	setstring("ANTRIEB_KOORD.UNIT", "DLGDATA.SYSTEM","284" );

	if (strOldID != "")
	{
		setdouble("10003.RAW", "DLGDATA.SYSTEM", dAlpha)
		setdouble("10004.RAW", "DLGDATA.SYSTEM", dBeta)
		setdouble("10005.RAW", "DLGDATA.SYSTEM", dLY)
		setdouble("10006.RAW", "DLGDATA.SYSTEM", dLZ)
		setdouble("10010.RAW", "DLGDATA.SYSTEM", dAntriebssteifigkeit)
	}
	
	if (strOldID != strNewSystemID)
		setint("SYSTEMCHANGED", "DLGDATA", 1)
	strProfileID = getstring("ANTRIEB_KOORD.PROFILEID", "DLGDATA.SYSTEM")
	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")

	if (dFWAnz > 2)
	{
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "false")
		//setstring("MOMENTE_VISIBLE", "DLGDATA.SYSTEM", "hidden")
		showMomente(false);
	}
	else
	{
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "visible")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "true")
		// setstring("MOMENTE_VISIBLE", "DLGDATA.SYSTEM", "visible")
		showMomente(true);
	}
	setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")

	if (strProfileID == "")
	{
		strProfileID = getstring("10005.PROFILEID", "DLGDATA.SYSTEM")
		dRet = createobject("DLGDATA.SYSTEM", "ANTRIEB_KOORD", 63)
		setstring("ANTRIEB_KOORD.PROFILEID", "DLGDATA.SYSTEM", strProfileID)
		setstring("ANTRIEB_KOORD.UNIT", "DLGDATA.SYSTEM", getstring("10005.UNIT", "DLGDATA.SYSTEM"))
		setdouble("ANTRIEB_KOORD.Y.RAW", "DLGDATA.SYSTEM", getdouble("10005.RAW", "DLGDATA.SYSTEM"))
		setdouble("ANTRIEB_KOORD.Z.RAW", "DLGDATA.SYSTEM", getdouble("10006.RAW", "DLGDATA.SYSTEM"))
	}
}

CopyAntriebKoord()
{
	setdouble("ANTRIEB_KOORD.Y.RAW", "DLGDATA.SYSTEM", getdouble("10005.RAW", "DLGDATA.SYSTEM"));
	setdouble("ANTRIEB_KOORD.Z.RAW", "DLGDATA.SYSTEM", getdouble("10006.RAW", "DLGDATA.SYSTEM"));
}

CalcMassendaten()
{
	nAnz = getsize("DLGDATA.MASSEN", "")
	if (nAnz > 0)
	{
		specialexec("CALC_MASSENKRAEFTE")
		MassenDynZyklus_Calc()
	}
}

CalcKraeftedaten()
{
	nAnz = getsize("DLGDATA.KRAEFTE", "")
	if (nAnz > 0)
	{
		specialexec("CALC_KRAEFTEKRAEFTE")
		KraefteDynZyklus_Calc()
	}
}

InitKOSys()
{
	strKOId = getstring("SELKOSYS.ID", "DLGDATA.USER_KO")
	if (strKOId == "")
	{
		strKOId = "10063"
		dscopy(strKOId, "DLGDATA.USER_KO.SELKOSYS")
	}

	setalias("SELKOSYS", "DLGDATA.USER_KO.SELKOSYS")
#	print "gaga"

	# Pfad zu irgendeinem Tech-Vektor
#	strPath = "DLGDATA.MASSEN[0].KOORD"
	strPath = "TMPVEKTOR"
	dRet = createobject("", strPath, 63)
	# globale (stat.) Koordinaten-Transformationen in Tech-Vektor uebertragen
	strX_ = getstring("10050", "SELKOSYS")
	strY_ = getstring("10051", "SELKOSYS")
	strZ_ = getstring("10052", "SELKOSYS")
	setstring(strX_, "SELKOSYS", "X")
	setstring(strY_, "SELKOSYS", "Y")
	setstring(strZ_, "SELKOSYS", "Z")
	setstring("GLOBKOORDMAP.X_.KOORD", strPath, strX_)
	setstring("GLOBKOORDMAP.X_.FACTOR", strPath, getstring("10053", "SELKOSYS"))
	setstring("GLOBKOORDMAP.Y_.KOORD", strPath, strY_)
	setstring("GLOBKOORDMAP.Y_.FACTOR", strPath, getstring("10054", "SELKOSYS"))
	setstring("GLOBKOORDMAP.Z_.KOORD", strPath, strZ_)
	setstring("GLOBKOORDMAP.Z_.FACTOR", strPath, getstring("10055", "SELKOSYS"))
	delete("", strPath)
}

Translate()
{
	nAnzKraefte = getsize("DLGDATA.KRAEFTE", "")
	if (nAnzKraefte > 0)
	{
		for i = 0 to (nAnzKraefte - 1)
		{
			strPath = "DLGDATA.KRAEFTE[" + i + "]"
			strText = translate(("IDC_KRAFT_K" + (i + 1) + "_LABEL"))
			setstring("text", strPath, strText)
		}
	}
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	if (nAnzMassen > 0)
	{
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			strText = translate(("IDC_MASSE_M" + (i + 1) + "_LABEL"))
			setstring("text", strPath, strText)
		}
	}
	strPathBauarten = "DLGDATA.DATEN.BAUARTEN"
	nAnz = getsize(strPathBauarten, "")
	if (nAnz > 0)
	{
		for i = 0 to (nAnz - 1)
		{
			strPath = strPathBauarten + "[" + i + "]"
			strText = getstring("1.VALUE", strPath)
			setstring("text", strPath, strText)
		}
	}

	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	if (dFWAnz > 0)
	{
		for n = 0 to (dFWAnz - 1)
		{
			pathFW = "DLGDATA.KRAEFTE_FW[" + n + "]"
			setstring("text", pathFW, (translate("FW") + " " + (n + 1)))
			pathFW = "DLGDATA.DATEN_FW[" + n + "]"
			setstring("text", pathFW, (translate("FW") + " " + (n + 1)))
			pathFW = "DLGDATA.MASSEN_FW[" + n + "]"
			setstring("text", pathFW, (translate("FW") + " " + (n + 1)))
		}
	}

}

RestoreAliases()
{
	strSelMasseID = getstring("", "DLGDATA.SELMASSEID")
	setalias("SELMASSE", "DLGDATA.MASSEN[" + strSelMasseID + "]")
	strSelKraftID = getstring("", "DLGDATA.SELKRAFTID")
	setalias("SELKRAFT", "DLGDATA.KRAEFTE[" + strSelKraftID + "]")
}

CalcSEFromDeltas()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL"
	nMPSize = 18

	dSe = 0
	for i = 0 to nMPSize - 1
	{
		strDeltaS = getstring("DELTAS.RAW", strProfilePath + "." + i)
		if (strDeltaS != "")
		{
			dDeltaS = getdouble("DELTAS.RAW", strProfilePath + "." + i)
			setdouble("SA.RAW", strProfilePath + "." + i, dSe)
			setdouble("DELTAS.RAW", strProfilePath + "." + i, dDeltaS)
			dSe = getdouble("SE.RAW", strProfilePath + "." + i)
		}
	}
}

CheckQSSumme()
{
	nAnzZyklen = 18
	strMPPath = "DLGDATA.DYNZYKLUS.PROFIL."
	dSum = 0.
	for n = 0 to (nAnzZyklen - 1)
	{
		dQs	= getdouble("QS.VALUE", strMPPath + n)
		dSum = dSum + dQs;
	}
	dEps = 0.5
	if ((dSum < (100 - dEps)) or (dSum > (100 + dEps)))
		return 0.
	return 1.
}
// Pruefen, ob Dynamikzyklus den maximalen Verfahrweg nicht verlaesst
// falls Bedingung nich erfuellt  Fehlermeldung und returnwert false
CheckHub()
{
	var result=true;
	if(getbool("ISKGT", "DLGDATA"))	{	// Nur im KGT Fall muss Hub geprueft werden	
		var profiler= new MotionProfiler();
		profiler.initData();
		if (profiler.checkHub()) {
			setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",false);
		} else {
			setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",true);
			result=false;
		};
	};
	return result;
}

ResetAxAlleMassen()
{
	nAnzZyklen = 18; 
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	for n = 0 to (nAnzZyklen - 1)	
	{
		for i = 0 to (nAnzMassen - 1)
		{
			setdouble("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", 0)
		}
	}
}

function	changeBranch(nBranchID)
{
	setint("CURRENTBRANCH", "", nBranchID);
	initDlgAuspraegung(nBranchID)
	// To do: Alias setzen auf Daten im aktuellen Zweig !?
	switch (nBranchID)	{
	case 0:	// Profilschienen (Ur-Version)
		showDrehzahl(false);
		showKraefte(true);
		setstring("BHIDEPSMASSE", "DLGDATA.AUSMASSE", "false");
		setbool("ISKGT", "DLGDATA", 0)		// d.h. Folgedialog fr Profilschienen
		setstring("DISABLE_4DMOTIONPROFILER","DLGDATA","true"); // 4D Motion Profiler deaktivieren
		setstring("DISABLE_BERECHNEN_KRAFT","DLGDATA","false"); // berechnen Button auf Kraft Tab aktivieren
		setstring("DISABLE_BERECHNEN_MASSE","DLGDATA","false"); // berechnen Button auf Masse Tab aktivieren
		break;
	case 1:	// Kugelgewindetrieb KGT
		showDrehzahl(true);
		setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr Profilschienen
		setstring("DISABLE_4DMOTIONPROFILER","DLGDATA","false"); // 4D Motion Profiler aktivieren
		setstring("DISABLE_BERECHNEN_KRAFT","DLGDATA","false"); // berechnen Button auf Kraft Tab aktivieren
		setstring("DISABLE_BERECHNEN_MASSE","DLGDATA","false"); // berechnen Button auf Masse Tab aktivieren

		break;
	case 2:	// Laufrollenfuehrungen LF
		showDrehzahl(false);
		showKraefte(false);
		setstring("BHIDEPSMASSE", "DLGDATA.AUSMASSE", "true");
		setstring("DISABLE_4DMOTIONPROFILER","DLGDATA","true"); // 4D Motion Profiler deaktivieren
		setstring("DISABLE_BERECHNEN_KRAFT","DLGDATA","true"); // berechnen Button auf Kraft Tab deaktivieren
		setstring("DISABLE_BERECHNEN_MASSE","DLGDATA","true"); // berechnen Button auf Masse Tab deaktivieren
		setdouble ("MASSEY_OFFSET_Y","DLGDATA",-30); // Massen anders positionieren
		setdouble ("MASSEX_OFFSET_Y","DLGDATA",-19); // Massen anders positionieren
		setdouble ("KRAFTY_OFFSET_Y","DLGDATA",-30); // Kraft anders positionieren
		setdouble ("KRAFTX_OFFSET_Y","DLGDATA",-19); // Kraft anders positionieren
		break;
	}
	strTable = readfile("catalog\\system\\templates\\"  + getDlgTemplateID("Navigation") + ".xml");
	setstring("NAVIGATIONTABLE", "", strTable); 
};

function	initDlgAuspraegung(nBranchID)
{
	var oSn = _session();
	oSn.Dialogs = new Array;
	switch (nBranchID)	{
	case 1:
		oSn.Dialogs["Navigation"]	= "KGTNavigation";
		oSn.Dialogs["IDD_AUSMASSE"] = "IDD_KGTAUSMASSE";
		oSn.Dialogs["IDD_DATEN"]	= "IDD_KGTDATEN";
		oSn.Dialogs["IDD_WINKEL"]	= "IDD_KGTWINKEL";
		oSn.Dialogs["IDD_HINWEISE"] = "IDD_KGTHINWEISE";
		oSn.Dialogs["IDD_KRAEFTEDYNZYKLUS"] = "IDD_KGTKRAEFTEDYNZYKLUS";
		oSn.Dialogs["IDD_KRAEFTEDYNSTRECKEN"] = "IDD_KGTKRAEFTEDYNSTRECKEN";
		oSn.Dialogs["IDD_KRAEFTEDYNZEITANTEILE"] = "IDD_KGTKRAEFTEDYNZEITANTEILE";
		oSn.Dialogs["IDD_MASSENDYNZYKLUS"] = "IDD_KGTMASSENDYNZYKLUS";
		oSn.Dialogs["IDD_MASSENDYNSTRECKEN"] = "IDD_KGTMASSENDYNSTRECKEN";
		oSn.Dialogs["IDD_MASSENDYNZEITANTEILE"] = "IDD_KGTMASSENDYNZEITANTEILE";
		
		
		break;
	case 2:
		oSn.Dialogs["Navigation"]	= "LFNavigation";
		oSn.Dialogs["IDD_AUSMASSE"] = "IDD_LFAUSMASSE";
		oSn.Dialogs["IDD_START"]	= "IDD_LFSTART";
		oSn.Dialogs["IDD_AUSWAHL"]	= "IDD_LFAUSWAHL";
		oSn.Dialogs["IDD_HINWEISE"]	= "IDD_LFHINWEISE";
		oSn.Dialogs["IDD_DATEN"]	= "IDD_LFDATEN";
		
		break;
	}
}

function getDlgTemplateID(strLogDlgID)
{
	var oSn = _session();
	var strRet = oSn.Dialogs[strLogDlgID];
	return (strRet == "") ? strLogDlgID : strRet;
}



# Prozesssteuerung
{
	// Variablen 'current_dlg' und 'event' sind schon belegt!
	// current_dlg = getstring("AKTUELLE_MASKE", "");	// #Die aktuelle Maske (sofern vorhanden)
	event = getstring("EKSUBMITEVENT", "");			// #Event aus der aktuellen Maske
	
	if (!_session().Dialogs) 
			changeBranch(getint("CATALOG.PROCESS.BRANCH", "ROOT"));
		
	
	eventPar = getstring("EKSUBMITEVENTPAR","");	// #Event aus der aktuellen Maske	
	dp="DLGDATA.PRODUKTBAUM"
	bMenuEvent = 0
	bInitMomente = 1

	start_dlg=getDlgTemplateID("IDD_START")
	if (current_dlg == "")
	{
		current_dlg = start_dlg
	}
	new_dlg=current_dlg
	
	// Wiederherstellen des urspruenglichen Events, wenn event "umgelenkt" wurde, um Fehlermeldung anzuzeigen
	var AfterMessage=false; // In Flag merken , dass gespeichertes Event eingespielt wird, um Fehlerbehandlung nicht doppelt durchzufuehren
	if (event=='CONTINUE_AFTER_MESSAGE') {
		event=getstring ("AFTER_MESSAGE_TARGET_EVENT","DLGDATA.PROCESS");
		AfterMessage=true;
		
	};
	
	switch (current_dlg)
	{
	case "IDD_START":
	case "IDD_LFSTART":
		setbool("ENHANCEDCOMBO", "DLGDATA", true); // Erweiterte Anzeige bei Comboboxen
		if((event=="IDC_STARTPRG_LABEL") or (event=="IDC_PROFILSCHIENE_IMG"))	
		{
			changeBranch(0);
			new_dlg=getDlgTemplateID("IDD_AUSWAHL");
		}
		else if (event=="IDC_KUGELWINDETRIEB_IMG")
		{
			changeBranch(1);
			new_dlg=getDlgTemplateID("IDD_AUSMASSE");
		}
		else if (event=="IDC_LFPLANUNGSTOOL_LABEL")
		{
			changeBranch(2);
			new_dlg=getDlgTemplateID("IDD_AUSWAHL");
		}
		if(event=="IDC_CONTINUE_BUT") {
			new_dlg=getDlgTemplateID("IDD_AUSWAHL");
		};
		break
		
		
	case "IDD_AUSWAHL":
		if(event=="IDC_CONTINUE_BUT")	
		{
			strAppID = getstring("ID", "DLGDATA.SYSTEM")
			if (strAppID == "")
			{
				strClassID = dsqueryclassidfromident("APP_4_2")
				if (strClassID != "")
				{
					CopySystem(strClassID)
					new_dlg = getDlgTemplateID("IDD_KOORDINATENSYS");
				}
				else
					print "error: APP_4_2 unknown"
			}
			new_dlg="IDD_KOORDINATENSYS"
		}
		else if (event=="IDC_APPLIKATIONEN_TAB")
		{
			strClassID = dsqueryclassidfromident(eventPar)
			if (strClassID != "")
			{
				CopySystem(strClassID)
				new_dlg = getDlgTemplateID("IDD_KOORDINATENSYS");
			}
 		}
		else if(event=="IDC_BACK_BUT")
			new_dlg = getDlgTemplateID("IDD_START");
		break;
	case "IDD_LFAUSWAHL":
		if(event=="IDC_CONTINUE_BUT")	
		{
			strAppID = getstring("ID", "DLGDATA.SYSTEM")
			if (strAppID == "")
			{
				strClassID = dsqueryclassidfromident("APP_1_1")
				if (strClassID != "")
				{
					CopySystem(strClassID)
					new_dlg = getDlgTemplateID("IDD_KOORDINATENSYS");
				}
				else
					print "error: APP_4_2 unknown"
			}
			new_dlg = getDlgTemplateID("IDD_KOORDINATENSYS");
		}
		else if (event=="IDC_APPLIKATIONEN_TAB")
		{
			strClassID = dsqueryclassidfromident(eventPar)
			if (strClassID != "")
			{
				CopySystem(strClassID)
				new_dlg = getDlgTemplateID("IDD_KOORDINATENSYS");
			}
 		}
		else if(event=="IDC_BACK_BUT")
			new_dlg = getDlgTemplateID("IDD_START");
		break;
	case "IDD_KOORDINATENSYS":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg = getDlgTemplateID("IDD_AUSMASSE");
		else if(event=="IDC_BACK_BUT")
			new_dlg = getDlgTemplateID("IDD_AUSWAHL");
		break
		
	case "IDD_AUSMASSE":
	case "IDD_LFAUSMASSE":
		CopyAntriebKoord();
		if(event=="IDC_CONTINUE_BUT")
		{
			setbool("ISKGT", "DLGDATA", 0)		// d.h. Folgedialog fr Profilschienen
			setint("SYSTEMCHANGED", "DLGDATA", 0)
			new_dlg=getDlgTemplateID("IDD_WINKEL");
		}
		else if(event=="IDC_BACK_BUT")
			new_dlg=getDlgTemplateID("IDD_KOORDINATENSYS");
		break		
		
	case "IDD_WINKEL":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg="IDD_DYNAUSWAHL"
		else if ((event=="IDC_BETA_EDIT") or (event=="IDC_ALPHA_EDIT"))
		{
			new_dlg="IDD_DDX_WINKEL"
		}
		else if(event=="IDC_BACK_BUT")
			new_dlg = getDlgTemplateID("IDD_AUSMASSE");
		break
	case "IDD_KGTWINKEL":
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_DYNAUSWAHL"
			} else {
				new_dlg="IDD_KGTWINKEL"
			};
		}
			
		else if ((event=="IDC_BETA_EDIT") or (event=="IDC_ALPHA_EDIT"))
		{
			new_dlg="IDD_DDX_WINKEL"
		}
		else if(event=="IDC_BACK_BUT") {
			new_dlg = getDlgTemplateID("IDD_AUSMASSE");

			};
			
		break

	case "IDD_DYNAUSWAHL":
		strPrevEingabeArt = getstring("EINGABEART","DLGDATA")
		if (event=="IDC_EINGABE_DYNAMIKZYKLUS_BUT")
		{
			setstring("EINGABEART","DLGDATA", "DYNAMIKZYKLUS")
			event = "IDC_CONTINUE_BUT"
		}
		else if (event=="IDC_EINGABE_ZEITANTEILE_BUT")
		{
			setstring("EINGABEART","DLGDATA", "ZEITANTEILE")
			event = "IDC_CONTINUE_BUT"
		}
		else if (event=="IDC_EINGABE_STRECKEN_BUT")
		{
			setstring("EINGABEART","DLGDATA", "STRECKENANTEILE")
			event = "IDC_CONTINUE_BUT"
		}
		if (event=="IDC_CONTINUE_BUT")
		{
			eingabeart = getstring("EINGABEART","DLGDATA")
			if (eingabeart == "DYNAMIKZYKLUS")
				new_dlg="IDD_DYNZYKLUS"
			else if (eingabeart == "ZEITANTEILE")
				new_dlg="IDD_DYNZEITANTEILE"
			else if (eingabeart == "STRECKENANTEILE")
				new_dlg="IDD_DYNSTRECKEN"
			else
			{
				new_dlg="IDD_DYNZYKLUS"
				setstring("EINGABEART","DLGDATA", "DYNAMIKZYKLUS")
			}
		}
		else if(event=="IDC_BACK_BUT")
			new_dlg=getDlgTemplateID("IDD_WINKEL");

		if ((strPrevEingabeArt!= "") and (strPrevEingabeArt != getstring("EINGABEART","DLGDATA")))
		{
			strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL"
			setint("RESETSTART", strProfilePath, 0)
			setstring("INPUT_FOCUS", "DLGDATA.DYNZYKLUS", "IDC_DYNZYKLUS_EDIT_2_3")
			bRet = execute(strProfilePath, "RESET") 
			nAnz = getint("SIZE",strProfilePath);
			for (i = 0; i < nAnz; i++)	{
				setstring("NM.RAW", strProfilePath + "." + i, "");
				setstring("NE.RAW", strProfilePath + "." + i, "");
			}
			ResetAxAlleMassen()
			setdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN", 100)
		}
		break
		
	case "IDD_DYNZYKLUS":
		dOrdNo = getdouble("DLGORDNUMBERS.IDD_DYNZYKLUS", "ROOT")
		setdouble("MAXDLGORDNUMBER", "DLGDATA", dOrdNo)
		setstring("BMSG_QS_SUM","DLGDATA.DYNZYKLUS", "false");
		if(event=="IDC_CONTINUE_BUT")
		{
			bDlgOK = getint("BDLGOK", "DLGDATA.DYNZYKLUS")
			bQSSum = 1	// # CheckQSSumme()
			if ((bDlgOK == 1) and (bQSSum == 1))
			{
				if(getbool("ISKGT", "DLGDATA"))	{	// Wenn KGT		
					var profiler= new MotionProfiler();
					profiler.initData();
					if (profiler.checkHub()) {
					    setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",false);
						new_dlg="IDD_KGTMASSENDYNZYKLUS"
					} else {
						setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",true);
						new_dlg="IDD_DYNZYKLUS"
					};
				} else								// Wenn Profilschienen
					new_dlg="IDD_MASSENDYNZYKLUS"
			}
			else
			{
				new_dlg=current_dlg
				if (bQSSum == 0)
					setstring("BMSG_QS_SUM","DLGDATA.DYNZYKLUS", "true");
			}
		}
		else if (event=="IDC_DYNZYKLUS_EDIT")
		{
			new_dlg = "IDD_DYNZYKLUS"
		}
		else if(event=="IDC_BACK_BUT") {
			new_dlg="IDD_DYNAUSWAHL"
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_DYNZYKLUS");
			new_dlg="IDD_4DPROFILE";
		};
		break
	
	case "IDD_4DPROFILE":
		if(event=="IDC_CONTINUE_BUT")
		{
			new_dlg=getstring ("SRCDLG","DLGDATA.4DMOTION");
		}
		else if(event=="IDC_BACK_BUT")
			new_dlg=getstring ("SRCDLG","DLGDATA.4DMOTION");
		break
	
		
	case "IDD_DYNZEITANTEILE":
		dOrdNo = getdouble("DLGORDNUMBERS.IDD_DYNZEITANTEILE", "ROOT")
		setdouble("MAXDLGORDNUMBER", "DLGDATA", dOrdNo)
		if(event=="IDC_CONTINUE_BUT")
		{
			bRet = execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCQSFROMQTVM")
			setstring("BMSG_QS_SUM","DLGDATA.DYNZEITANTEILE", "false");
			if (bRet == 1)
			{
				if(getbool("ISKGT", "DLGDATA"))					// Wenn KGT
				{
					new_dlg="IDD_KGTMASSENDYNZEITANTEILE"
					setbool("KEINE_DREHZAHL","DLGDATA",false)	// zustzlich Drehzahl darstellen
				}
				else											// Wenn Profilschienen
				{
					new_dlg="IDD_MASSENDYNZEITANTEILE"
					setbool("KEINE_DREHZAHL","DLGDATA",true)	// hier keine Drehzahlen darstellen
				}
			}
			else
			{
				setstring("BMSG_QS_SUM","DLGDATA.DYNZEITANTEILE", "true");
				new_dlg="IDD_DYNZEITANTEILE"
			}
		}
		else if	(event=="IDC_CALC_BUT")
		{
			bRet = execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCQSFROMQTVM")
			new_dlg="IDD_DYNZEITANTEILE"
		}
		else if(event=="IDC_BACK_BUT") {
			new_dlg="IDD_DYNAUSWAHL"
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_DYNZEITANTEILE");
			new_dlg="IDD_4DPROFILE";
		};
		break
		
	case "IDD_DYNSTRECKEN":
		dOrdNo = getdouble("DLGORDNUMBERS.IDD_DYNSTRECKEN", "ROOT")
		setdouble("MAXDLGORDNUMBER", "DLGDATA", dOrdNo)
		bRet = execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCQSFROMDELTAS")
		bRet = execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCQTFROMDELTASVM")
		CalcSEFromDeltas()
		if(event=="IDC_CONTINUE_BUT")
		{
			if(getbool("ISKGT", "DLGDATA"))					// Wenn KGT
			{
				var profiler= new MotionProfiler();
				profiler.initData();
				if (profiler.checkHub()) {
				    setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",false);
					new_dlg="IDD_KGTMASSENDYNSTRECKEN"
					setbool("KEINE_DREHZAHL","DLGDATA",false)	// zustzlich Drehzahl darstellen
				} else {
					setbool ("BMSG_HUB_RANGE","DLGDATA.DYNZYKLUS",true);
					new_dlg="IDD_DYNSTRECKEN";
				};
			}
			else											// Wenn Profilschienen
			{
				new_dlg="IDD_MASSENDYNSTRECKEN"
				setbool("KEINE_DREHZAHL","DLGDATA",true)	// hier keine Drehzahlen darstellen
			}
		}
		else if	(event=="IDC_CALC_BUT")
		{
			new_dlg="IDD_DYNSTRECKEN"
		}
		else if(event=="IDC_BACK_BUT") {
			new_dlg="IDD_DYNAUSWAHL"
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_DYNSTRECKEN");
			new_dlg="IDD_4DPROFILE";
		};
		break
		
	case "IDD_MASSENDYNZYKLUS":
		if (event=="IDC_CONTINUE_BUT"|| left(event,11)=="IDC_TABLE02") {
			if (!CheckMassen()) {
				new_dlg=getDlgTemplateID("IDD_MASSENDYNZYKLUS");
				event=" ";
				break;
			};
			new_dlg="IDD_KRAEFTEDYNZYKLUS"
			
		} else if(event=="IDC_BACK_BUT")
			new_dlg="IDD_DYNZYKLUS"
		break
		
	case "IDD_MASSENDYNZEITANTEILE":
		if (event=="IDC_CONTINUE_BUT"|| left(event,11)=="IDC_TABLE02") {
			if (!CheckMassen()) {
				new_dlg=getDlgTemplateID("IDD_MASSENDYNZEITANTEILE");
				event=" ";
				break;
			};
			new_dlg="IDD_KRAEFTEDYNZEITANTEILE"
		} else if(event=="IDC_BACK_BUT")
			new_dlg="IDD_DYNZEITANTEILE"
		break
		
	case "IDD_MASSENDYNSTRECKEN":
		if (event=="IDC_CONTINUE_BUT"|| left(event,11)=="IDC_TABLE02") {
			if (!CheckMassen()) {
				new_dlg=getDlgTemplateID("IDD_MASSENDYNSTRECKEN");
				event=" ";
				break;
			};
			new_dlg="IDD_KRAEFTEDYNSTRECKEN"
		 } else if(event=="IDC_BACK_BUT")
			new_dlg="IDD_DYNSTRECKEN"
		break
		
	case "IDD_KRAEFTEDYNZYKLUS":
		if(event=="IDC_CONTINUE_BUT" || left(event,11)=="IDC_TABLE02") {
			if (!CheckKraefte()) {
				new_dlg=getDlgTemplateID("IDD_KRAEFTEDYNZYKLUS");
				event=" ";
				break;
			};
			new_dlg = getDlgTemplateID("IDD_HINWEISE");
		 } else if(event=="IDC_BACK_BUT")
			new_dlg="IDD_MASSENDYNZYKLUS"
		break
		
	case "IDD_KRAEFTEDYNZEITANTEILE":
		if(event=="IDC_CONTINUE_BUT"|| left(event,11)=="IDC_TABLE02") {
			if (!CheckKraefte()) {
				new_dlg=getDlgTemplateID("IDD_KRAEFTEDYNZEITANTEILE");
				event=" ";
				break;
			};
			new_dlg = getDlgTemplateID("IDD_HINWEISE");
		} else if(event=="IDC_BACK_BUT")
			new_dlg="IDD_MASSENDYNZEITANTEILE"
		break

	case "IDD_KRAEFTEDYNSTRECKEN":
		if (event=="IDC_CONTINUE_BUT"|| left(event,11)=="IDC_TABLE02") {
			if (!CheckKraefte()) {
				new_dlg=getDlgTemplateID("IDD_KRAEFTEDYNSTRECKEN");
				event=" ";
				break;
			};
			new_dlg = getDlgTemplateID("IDD_HINWEISE");			
		} else if (event=="IDC_BACK_BUT") {
			new_dlg="IDD_MASSENDYNSTRECKEN";			
		};
		break;

	case "IDD_HINWEISE":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg="IDD_DATEN"
		else if(event=="IDC_BACK_BUT")
		{
			eingabeart = getstring("EINGABEART","DLGDATA")
			if (eingabeart == "DYNAMIKZYKLUS")
				new_dlg="IDD_KRAEFTEDYNZYKLUS"
			else if (eingabeart == "ZEITANTEILE")
				new_dlg="IDD_KRAEFTEDYNZEITANTEILE"
			else if (eingabeart == "STRECKENANTEILE")
				new_dlg="IDD_KRAEFTEDYNSTRECKEN"
			else
				new_dlg="IDD_KRAEFTEDYNZYKLUS"
		}
		break
		
	case "IDD_LFHINWEISE":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg = getDlgTemplateID("IDD_DATEN");
		else if(event=="IDC_BACK_BUT")
		{
			eingabeart = getstring("EINGABEART","DLGDATA")
			if (eingabeart == "DYNAMIKZYKLUS")
				new_dlg="IDD_KRAEFTEDYNZYKLUS"
			else if (eingabeart == "ZEITANTEILE")
				new_dlg="IDD_KRAEFTEDYNZEITANTEILE"
			else if (eingabeart == "STRECKENANTEILE")
				new_dlg="IDD_KRAEFTEDYNSTRECKEN"
			else
				new_dlg="IDD_KRAEFTEDYNZYKLUS"
		}
		break
		
	case "IDD_DATEN":
		if(event=="IDC_CONTINUE_BUT")
		{
			new_dlg="IDD_VERLAGERUNGEN"
		}
		else if(event=="IDC_BACK_BUT")
		{
			new_dlg = getDlgTemplateID("IDD_HINWEISE");
		}
		break
		
	case "IDD_LFDATEN":
		if(event=="IDC_CONTINUE_BUT")
		{
			new_dlg="IDD_PROJECTLIST"
		}
		else if(event=="IDC_BACK_BUT")
		{
			new_dlg = getDlgTemplateID("IDD_HINWEISE");
		}
		break
		
	case "IDD_VERLAGERUNGEN":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg="IDD_PROJECTLIST"
		else if(event=="IDC_BACK_BUT")
			new_dlg=getDlgTemplateID("IDD_DATEN")
		break
		
	case "IDD_MTTFDATEN":
		if(event=="IDC_UEBERNEHMEN_BUT")
		{
			new_dlg="IDD_DDX_MTTFDATEN"
		}
		break
		
	case "IDD_PROJECTLIST":
		if(event=="IDC_BACK_BUT")
		{
		
			switch (getint("CURRENTBRANCH", ""))	{
				case 0:// Profilschienen
					new_dlg="IDD_VERLAGERUNGEN"
					break;
				case 1:// KGT
					new_dlg="IDD_KGTDATEN"
					break;
				case 2:// LF
					new_dlg="IDD_LFDATEN"
					break;
			};
		}
		break
		
	case "IDD_KGTAUSMASSE":
		// Pruefung auf Fehlermeldung
		if(event=="IDC_CONTINUE_BUT" || left(event,11)=="IDC_TABLE02") {
			if (!AfterMessage &&!CheckSPU()) {
				new_dlg= getDlgTemplateID("IDD_AUSMASSE");
				setstring ("AFTER_MESSAGE_TARGET_EVENT","DLGDATA.PROCESS",event);
				event=' '; //eventhandling abbrechen
				break;
			};
		};
		setstring("P.RAW", "DLGDATA.KGTSYSTEM", getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN")); // Sicherstellen, da Steigung korrekt uebernommen wird
		if(event=="IDC_CONTINUE_BUT" )
		{
			//setint("SYSTEMCHANGED", "DLGDATA", 0)
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			new_dlg= getDlgTemplateID("IDD_WINKEL");
		} else if(event=="IDC_BACK_BUT") {
			new_dlg="IDD_START"
		} else if (event=='IDC_MSG_NOT_FOUND_SPU') { // Weitergehen nach gleichnamiger Warnmeldung
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			new_dlg= getDlgTemplateID("IDD_WINKEL");
		};
		break
		
	case "IDD_KGTMASSENDYNZYKLUS":
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTKRAEFTEDYNZYKLUS"
			} else {
				new_dlg="IDD_KGTMASSENDYNZYKLUS"
			};
		}
			
			
		else if(event=="IDC_BACK_BUT")
		{
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			if (CheckHorizontal()) {
				new_dlg="IDD_DYNZYKLUS"	
			} else {
				new_dlg="IDD_KGTMASSENDYNZYKLUS"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTMASSENDYNZYKLUS");
			new_dlg="IDD_4DPROFILE";
		};
		break
		
	case "IDD_KGTMASSENDYNZEITANTEILE":
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			} else {
				new_dlg="IDD_KGTMASSENDYNZEITANTEILE"
			};
		}
		else if(event=="IDC_BACK_BUT")
		{
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			if (CheckHorizontal()) {
				new_dlg="IDD_DYNZEITANTEILE"
			} else {
				new_dlg="IDD_KGTMASSENDYNZEITANTEILE"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTMASSENDYNZEITANTEILE");
			new_dlg="IDD_4DPROFILE";
		};

		break
		
	case "IDD_KGTMASSENDYNSTRECKEN":
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTKRAEFTEDYNSTRECKEN"
			} else {
				new_dlg="IDD_KGTMASSENDYNSTRECKEN"
			};
		}
		else if(event=="IDC_BACK_BUT")
		{
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			if (CheckHorizontal()) {
				new_dlg="IDD_DYNSTRECKEN"
			} else {
				new_dlg="IDD_KGTMASSENDYNSTRECKEN"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTMASSENDYNSTRECKEN");
			new_dlg="IDD_4DPROFILE";
		}
		break
			
	case "IDD_KGTKRAEFTEDYNZYKLUS":
		setbool("ISKGT", "DLGDATA", 1)			// d.h. Folgedialog fr KGT
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTHINWEISE"
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZYKLUS"
			};
		}
		else if(event=="IDC_BACK_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTMASSENDYNZYKLUS"
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZYKLUS"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTKRAEFTEDYNZYKLUS");
			new_dlg="IDD_4DPROFILE";
		};
		break
		
	case "IDD_KGTKRAEFTEDYNZEITANTEILE":
		setbool("ISKGT", "DLGDATA", 1)			// d.h. Folgedialog fr KGT
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTHINWEISE"				
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			};
		}
		else if(event=="IDC_BACK_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTMASSENDYNZEITANTEILE"
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTKRAEFTEDYNZEITANTEILE");
			new_dlg="IDD_4DPROFILE";
		}
		break
		
	case "IDD_KGTKRAEFTEDYNSTRECKEN":
		setbool("ISKGT", "DLGDATA", 1)			// d.h. Folgedialog fr KGT
		if(event=="IDC_CONTINUE_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTHINWEISE"
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			};
		}
		else if(event=="IDC_BACK_BUT") {
			if (CheckHorizontal()) {
				new_dlg="IDD_KGTMASSENDYNSTRECKEN"
			} else {
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			};
		} else if(event=="IDC_4DPROFILER") {
			setstring ("SRCDLG","DLGDATA.4DMOTION","IDD_KGTKRAEFTEDYNSTRECKEN");
			new_dlg="IDD_4DPROFILE";
		}
		break

	case "IDD_KGTHINWEISE":
		if(event=="IDC_CONTINUE_BUT")
			new_dlg="IDD_KGTDATEN"
		else if(event=="IDC_BACK_BUT")
		{
			eingabeart = getstring("EINGABEART","DLGDATA")
			if (eingabeart == "DYNAMIKZYKLUS")
				new_dlg="IDD_KGTKRAEFTEDYNZYKLUS"
			else if (eingabeart == "ZEITANTEILE")
				new_dlg="IDD_KGTKRAEFTEDYNZEITANTEILE"
			else if (eingabeart == "STRECKENANTEILE")
				new_dlg="IDD_KGTKRAEFTEDYNSTRECKEN"
			else
				new_dlg="IDD_KGTKRAEFTEDYNZYKLUS"
		}
		break;
		
	case "IDD_KGTDATEN":
		if(event=="IDC_CONTINUE_BUT")
		{
			setbool("ISKGT", "DLGDATA", 1)		// d.h. Folgedialog fr KGT
			new_dlg="IDD_PROJECTLIST"
		}
		else if(event=="IDC_BACK_BUT")
		{
			new_dlg="IDD_KGTHINWEISE"
			ClearResult()
		}
		else if(event=="IDC_SONDERMUTTER_BUT")
		{
			new_dlg="IDD_KGTSONDERMUTTER";
			ClearResult();
		}
		break;
		
	default:
		new_dlg=current_dlg
	}	

	if(event=="IDC_DEU_BUT" || event=="MENU_SPRACHE_DEUTSCH")
	{
#		setstring("EKCURRENTLANGUAGE","","DE")
		bRet = changelanguage("DE")
		Translate()
		strIniFile = getstddirectory("PROGRAM") + "Linax.ini"
		writeinistring(strIniFile, "CATALOG", "LANGUAGE", "DE")
#		new_dlg="IDD_AUSWAHL"
#			print(new_dlg)
	}
	else if(event=="IDC_ENGLISCH_BUT" || event=="MENU_SPRACHE_ENGLISCH")
	{
#		setstring("EKCURRENTLANGUAGE","","EN")
		bRet = changelanguage("EN")
		Translate()
		strIniFile = getstddirectory("PROGRAM") + "Linax.ini"
		writeinistring(strIniFile, "CATALOG", "LANGUAGE", "EN")
#		new_dlg="IDD_AUSWAHL"
	}
	else if(event=="IDC_FRANZ_BUT")
	{
#		setstring("EKCURRENTLANGUAGE","","FR")
#		new_dlg="IDD_AUSWAHL"
		strClassID = dsqueryclassidfromident("APP_2_1")
		dscopy(strClassID, "DLGDATA.SYSTEM")
		new_dlg="IDD_KRAEFTEDYNZYKLUS"
	}
	else if(event=="IDC_MENU")
	{
		new_dlg="IDD_AUSWAHL"
	}

	else if(event=="Init")
	{
		new_dlg="IDD_IF_APPLIKATIONEN"
	}
	else if (event=="IDC_CONTINUE_BUT")
	{
		if (current_dlg=="IDD_IF_APPLIKATIONEN")
		{
			new_dlg ="IDD_IF_KOORDINATENSYSTEM"
		}
		else if (current_dlg=="IDD_IF_KOORDINATENSYSTEM")
		{
			new_dlg = "IDD_IF_DATEN"
		}
	}
	else if (event=="IDC_HELP_BUT")
	{
		new_dlg="IDD_HELP"
	}
	else if (event=="MENU_DATEI_NEW")
	{
		delete("", "DLGDATA")
		ReadIniSalesInfo()
		resetglobkoordmap()
		InitDefault()
		new_dlg = getDlgTemplateID("IDD_START");
		setstring("PROJECTFILE", "", "")
		var nBranchID = getint("CURRENTBRANCH", "");
		changeBranch(nBranchID);

	}
	else if (event=="MENU_DATEI_SAVEAS")
	{
		strRetPath = filedialog(0, "xml", "", "Project Files (*.xml)|*.xml|All Files(*.*)|*.*|", "")
		if (strRetPath != "")
		{
			setstring("PROJECTFILE", "", strRetPath)
			savexml("DLGDATA", strRetPath)
		}
	}
	else if (event=="MENU_DATEI_CLOSE")
	{
		delete("", "DLGDATA")
		resetglobkoordmap()
		InitDefault()
		new_dlg="IDD_AUSWAHL"
		setstring("PROJECTFILE", "", "")
	}
	else if (event=="MENU_DATEI_OPEN")
	{
		strRetPath = filedialog(1, "xml", "", "Project Files (*.xml)|*.xml|All Files(*.*)|*.*|", "")
		if (strRetPath != "")
		{
			delete("", "DLGDATA")
			setstring("PROJECTFILE", "", strRetPath)
			EnableChangeUSInObj(0)
			loadxml("DLGDATA", strRetPath)
			EnableChangeUSInObj(1)
			InitKOSys()
			Daten_InitBauarten("DLGDATA.DATEN.BAUARTEN")
			Translate()
			RestoreAliases()
			if (getdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN") <= 0)
				setdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN", 100)
			var nBranchID = getint("CURRENTBRANCH", "");
				
			changeBranch(nBranchID);
		/*	
			if (nBranchID == 1)
				new_dlg=getDlgTemplateID("IDD_AUSMASSE");
			else
				new_dlg=getDlgTemplateID("IDD_AUSWAHL");
		*/				
			// new_dlg="IDD_AUSWAHL"
			new_dlg=getDlgTemplateID("IDD_START");
		}
	}
	else if (event=="MENU_DATEI_SAVE")
	{
		strRetPath = getstring("PROJECTFILE", "")
		if (strRetPath == "")
		{
			strRetPath = filedialog(0, "xml", "", "Project Files (*.xml)|*.xml|All Files(*.*)|*.*|", "")
			if (strRetPath != "")
			{
				setstring("PROJECTFILE", "", strRetPath)
				savexml("DLGDATA", strRetPath)
			}
		}
		else
		{
			savexml("DLGDATA", strRetPath)
		}
	}
	else if (event == "MENU_DATEI_PROJECTDATA")
	{
		new_dlg="IDD_PROJECTLIST"
	}
	else if (event == "MENU_INFO")
	{
		new_dlg="IDD_INFO"
	}
	else if (event == "MENU_OPTIONEN_KO_SYS")
	{
		new_dlg="IDD_USER_KOORDINATENSYS"
	}
	else if (event == "MENU_OPTIONEN_MTTF")
	{
		new_dlg="IDD_MTTFDATEN"
	}
	else if (event == "MENU_OPTIONEN_SONDERMUTTERPWD")
	{
		new_dlg="IDD_SONDERMUTTERPWD"
	}

#	else if(event=="IDC_BACK_BUT")		new_dlg="GOBACK"
	else if(event=="IDC_EXIT_BUT")		new_dlg="EXIT"
	else if (event=="IDC_TABLE02_BUT_COL1_02")
	{
		tmp_dlg = getDlgTemplateID("IDD_AUSWAHL");
	}
	else if (event=="IDC_TABLE02_BUT_COL1_04")
	{
		tmp_dlg=getDlgTemplateID("IDD_KOORDINATENSYS");
	}
	else if (event=="IDC_TABLE02_BUT_COL1_06")
	{	if (  CheckPFAbmessungen()) {
			tmp_dlg= getDlgTemplateID("IDD_WINKEL");
		};
	}
	else if (event=="IDC_TABLE02_BUT_COL1_08")
	{
		tmp_dlg=getDlgTemplateID("IDD_AUSMASSE");
	}
	else if (event=="IDC_TABLE02_BUT_COL1_10")
	{
		if (CheckHorizontal() && CheckPFAbmessungen() ) {
			tmp_dlg=getDlgTemplateID("IDD_DYNAUSWAHL");
		};
	}
	else if (event=="IDC_TABLE02_BUT_COL1_12")
	{
		if (CheckHub() && CheckHorizontal() && CheckPFAbmessungen()) {
			strEingabeart = getstring("EINGABEART","DLGDATA")
			switch (strEingabeart)
			{
			case "DYNAMIKZYKLUS":
				tmp_dlg=getDlgTemplateID("IDD_MASSENDYNZYKLUS");
				break
			case "ZEITANTEILE":
				tmp_dlg=getDlgTemplateID("IDD_MASSENDYNZEITANTEILE");
				break
			case "STRECKENANTEILE":
				tmp_dlg=getDlgTemplateID("IDD_MASSENDYNSTRECKEN");
				break
			default:
				tmp_dlg=getDlgTemplateID("IDD_MASSENDYNZYKLUS");
			}
		};
#		CalcMassendaten()
	}
	else if (event=="IDC_TABLE02_BUT_COL1_14")
	{
		if (CheckHub() && CheckHorizontal()  && CheckMassen() && CheckPFAbmessungen()) {
			strEingabeart = getstring("EINGABEART","DLGDATA")
			switch (strEingabeart)
			{
			case "DYNAMIKZYKLUS":
				tmp_dlg=getDlgTemplateID("IDD_KRAEFTEDYNZYKLUS");
				break
			case "ZEITANTEILE":
				tmp_dlg=getDlgTemplateID("IDD_KRAEFTEDYNZEITANTEILE");
				break
			case "STRECKENANTEILE":
				tmp_dlg=getDlgTemplateID("IDD_KRAEFTEDYNSTRECKEN");
				break
			default:
				tmp_dlg=getDlgTemplateID("IDD_KRAEFTEDYNZYKLUS");
			}
		};
#		CalcMassendaten()
#		CalcKraeftedaten()
	}
	else if (event=="IDC_TABLE02_BUT_COL1_16")
	{
		if (CheckHub()&& CheckHorizontal()  && CheckMassen() && CheckKraefte() && CheckPFAbmessungen()) {
			tmp_dlg = getDlgTemplateID("IDD_HINWEISE");
		};
#		CalcMassendaten()
#		CalcKraeftedaten()
#		Hinweise_Calc()
	}
	else if (event=="IDC_TABLE02_BUT_COL1_18")
	{
		if (CheckHub()&& CheckHorizontal() && CheckMassen() && CheckKraefte() && CheckPFAbmessungen()) {
			tmp_dlg=getDlgTemplateID("IDD_DATEN");
		};
	}
	else if (event=="IDC_TABLE02_BUT_COL1_20")
	{
		if (CheckHub()&& CheckHorizontal()  && CheckMassen() && CheckKraefte() && CheckPFAbmessungen()) {
			tmp_dlg=getDlgTemplateID("IDD_VERLAGERUNGEN");
		};
	}
	else if (event=="IDC_TABLE02_BUT_COL1_22")
	{
		if (CheckHub()&& CheckHorizontal()  && CheckMassen() && CheckKraefte() && CheckPFAbmessungen()) {
			tmp_dlg=getDlgTemplateID("IDD_PROJECTLIST");
		};
	}

	dCurrentMaxOrdNo = getdouble("MAXDLGORDNUMBER", "DLGDATA")
	dDatenOrdNo	= getdouble("DLGORDNUMBERS.IDD_DATEN", "ROOT")
	var nSysChanged = getint("SYSTEMCHANGED", "DLGDATA");
	if ((tmp_dlg != "") && ((getint("SYSTEMCHANGED", "DLGDATA") == 0) || (getint("CURRENTBRANCH", "") == 1)))
	{
		dOrdNo = getdouble("DLGORDNUMBERS." + tmp_dlg, "ROOT")
		if (dOrdNo <= dCurrentMaxOrdNo)
			new_dlg = tmp_dlg
		
	}

	setstring("EKSUBMITEVENT","",event)		# Event neu setzen
	setstring("AKTUELLE_MASKE","",new_dlg)		# Neue Dialog-ID setzen

	dOrdNo = getdouble("DLGORDNUMBERS." + new_dlg, "ROOT")
	if (dOrdNo > dCurrentMaxOrdNo)
		setdouble("MAXDLGORDNUMBER", "DLGDATA", dOrdNo)

	if ((new_dlg == "IDD_DATEN") and (current_dlg != new_dlg))
	{
		strSelTableRowID = getstring("SELSEARCHTABLE_ROW", "DLGDATA.DATEN")
		if (strSelTableRowID != "")
		{
			triggerevent("IDD_DATEN", "IDC_SEARCH_BUT")
			setstring ("SELSEARCHTABLE_ROW", "DLGDATA.DATEN", strSelTableRowID)
			triggerevent("IDD_DATEN", "IDC_SEARCH_TAB")
#				setstring ("SELSEARCHTABLE_ROW", "DLGDATA.DATEN", strSelTableRowID)
#				setstring ("SELSEARCHTABLE_ROW", "DLGDATA.DATEN", "")
			dFWAnz = getdouble("10001", "DLGDATA.SYSTEM")
			if (dFWAnz <= 2)
			{
				MAequiX = getstring("MAEQUI_MITDELTAZ.X.VALUE", "DLGDATA.DATEN_FW[0]")
				MAequiY = getstring("MAEQUI_MITDELTAZ.Y.VALUE", "DLGDATA.DATEN_FW[0]")
				MAequiZ = getstring("MAEQUI_MITDELTAZ.Z.VALUE", "DLGDATA.DATEN_FW[0]")
				if ((MAequiX != "") or (MAequiY != "") or (MAequiZ != "")) {
					bInitMomente = 0;
					setdouble("INIT_MOMENTE", "PRG", bInitMomente)
				};
			}
		}
		else
		{
			ClearResult()
		}
	}

	if (dOrdNo < dDatenOrdNo)
		setdouble("INIT_MOMENTE", "PRG", bInitMomente)
}

